/* PositionManager.c generated by valac 0.56.17, the Vala compiler
 * generated from PositionManager.vala, do not modify */

/**/
/*  Copyright (C) 2012 Robert Dyer, Rico Tzschichholz*/
/**/
/*  This file is part of Plank.*/
/**/
/*  Plank is free software: you can redistribute it and/or modify*/
/*  it under the terms of the GNU General Public License as published by*/
/*  the Free Software Foundation, either version 3 of the License, or*/
/*  (at your option) any later version.*/
/**/
/*  Plank is distributed in the hope that it will be useful,*/
/*  but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*  GNU General Public License for more details.*/
/**/
/*  You should have received a copy of the GNU General Public License*/
/*  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/**/

#include "plank.h"
#include <glib.h>
#include <gdk/gdk.h>
#include <gee.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include "plank-internal.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PLANK_POSITION_MANAGER_0_PROPERTY,
	PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY,
	PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY,
	PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY,
	PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_POSITION_PROPERTY,
	PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY,
	PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY,
	PLANK_POSITION_MANAGER_OFFSET_PROPERTY,
	PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY,
	PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY,
	PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY,
	PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY,
	PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY,
	PLANK_POSITION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* plank_position_manager_properties[PLANK_POSITION_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _plank_dock_item_draw_value_unref0(var) ((var == NULL) ? NULL : (var = (plank_dock_item_draw_value_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _PlankPositionManagerPrivate {
	PlankDockController* _controller;
	gboolean _screen_is_composited;
	GdkRectangle static_dock_region;
	GeeHashMap* draw_values;
	GdkRectangle monitor_geo;
	gint window_scale_factor;
	gint _LineWidth;
	gint _IconSize;
	gint _ZoomIconSize;
	GtkPositionType _Position;
	GtkAlign _Alignment;
	GtkAlign _ItemsAlignment;
	gint _Offset;
	gint _IndicatorSize;
	gint _IconShadowSize;
	gint _GlowSize;
	gint _HorizPadding;
	gint _TopPadding;
	gint _BottomPadding;
	gint _ItemPadding;
	gint _UrgentBounceHeight;
	gint _LaunchBounceHeight;
	gint items_width;
	gint items_offset;
	gint top_offset;
	gint bottom_offset;
	gint extra_hide_offset;
	gint win_x;
	gint win_y;
	gint VisibleDockHeight;
	gint DockHeight;
	gint DockBackgroundHeight;
	gint VisibleDockWidth;
	gint DockWidth;
	gint DockBackgroundWidth;
	gdouble ZoomPercent;
	GdkRectangle background_rect;
	gint _MaxItemCount;
	gint _MaxIconSize;
};

static gint PlankPositionManager_private_offset;
static gpointer plank_position_manager_parent_class = NULL;

static PlankDockController* plank_position_manager_get_controller (PlankPositionManager* self);
static void plank_position_manager_screen_changed (PlankPositionManager* self,
                                            GdkScreen* screen);
static void _plank_position_manager_screen_changed_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                         gpointer self);
static void _plank_position_manager_screen_changed_gdk_screen_size_changed (GdkScreen* _sender,
                                                                     gpointer self);
static void plank_position_manager_screen_composited_changed (PlankPositionManager* self,
                                                       GdkScreen* screen);
static void _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender,
                                                                                      gpointer self);
static void plank_position_manager_prefs_changed (PlankPositionManager* self,
                                           GObject* prefs,
                                           GParamSpec* prop);
static void _plank_position_manager_prefs_changed_g_object_notify (GObject* _sender,
                                                            GParamSpec* pspec,
                                                            gpointer self);
static gint plank_position_manager_find_monitor_number (GdkScreen* screen,
                                                 const gchar* plug_name);
static void plank_position_manager_set_screen_is_composited (PlankPositionManager* self,
                                                      gboolean value);
static void plank_position_manager_prefs_monitor_changed (PlankPositionManager* self);
static void plank_position_manager_update_dimensions (PlankPositionManager* self);
static void plank_position_manager_update_caches (PlankPositionManager* self,
                                           PlankDockTheme* theme);
static void plank_position_manager_update_max_icon_size (PlankPositionManager* self,
                                                  PlankDockTheme* theme);
static void plank_position_manager_set_Position (PlankPositionManager* self,
                                          GtkPositionType value);
static void plank_position_manager_set_Alignment (PlankPositionManager* self,
                                           GtkAlign value);
static void plank_position_manager_set_ItemsAlignment (PlankPositionManager* self,
                                                GtkAlign value);
static void plank_position_manager_set_Offset (PlankPositionManager* self,
                                        gint value);
static gint plank_position_manager_get_MaxIconSize (PlankPositionManager* self);
static void plank_position_manager_set_IconSize (PlankPositionManager* self,
                                          gint value);
static void plank_position_manager_set_ZoomIconSize (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_set_IconShadowSize (PlankPositionManager* self,
                                                gint value);
static void plank_position_manager_set_IndicatorSize (PlankPositionManager* self,
                                               gint value);
static void plank_position_manager_set_GlowSize (PlankPositionManager* self,
                                          gint value);
static void plank_position_manager_set_HorizPadding (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_set_TopPadding (PlankPositionManager* self,
                                            gint value);
static void plank_position_manager_set_BottomPadding (PlankPositionManager* self,
                                               gint value);
static void plank_position_manager_set_ItemPadding (PlankPositionManager* self,
                                             gint value);
static void plank_position_manager_set_UrgentBounceHeight (PlankPositionManager* self,
                                                    gint value);
static void plank_position_manager_set_LaunchBounceHeight (PlankPositionManager* self,
                                                    gint value);
static void plank_position_manager_set_LineWidth (PlankPositionManager* self,
                                           gint value);
static void plank_position_manager_set_MaxIconSize (PlankPositionManager* self,
                                             gint value);
static void plank_position_manager_set_MaxItemCount (PlankPositionManager* self,
                                              gint value);
static void plank_position_manager_update_background_region (PlankPositionManager* self,
                                                      PlankDockItemDrawValue* val_first,
                                                      PlankDockItemDrawValue* val_last);
static gboolean __lambda29_ (PlankPositionManager* self,
                      PlankDockElement* i,
                      PlankDockItemDrawValue* val);
static void plank_position_manager_get_item_draw_region (PlankPositionManager* self,
                                                  PlankDockItemDrawValue* val,
                                                  GdkRectangle* result);
static void plank_position_manager_get_item_hover_region (PlankPositionManager* self,
                                                   PlankDockItemDrawValue* val,
                                                   GdkRectangle* result);
static void plank_position_manager_get_item_background_region (PlankPositionManager* self,
                                                        PlankDockItemDrawValue* val,
                                                        GdkRectangle* result);
static gboolean ___lambda29__gee_forall_map_func (gconstpointer k,
                                           gconstpointer v,
                                           gpointer self);
static GObject * plank_position_manager_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static void plank_position_manager_finalize (GObject * obj);
static GType plank_position_manager_get_type_once (void);
static void _vala_plank_position_manager_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_plank_position_manager_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

static inline gpointer
plank_position_manager_get_instance_private (PlankPositionManager* self)
{
	return G_STRUCT_MEMBER_P (self, PlankPositionManager_private_offset);
}

static void
_plank_position_manager_screen_changed_gdk_screen_monitors_changed (GdkScreen* _sender,
                                                                    gpointer self)
{
#line 77 "../lib/PositionManager.vala"
	plank_position_manager_screen_changed ((PlankPositionManager*) self, _sender);
#line 231 "PositionManager.c"
}

static void
_plank_position_manager_screen_changed_gdk_screen_size_changed (GdkScreen* _sender,
                                                                gpointer self)
{
#line 78 "../lib/PositionManager.vala"
	plank_position_manager_screen_changed ((PlankPositionManager*) self, _sender);
#line 240 "PositionManager.c"
}

static void
_plank_position_manager_screen_composited_changed_gdk_screen_composited_changed (GdkScreen* _sender,
                                                                                 gpointer self)
{
#line 79 "../lib/PositionManager.vala"
	plank_position_manager_screen_composited_changed ((PlankPositionManager*) self, _sender);
#line 249 "PositionManager.c"
}

static void
_plank_position_manager_prefs_changed_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self)
{
#line 80 "../lib/PositionManager.vala"
	plank_position_manager_prefs_changed ((PlankPositionManager*) self, _sender, pspec);
#line 259 "PositionManager.c"
}

/**
 * Creates a new position manager.
 *
 * @param controller the dock controller to manage positions for
 */
PlankPositionManager*
plank_position_manager_construct (GType object_type,
                                  PlankDockController* controller)
{
	PlankPositionManager * self = NULL;
#line 43 "../lib/PositionManager.vala"
	g_return_val_if_fail (controller != NULL, NULL);
#line 45 "../lib/PositionManager.vala"
	self = (PlankPositionManager*) g_object_new (object_type, "controller", controller, NULL);
#line 43 "../lib/PositionManager.vala"
	return self;
#line 278 "PositionManager.c"
}

PlankPositionManager*
plank_position_manager_new (PlankDockController* controller)
{
#line 43 "../lib/PositionManager.vala"
	return plank_position_manager_construct (PLANK_TYPE_POSITION_MANAGER, controller);
#line 286 "PositionManager.c"
}

/**
 * Initializes the position manager.
 */
void
plank_position_manager_initialize (PlankPositionManager* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* screen = NULL;
	PlankDockController* _tmp3_;
	PlankDockWindow* _tmp4_;
	PlankDockWindow* _tmp5_;
	GdkScreen* _tmp6_;
	PlankDockController* _tmp7_;
	PlankDockPreferences* _tmp8_;
	PlankDockPreferences* _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GdkRectangle _tmp15_ = {0};
#line 57 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 57 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 57 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 57 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 57 "../lib/PositionManager.vala"
	_vala_return_if_fail (_tmp2_ != NULL, "controller.window != null");
#line 60 "../lib/PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 60 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_window (_tmp3_);
#line 60 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 60 "../lib/PositionManager.vala"
	_tmp6_ = gtk_window_get_screen ((GtkWindow*) _tmp5_);
#line 60 "../lib/PositionManager.vala"
	screen = _tmp6_;
#line 62 "../lib/PositionManager.vala"
	_tmp7_ = self->priv->_controller;
#line 62 "../lib/PositionManager.vala"
	_tmp8_ = plank_dock_controller_get_prefs (_tmp7_);
#line 62 "../lib/PositionManager.vala"
	_tmp9_ = _tmp8_;
#line 62 "../lib/PositionManager.vala"
	g_signal_connect_object ((GObject*) _tmp9_, "notify", (GCallback) _plank_position_manager_prefs_changed_g_object_notify, self, 0);
#line 63 "../lib/PositionManager.vala"
	g_signal_connect_object (screen, "monitors-changed", (GCallback) _plank_position_manager_screen_changed_gdk_screen_monitors_changed, self, 0);
#line 64 "../lib/PositionManager.vala"
	g_signal_connect_object (screen, "size-changed", (GCallback) _plank_position_manager_screen_changed_gdk_screen_size_changed, self, 0);
#line 65 "../lib/PositionManager.vala"
	g_signal_connect_object (screen, "composited-changed", (GCallback) _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed, self, 0);
#line 68 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 68 "../lib/PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 68 "../lib/PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 68 "../lib/PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_Monitor (_tmp12_);
#line 68 "../lib/PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 68 "../lib/PositionManager.vala"
	gdk_screen_get_monitor_geometry (screen, plank_position_manager_find_monitor_number (screen, _tmp14_), &_tmp15_);
#line 68 "../lib/PositionManager.vala"
	self->priv->monitor_geo = _tmp15_;
#line 70 "../lib/PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (screen));
#line 362 "PositionManager.c"
}

static void
plank_position_manager_prefs_changed (PlankPositionManager* self,
                                      GObject* prefs,
                                      GParamSpec* prop)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 87 "../lib/PositionManager.vala"
	static GQuark _tmp2_label0 = 0;
#line 85 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 85 "../lib/PositionManager.vala"
	g_return_if_fail (prefs != NULL);
#line 85 "../lib/PositionManager.vala"
	g_return_if_fail (prop != NULL);
#line 87 "../lib/PositionManager.vala"
	_tmp0_ = prop->name;
#line 87 "../lib/PositionManager.vala"
	_tmp1_ = _tmp0_;
#line 87 "../lib/PositionManager.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 87 "../lib/PositionManager.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("Monitor")))) {
#line 87 "../lib/PositionManager.vala"
		switch (0) {
#line 391 "PositionManager.c"
			default:
			{
#line 89 "../lib/PositionManager.vala"
				plank_position_manager_prefs_monitor_changed (self);
#line 90 "../lib/PositionManager.vala"
				break;
#line 398 "PositionManager.c"
			}
		}
	} else {
#line 87 "../lib/PositionManager.vala"
		switch (0) {
#line 404 "PositionManager.c"
			default:
			{
#line 93 "../lib/PositionManager.vala"
				break;
#line 409 "PositionManager.c"
			}
		}
	}
}

gchar**
plank_position_manager_get_monitor_plug_names (GdkScreen* screen,
                                               gint* result_length1)
{
	gint n_monitors = 0;
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result;
#line 97 "../lib/PositionManager.vala"
	g_return_val_if_fail (screen != NULL, NULL);
#line 99 "../lib/PositionManager.vala"
	n_monitors = gdk_screen_get_n_monitors (screen);
#line 100 "../lib/PositionManager.vala"
	_tmp0_ = g_new0 (gchar*, n_monitors + 1);
#line 100 "../lib/PositionManager.vala"
	_result_ = _tmp0_;
#line 100 "../lib/PositionManager.vala"
	_result__length1 = n_monitors;
#line 100 "../lib/PositionManager.vala"
	__result__size_ = _result__length1;
#line 439 "PositionManager.c"
	{
		gint i = 0;
#line 102 "../lib/PositionManager.vala"
		i = 0;
#line 444 "PositionManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 102 "../lib/PositionManager.vala"
			_tmp1_ = TRUE;
#line 102 "../lib/PositionManager.vala"
			while (TRUE) {
#line 451 "PositionManager.c"
				gchar* _tmp3_ = NULL;
				gchar* _tmp4_;
				gchar** _tmp6_;
				gint _tmp6__length1;
				gchar* _tmp7_;
#line 102 "../lib/PositionManager.vala"
				if (!_tmp1_) {
#line 459 "PositionManager.c"
					gint _tmp2_;
#line 102 "../lib/PositionManager.vala"
					_tmp2_ = i;
#line 102 "../lib/PositionManager.vala"
					i = _tmp2_ + 1;
#line 465 "PositionManager.c"
				}
#line 102 "../lib/PositionManager.vala"
				_tmp1_ = FALSE;
#line 102 "../lib/PositionManager.vala"
				if (!(i < n_monitors)) {
#line 102 "../lib/PositionManager.vala"
					break;
#line 473 "PositionManager.c"
				}
#line 103 "../lib/PositionManager.vala"
				_tmp4_ = gdk_screen_get_monitor_plug_name (screen, i);
#line 103 "../lib/PositionManager.vala"
				_tmp3_ = _tmp4_;
#line 103 "../lib/PositionManager.vala"
				if (_tmp3_ == NULL) {
#line 481 "PositionManager.c"
					gchar* _tmp5_;
#line 103 "../lib/PositionManager.vala"
					_tmp5_ = g_strdup_printf ("PLUG_MONITOR_%i", i);
#line 103 "../lib/PositionManager.vala"
					_g_free0 (_tmp3_);
#line 103 "../lib/PositionManager.vala"
					_tmp3_ = _tmp5_;
#line 489 "PositionManager.c"
				}
#line 103 "../lib/PositionManager.vala"
				_tmp6_ = _result_;
#line 103 "../lib/PositionManager.vala"
				_tmp6__length1 = _result__length1;
#line 103 "../lib/PositionManager.vala"
				_tmp7_ = _tmp3_;
#line 103 "../lib/PositionManager.vala"
				_tmp3_ = NULL;
#line 103 "../lib/PositionManager.vala"
				_g_free0 (_tmp6_[i]);
#line 103 "../lib/PositionManager.vala"
				_tmp6_[i] = _tmp7_;
#line 102 "../lib/PositionManager.vala"
				_g_free0 (_tmp3_);
#line 505 "PositionManager.c"
			}
		}
	}
#line 105 "../lib/PositionManager.vala"
	_tmp8_ = _result_;
#line 105 "../lib/PositionManager.vala"
	_tmp8__length1 = _result__length1;
#line 105 "../lib/PositionManager.vala"
	if (result_length1) {
#line 105 "../lib/PositionManager.vala"
		*result_length1 = _tmp8__length1;
#line 517 "PositionManager.c"
	}
#line 105 "../lib/PositionManager.vala"
	result = _tmp8_;
#line 105 "../lib/PositionManager.vala"
	return result;
#line 523 "PositionManager.c"
}

static gint
plank_position_manager_find_monitor_number (GdkScreen* screen,
                                            const gchar* plug_name)
{
	gint n_monitors = 0;
	gint result;
#line 108 "../lib/PositionManager.vala"
	g_return_val_if_fail (screen != NULL, 0);
#line 108 "../lib/PositionManager.vala"
	g_return_val_if_fail (plug_name != NULL, 0);
#line 110 "../lib/PositionManager.vala"
	if (g_strcmp0 (plug_name, "") == 0) {
#line 111 "../lib/PositionManager.vala"
		result = gdk_screen_get_primary_monitor (screen);
#line 111 "../lib/PositionManager.vala"
		return result;
#line 542 "PositionManager.c"
	}
#line 113 "../lib/PositionManager.vala"
	n_monitors = gdk_screen_get_n_monitors (screen);
#line 546 "PositionManager.c"
	{
		gint i = 0;
#line 115 "../lib/PositionManager.vala"
		i = 0;
#line 551 "PositionManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 115 "../lib/PositionManager.vala"
			_tmp0_ = TRUE;
#line 115 "../lib/PositionManager.vala"
			while (TRUE) {
#line 558 "PositionManager.c"
				gchar* _tmp2_ = NULL;
				gchar* _tmp3_;
				gchar* name = NULL;
				gchar* _tmp5_;
				const gchar* _tmp6_;
#line 115 "../lib/PositionManager.vala"
				if (!_tmp0_) {
#line 566 "PositionManager.c"
					gint _tmp1_;
#line 115 "../lib/PositionManager.vala"
					_tmp1_ = i;
#line 115 "../lib/PositionManager.vala"
					i = _tmp1_ + 1;
#line 572 "PositionManager.c"
				}
#line 115 "../lib/PositionManager.vala"
				_tmp0_ = FALSE;
#line 115 "../lib/PositionManager.vala"
				if (!(i < n_monitors)) {
#line 115 "../lib/PositionManager.vala"
					break;
#line 580 "PositionManager.c"
				}
#line 116 "../lib/PositionManager.vala"
				_tmp3_ = gdk_screen_get_monitor_plug_name (screen, i);
#line 116 "../lib/PositionManager.vala"
				_tmp2_ = _tmp3_;
#line 116 "../lib/PositionManager.vala"
				if (_tmp2_ == NULL) {
#line 588 "PositionManager.c"
					gchar* _tmp4_;
#line 116 "../lib/PositionManager.vala"
					_tmp4_ = g_strdup_printf ("PLUG_MONITOR_%i", i);
#line 116 "../lib/PositionManager.vala"
					_g_free0 (_tmp2_);
#line 116 "../lib/PositionManager.vala"
					_tmp2_ = _tmp4_;
#line 596 "PositionManager.c"
				}
#line 116 "../lib/PositionManager.vala"
				_tmp5_ = _tmp2_;
#line 116 "../lib/PositionManager.vala"
				_tmp2_ = NULL;
#line 116 "../lib/PositionManager.vala"
				name = _tmp5_;
#line 117 "../lib/PositionManager.vala"
				_tmp6_ = name;
#line 117 "../lib/PositionManager.vala"
				if (g_strcmp0 (plug_name, _tmp6_) == 0) {
#line 118 "../lib/PositionManager.vala"
					result = i;
#line 118 "../lib/PositionManager.vala"
					_g_free0 (name);
#line 118 "../lib/PositionManager.vala"
					_g_free0 (_tmp2_);
#line 118 "../lib/PositionManager.vala"
					return result;
#line 616 "PositionManager.c"
				}
#line 115 "../lib/PositionManager.vala"
				_g_free0 (name);
#line 115 "../lib/PositionManager.vala"
				_g_free0 (_tmp2_);
#line 622 "PositionManager.c"
			}
		}
	}
#line 121 "../lib/PositionManager.vala"
	result = gdk_screen_get_primary_monitor (screen);
#line 121 "../lib/PositionManager.vala"
	return result;
#line 630 "PositionManager.c"
}

static void
plank_position_manager_prefs_monitor_changed (PlankPositionManager* self)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
#line 124 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 126 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 126 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 126 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 126 "../lib/PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 126 "../lib/PositionManager.vala"
	plank_position_manager_screen_changed (self, _tmp3_);
#line 652 "PositionManager.c"
}

static void
plank_position_manager_screen_changed (PlankPositionManager* self,
                                       GdkScreen* screen)
{
	GdkRectangle old_monitor_geo = {0};
	GdkRectangle _tmp0_;
	PlankDockController* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GdkRectangle _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	GdkRectangle _tmp10_;
	GdkRectangle _tmp11_;
	GdkRectangle _tmp18_;
	GdkRectangle _tmp19_;
	GdkRectangle _tmp20_;
	GdkRectangle _tmp21_;
#line 129 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 129 "../lib/PositionManager.vala"
	g_return_if_fail (screen != NULL);
#line 131 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->monitor_geo;
#line 131 "../lib/PositionManager.vala"
	old_monitor_geo = _tmp0_;
#line 133 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 133 "../lib/PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_prefs (_tmp1_);
#line 133 "../lib/PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 133 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_preferences_get_Monitor (_tmp3_);
#line 133 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 133 "../lib/PositionManager.vala"
	gdk_screen_get_monitor_geometry (screen, plank_position_manager_find_monitor_number (screen, _tmp5_), &_tmp6_);
#line 133 "../lib/PositionManager.vala"
	self->priv->monitor_geo = _tmp6_;
#line 136 "../lib/PositionManager.vala"
	_tmp10_ = old_monitor_geo;
#line 136 "../lib/PositionManager.vala"
	_tmp11_ = self->priv->monitor_geo;
#line 136 "../lib/PositionManager.vala"
	if (_tmp10_.x == _tmp11_.x) {
#line 704 "PositionManager.c"
		GdkRectangle _tmp12_;
		GdkRectangle _tmp13_;
#line 137 "../lib/PositionManager.vala"
		_tmp12_ = old_monitor_geo;
#line 137 "../lib/PositionManager.vala"
		_tmp13_ = self->priv->monitor_geo;
#line 137 "../lib/PositionManager.vala"
		_tmp9_ = _tmp12_.y == _tmp13_.y;
#line 713 "PositionManager.c"
	} else {
#line 136 "../lib/PositionManager.vala"
		_tmp9_ = FALSE;
#line 717 "PositionManager.c"
	}
#line 136 "../lib/PositionManager.vala"
	if (_tmp9_) {
#line 721 "PositionManager.c"
		GdkRectangle _tmp14_;
		GdkRectangle _tmp15_;
#line 138 "../lib/PositionManager.vala"
		_tmp14_ = old_monitor_geo;
#line 138 "../lib/PositionManager.vala"
		_tmp15_ = self->priv->monitor_geo;
#line 138 "../lib/PositionManager.vala"
		_tmp8_ = _tmp14_.width == _tmp15_.width;
#line 730 "PositionManager.c"
	} else {
#line 136 "../lib/PositionManager.vala"
		_tmp8_ = FALSE;
#line 734 "PositionManager.c"
	}
#line 136 "../lib/PositionManager.vala"
	if (_tmp8_) {
#line 738 "PositionManager.c"
		GdkRectangle _tmp16_;
		GdkRectangle _tmp17_;
#line 139 "../lib/PositionManager.vala"
		_tmp16_ = old_monitor_geo;
#line 139 "../lib/PositionManager.vala"
		_tmp17_ = self->priv->monitor_geo;
#line 139 "../lib/PositionManager.vala"
		_tmp7_ = _tmp16_.height == _tmp17_.height;
#line 747 "PositionManager.c"
	} else {
#line 136 "../lib/PositionManager.vala"
		_tmp7_ = FALSE;
#line 751 "PositionManager.c"
	}
#line 136 "../lib/PositionManager.vala"
	if (_tmp7_) {
#line 140 "../lib/PositionManager.vala"
		return;
#line 757 "PositionManager.c"
	}
#line 142 "../lib/PositionManager.vala"
	_tmp18_ = self->priv->monitor_geo;
#line 142 "../lib/PositionManager.vala"
	_tmp19_ = self->priv->monitor_geo;
#line 142 "../lib/PositionManager.vala"
	_tmp20_ = self->priv->monitor_geo;
#line 142 "../lib/PositionManager.vala"
	_tmp21_ = self->priv->monitor_geo;
#line 142 "../lib/PositionManager.vala"
	plank_logger_verbose ("PositionManager.monitor_geo_changed (%i,%i-%ix%i)", _tmp18_.x, _tmp19_.y, _tmp20_.width, _tmp21_.height, NULL);
#line 145 "../lib/PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 147 "../lib/PositionManager.vala"
	plank_position_manager_update_dimensions (self);
#line 148 "../lib/PositionManager.vala"
	plank_position_manager_update_regions (self);
#line 150 "../lib/PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 777 "PositionManager.c"
}

static void
plank_position_manager_screen_composited_changed (PlankPositionManager* self,
                                                  GdkScreen* screen)
{
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockTheme* _tmp3_;
	PlankDockTheme* _tmp4_;
#line 153 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 153 "../lib/PositionManager.vala"
	g_return_if_fail (screen != NULL);
#line 155 "../lib/PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 157 "../lib/PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (screen));
#line 159 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 159 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 159 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 159 "../lib/PositionManager.vala"
	_tmp3_ = plank_dock_renderer_get_theme (_tmp2_);
#line 159 "../lib/PositionManager.vala"
	_tmp4_ = _tmp3_;
#line 159 "../lib/PositionManager.vala"
	plank_position_manager_update (self, _tmp4_);
#line 161 "../lib/PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 811 "PositionManager.c"
}

/**
 * Updates all internal caches.
 *
 * @param theme the current dock theme
 */
void
plank_position_manager_update (PlankPositionManager* self,
                               PlankDockTheme* theme)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
#line 302 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 302 "../lib/PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 304 "../lib/PositionManager.vala"
	plank_logger_verbose ("PositionManager.update ()", NULL);
#line 306 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 306 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 306 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 306 "../lib/PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 306 "../lib/PositionManager.vala"
	plank_position_manager_set_screen_is_composited (self, gdk_screen_is_composited (_tmp3_));
#line 308 "../lib/PositionManager.vala"
	g_object_freeze_notify ((GObject*) self);
#line 310 "../lib/PositionManager.vala"
	plank_position_manager_update_caches (self, theme);
#line 311 "../lib/PositionManager.vala"
	plank_position_manager_update_max_icon_size (self, theme);
#line 312 "../lib/PositionManager.vala"
	plank_position_manager_update_dimensions (self);
#line 313 "../lib/PositionManager.vala"
	plank_position_manager_update_regions (self);
#line 315 "../lib/PositionManager.vala"
	g_object_thaw_notify ((GObject*) self);
#line 855 "PositionManager.c"
}

static void
plank_position_manager_update_caches (PlankPositionManager* self,
                                      PlankDockTheme* theme)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockPreferences* _tmp3_;
	GtkPositionType _tmp4_;
	GtkPositionType _tmp5_;
	PlankDockPreferences* _tmp6_;
	GtkAlign _tmp7_;
	GtkAlign _tmp8_;
	PlankDockPreferences* _tmp9_;
	GtkAlign _tmp10_;
	GtkAlign _tmp11_;
	PlankDockPreferences* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp21_;
	PlankDockPreferences* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gdouble scaled_icon_size = 0.0;
	gint _tmp26_;
	gdouble _tmp27_;
	gdouble _tmp28_;
	gdouble _tmp29_;
	gdouble _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	gdouble _tmp36_;
	gdouble _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gint _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	gint _tmp46_;
	gint _tmp47_;
	gint _tmp48_;
	gboolean _tmp49_;
	gint _tmp52_ = 0;
	gint _tmp53_;
	gint _tmp55_;
	gint _tmp56_;
	gint _tmp57_;
#line 318 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 318 "../lib/PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 320 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 320 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 320 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 320 "../lib/PositionManager.vala"
	prefs = _tmp2_;
#line 322 "../lib/PositionManager.vala"
	_tmp3_ = prefs;
#line 322 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_preferences_get_Position (_tmp3_);
#line 322 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 322 "../lib/PositionManager.vala"
	plank_position_manager_set_Position (self, _tmp5_);
#line 323 "../lib/PositionManager.vala"
	_tmp6_ = prefs;
#line 323 "../lib/PositionManager.vala"
	_tmp7_ = plank_dock_preferences_get_Alignment (_tmp6_);
#line 323 "../lib/PositionManager.vala"
	_tmp8_ = _tmp7_;
#line 323 "../lib/PositionManager.vala"
	plank_position_manager_set_Alignment (self, _tmp8_);
#line 324 "../lib/PositionManager.vala"
	_tmp9_ = prefs;
#line 324 "../lib/PositionManager.vala"
	_tmp10_ = plank_dock_preferences_get_ItemsAlignment (_tmp9_);
#line 324 "../lib/PositionManager.vala"
	_tmp11_ = _tmp10_;
#line 324 "../lib/PositionManager.vala"
	plank_position_manager_set_ItemsAlignment (self, _tmp11_);
#line 325 "../lib/PositionManager.vala"
	_tmp12_ = prefs;
#line 325 "../lib/PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_Offset (_tmp12_);
#line 325 "../lib/PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 325 "../lib/PositionManager.vala"
	plank_position_manager_set_Offset (self, _tmp14_);
#line 328 "../lib/PositionManager.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 329 "../lib/PositionManager.vala"
		if (plank_position_manager_is_horizontal_dock (self)) {
#line 961 "PositionManager.c"
			GtkAlign _tmp15_;
			GtkAlign _tmp17_;
			gint _tmp19_;
#line 330 "../lib/PositionManager.vala"
			_tmp15_ = self->priv->_Alignment;
#line 330 "../lib/PositionManager.vala"
			if (_tmp15_ == GTK_ALIGN_START) {
#line 331 "../lib/PositionManager.vala"
				plank_position_manager_set_Alignment (self, GTK_ALIGN_END);
#line 971 "PositionManager.c"
			} else {
				GtkAlign _tmp16_;
#line 332 "../lib/PositionManager.vala"
				_tmp16_ = self->priv->_Alignment;
#line 332 "../lib/PositionManager.vala"
				if (_tmp16_ == GTK_ALIGN_END) {
#line 333 "../lib/PositionManager.vala"
					plank_position_manager_set_Alignment (self, GTK_ALIGN_START);
#line 980 "PositionManager.c"
				}
			}
#line 335 "../lib/PositionManager.vala"
			_tmp17_ = self->priv->_ItemsAlignment;
#line 335 "../lib/PositionManager.vala"
			if (_tmp17_ == GTK_ALIGN_START) {
#line 336 "../lib/PositionManager.vala"
				plank_position_manager_set_ItemsAlignment (self, GTK_ALIGN_END);
#line 989 "PositionManager.c"
			} else {
				GtkAlign _tmp18_;
#line 337 "../lib/PositionManager.vala"
				_tmp18_ = self->priv->_ItemsAlignment;
#line 337 "../lib/PositionManager.vala"
				if (_tmp18_ == GTK_ALIGN_END) {
#line 338 "../lib/PositionManager.vala"
					plank_position_manager_set_ItemsAlignment (self, GTK_ALIGN_START);
#line 998 "PositionManager.c"
				}
			}
#line 340 "../lib/PositionManager.vala"
			_tmp19_ = self->priv->_Offset;
#line 340 "../lib/PositionManager.vala"
			plank_position_manager_set_Offset (self, -_tmp19_);
#line 1005 "PositionManager.c"
		} else {
			GtkPositionType _tmp20_;
#line 342 "../lib/PositionManager.vala"
			_tmp20_ = self->priv->_Position;
#line 342 "../lib/PositionManager.vala"
			if (_tmp20_ == GTK_POS_RIGHT) {
#line 343 "../lib/PositionManager.vala"
				plank_position_manager_set_Position (self, GTK_POS_LEFT);
#line 1014 "PositionManager.c"
			} else {
#line 345 "../lib/PositionManager.vala"
				plank_position_manager_set_Position (self, GTK_POS_RIGHT);
#line 1018 "PositionManager.c"
			}
		}
	}
#line 349 "../lib/PositionManager.vala"
	_tmp21_ = self->priv->_MaxIconSize;
#line 349 "../lib/PositionManager.vala"
	_tmp22_ = prefs;
#line 349 "../lib/PositionManager.vala"
	_tmp23_ = plank_dock_preferences_get_IconSize (_tmp22_);
#line 349 "../lib/PositionManager.vala"
	_tmp24_ = _tmp23_;
#line 349 "../lib/PositionManager.vala"
	plank_position_manager_set_IconSize (self, MIN (_tmp21_, _tmp24_));
#line 350 "../lib/PositionManager.vala"
	self->priv->ZoomPercent = 1.0;
#line 351 "../lib/PositionManager.vala"
	_tmp25_ = self->priv->_IconSize;
#line 351 "../lib/PositionManager.vala"
	plank_position_manager_set_ZoomIconSize (self, _tmp25_);
#line 353 "../lib/PositionManager.vala"
	_tmp26_ = self->priv->_IconSize;
#line 353 "../lib/PositionManager.vala"
	scaled_icon_size = _tmp26_ / 10.0;
#line 355 "../lib/PositionManager.vala"
	_tmp27_ = plank_dock_theme_get_IconShadowSize (theme);
#line 355 "../lib/PositionManager.vala"
	_tmp28_ = _tmp27_;
#line 355 "../lib/PositionManager.vala"
	plank_position_manager_set_IconShadowSize (self, (gint) ceil (_tmp28_ * scaled_icon_size));
#line 356 "../lib/PositionManager.vala"
	_tmp29_ = plank_dock_theme_get_IndicatorSize (theme);
#line 356 "../lib/PositionManager.vala"
	_tmp30_ = _tmp29_;
#line 356 "../lib/PositionManager.vala"
	plank_position_manager_set_IndicatorSize (self, (gint) (_tmp30_ * scaled_icon_size));
#line 357 "../lib/PositionManager.vala"
	_tmp31_ = plank_dock_theme_get_GlowSize (theme);
#line 357 "../lib/PositionManager.vala"
	_tmp32_ = _tmp31_;
#line 357 "../lib/PositionManager.vala"
	plank_position_manager_set_GlowSize (self, (gint) (_tmp32_ * scaled_icon_size));
#line 358 "../lib/PositionManager.vala"
	_tmp33_ = plank_dock_theme_get_HorizPadding (theme);
#line 358 "../lib/PositionManager.vala"
	_tmp34_ = _tmp33_;
#line 358 "../lib/PositionManager.vala"
	plank_position_manager_set_HorizPadding (self, (gint) (_tmp34_ * scaled_icon_size));
#line 359 "../lib/PositionManager.vala"
	_tmp35_ = plank_dock_theme_get_TopPadding (theme);
#line 359 "../lib/PositionManager.vala"
	_tmp36_ = _tmp35_;
#line 359 "../lib/PositionManager.vala"
	plank_position_manager_set_TopPadding (self, (gint) (_tmp36_ * scaled_icon_size));
#line 360 "../lib/PositionManager.vala"
	_tmp37_ = plank_dock_theme_get_BottomPadding (theme);
#line 360 "../lib/PositionManager.vala"
	_tmp38_ = _tmp37_;
#line 360 "../lib/PositionManager.vala"
	plank_position_manager_set_BottomPadding (self, (gint) (_tmp38_ * scaled_icon_size));
#line 361 "../lib/PositionManager.vala"
	_tmp39_ = plank_dock_theme_get_ItemPadding (theme);
#line 361 "../lib/PositionManager.vala"
	_tmp40_ = _tmp39_;
#line 361 "../lib/PositionManager.vala"
	plank_position_manager_set_ItemPadding (self, (gint) (_tmp40_ * scaled_icon_size));
#line 362 "../lib/PositionManager.vala"
	_tmp41_ = plank_dock_theme_get_UrgentBounceHeight (theme);
#line 362 "../lib/PositionManager.vala"
	_tmp42_ = _tmp41_;
#line 362 "../lib/PositionManager.vala"
	_tmp43_ = self->priv->_IconSize;
#line 362 "../lib/PositionManager.vala"
	plank_position_manager_set_UrgentBounceHeight (self, (gint) (_tmp42_ * _tmp43_));
#line 363 "../lib/PositionManager.vala"
	_tmp44_ = plank_dock_theme_get_LaunchBounceHeight (theme);
#line 363 "../lib/PositionManager.vala"
	_tmp45_ = _tmp44_;
#line 363 "../lib/PositionManager.vala"
	_tmp46_ = self->priv->_IconSize;
#line 363 "../lib/PositionManager.vala"
	plank_position_manager_set_LaunchBounceHeight (self, (gint) (_tmp45_ * _tmp46_));
#line 364 "../lib/PositionManager.vala"
	_tmp47_ = plank_theme_get_LineWidth ((PlankTheme*) theme);
#line 364 "../lib/PositionManager.vala"
	_tmp48_ = _tmp47_;
#line 364 "../lib/PositionManager.vala"
	plank_position_manager_set_LineWidth (self, _tmp48_);
#line 366 "../lib/PositionManager.vala"
	_tmp49_ = self->priv->_screen_is_composited;
#line 366 "../lib/PositionManager.vala"
	if (!_tmp49_) {
#line 1110 "PositionManager.c"
		gint _tmp50_;
		gint _tmp51_;
#line 367 "../lib/PositionManager.vala"
		_tmp50_ = self->priv->_HorizPadding;
#line 367 "../lib/PositionManager.vala"
		if (_tmp50_ < 0) {
#line 368 "../lib/PositionManager.vala"
			plank_position_manager_set_HorizPadding (self, (gint) scaled_icon_size);
#line 1119 "PositionManager.c"
		}
#line 369 "../lib/PositionManager.vala"
		_tmp51_ = self->priv->_TopPadding;
#line 369 "../lib/PositionManager.vala"
		if (_tmp51_ < 0) {
#line 370 "../lib/PositionManager.vala"
			plank_position_manager_set_TopPadding (self, (gint) scaled_icon_size);
#line 1127 "PositionManager.c"
		}
	}
#line 373 "../lib/PositionManager.vala"
	_tmp53_ = self->priv->_HorizPadding;
#line 373 "../lib/PositionManager.vala"
	if (_tmp53_ > 0) {
#line 1134 "PositionManager.c"
		gint _tmp54_;
#line 373 "../lib/PositionManager.vala"
		_tmp54_ = self->priv->_HorizPadding;
#line 373 "../lib/PositionManager.vala"
		_tmp52_ = _tmp54_;
#line 1140 "PositionManager.c"
	} else {
#line 373 "../lib/PositionManager.vala"
		_tmp52_ = 0;
#line 1144 "PositionManager.c"
	}
#line 373 "../lib/PositionManager.vala"
	_tmp55_ = self->priv->_LineWidth;
#line 373 "../lib/PositionManager.vala"
	self->priv->items_offset = (gint) ((2 * _tmp55_) + _tmp52_);
#line 375 "../lib/PositionManager.vala"
	_tmp56_ = self->priv->_TopPadding;
#line 375 "../lib/PositionManager.vala"
	self->priv->top_offset = plank_theme_get_top_offset ((PlankTheme*) theme) + _tmp56_;
#line 376 "../lib/PositionManager.vala"
	_tmp57_ = self->priv->_BottomPadding;
#line 376 "../lib/PositionManager.vala"
	self->priv->bottom_offset = plank_theme_get_bottom_offset ((PlankTheme*) theme) + _tmp57_;
#line 378 "../lib/PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 1160 "PositionManager.c"
		gint _tmp58_;
#line 379 "../lib/PositionManager.vala"
		_tmp58_ = self->priv->_IconShadowSize;
#line 379 "../lib/PositionManager.vala"
		self->priv->extra_hide_offset = _tmp58_;
#line 1166 "PositionManager.c"
	} else {
		gint _tmp59_;
#line 380 "../lib/PositionManager.vala"
		_tmp59_ = self->priv->_IconShadowSize;
#line 380 "../lib/PositionManager.vala"
		if (self->priv->top_offset < _tmp59_) {
#line 1173 "PositionManager.c"
			gint _tmp60_;
#line 381 "../lib/PositionManager.vala"
			_tmp60_ = self->priv->_IconShadowSize;
#line 381 "../lib/PositionManager.vala"
			self->priv->extra_hide_offset = _tmp60_ - self->priv->top_offset;
#line 1179 "PositionManager.c"
		} else {
#line 383 "../lib/PositionManager.vala"
			self->priv->extra_hide_offset = 0;
#line 1183 "PositionManager.c"
		}
	}
}

/**
 * Find an appropriate MaxIconSize
 */
static void
plank_position_manager_update_max_icon_size (PlankPositionManager* self,
                                             PlankDockTheme* theme)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	gint item_count = 0;
	PlankDockController* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeArrayList* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint width = 0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_ = 0;
	gint max_width = 0;
	gint step_size = 0;
	gboolean _tmp15_ = FALSE;
#line 389 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 389 "../lib/PositionManager.vala"
	g_return_if_fail (theme != NULL);
#line 391 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 391 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 391 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 391 "../lib/PositionManager.vala"
	prefs = _tmp2_;
#line 394 "../lib/PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 394 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_VisibleItems (_tmp3_);
#line 394 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 394 "../lib/PositionManager.vala"
	_tmp6_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp5_);
#line 394 "../lib/PositionManager.vala"
	_tmp7_ = _tmp6_;
#line 394 "../lib/PositionManager.vala"
	item_count = _tmp7_;
#line 395 "../lib/PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 395 "../lib/PositionManager.vala"
	_tmp9_ = self->priv->_IconSize;
#line 395 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_HorizPadding;
#line 395 "../lib/PositionManager.vala"
	_tmp11_ = self->priv->_LineWidth;
#line 395 "../lib/PositionManager.vala"
	width = ((item_count * (_tmp8_ + _tmp9_)) + (2 * _tmp10_)) + (4 * _tmp11_);
#line 396 "../lib/PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 1250 "PositionManager.c"
		GdkRectangle _tmp13_;
#line 396 "../lib/PositionManager.vala"
		_tmp13_ = self->priv->monitor_geo;
#line 396 "../lib/PositionManager.vala"
		_tmp12_ = _tmp13_.width;
#line 1256 "PositionManager.c"
	} else {
		GdkRectangle _tmp14_;
#line 396 "../lib/PositionManager.vala"
		_tmp14_ = self->priv->monitor_geo;
#line 396 "../lib/PositionManager.vala"
		_tmp12_ = _tmp14_.height;
#line 1263 "PositionManager.c"
	}
#line 396 "../lib/PositionManager.vala"
	max_width = _tmp12_;
#line 397 "../lib/PositionManager.vala"
	step_size = MAX (1, (gint) (fabs ((gdouble) (width - max_width)) / item_count));
#line 399 "../lib/PositionManager.vala"
	if (width > max_width) {
#line 1271 "PositionManager.c"
		gint _tmp16_;
#line 399 "../lib/PositionManager.vala"
		_tmp16_ = self->priv->_MaxIconSize;
#line 399 "../lib/PositionManager.vala"
		_tmp15_ = _tmp16_ > PLANK_DOCK_PREFERENCES_MIN_ICON_SIZE;
#line 1277 "PositionManager.c"
	} else {
#line 399 "../lib/PositionManager.vala"
		_tmp15_ = FALSE;
#line 1281 "PositionManager.c"
	}
#line 399 "../lib/PositionManager.vala"
	if (_tmp15_) {
#line 1285 "PositionManager.c"
		gint _tmp17_;
#line 400 "../lib/PositionManager.vala"
		_tmp17_ = self->priv->_MaxIconSize;
#line 400 "../lib/PositionManager.vala"
		plank_position_manager_set_MaxIconSize (self, _tmp17_ - step_size);
#line 1291 "PositionManager.c"
	} else {
		gboolean _tmp18_ = FALSE;
		gboolean _tmp19_ = FALSE;
#line 401 "../lib/PositionManager.vala"
		if (width < max_width) {
#line 1297 "PositionManager.c"
			gint _tmp20_;
			PlankDockPreferences* _tmp21_;
			gint _tmp22_;
			gint _tmp23_;
#line 401 "../lib/PositionManager.vala"
			_tmp20_ = self->priv->_MaxIconSize;
#line 401 "../lib/PositionManager.vala"
			_tmp21_ = prefs;
#line 401 "../lib/PositionManager.vala"
			_tmp22_ = plank_dock_preferences_get_IconSize (_tmp21_);
#line 401 "../lib/PositionManager.vala"
			_tmp23_ = _tmp22_;
#line 401 "../lib/PositionManager.vala"
			_tmp19_ = _tmp20_ < _tmp23_;
#line 1312 "PositionManager.c"
		} else {
#line 401 "../lib/PositionManager.vala"
			_tmp19_ = FALSE;
#line 1316 "PositionManager.c"
		}
#line 401 "../lib/PositionManager.vala"
		if (_tmp19_) {
#line 401 "../lib/PositionManager.vala"
			_tmp18_ = step_size > 1;
#line 1322 "PositionManager.c"
		} else {
#line 401 "../lib/PositionManager.vala"
			_tmp18_ = FALSE;
#line 1326 "PositionManager.c"
		}
#line 401 "../lib/PositionManager.vala"
		if (_tmp18_) {
#line 1330 "PositionManager.c"
			gint _tmp24_;
#line 402 "../lib/PositionManager.vala"
			_tmp24_ = self->priv->_MaxIconSize;
#line 402 "../lib/PositionManager.vala"
			plank_position_manager_set_MaxIconSize (self, _tmp24_ + step_size);
#line 1336 "PositionManager.c"
		} else {
			gint _tmp25_;
			gint _tmp26_;
#line 405 "../lib/PositionManager.vala"
			_tmp25_ = self->priv->_MaxIconSize;
#line 405 "../lib/PositionManager.vala"
			plank_position_manager_set_MaxIconSize (self, MAX (PLANK_DOCK_PREFERENCES_MIN_ICON_SIZE, MIN (PLANK_DOCK_PREFERENCES_MAX_ICON_SIZE, ((gint) (_tmp25_ / 2.0)) * 2)));
#line 407 "../lib/PositionManager.vala"
			_tmp26_ = self->priv->_MaxIconSize;
#line 407 "../lib/PositionManager.vala"
			plank_logger_verbose ("PositionManager.MaxIconSize = %i", _tmp26_, NULL);
#line 408 "../lib/PositionManager.vala"
			plank_position_manager_update_caches (self, theme);
#line 409 "../lib/PositionManager.vala"
			return;
#line 1352 "PositionManager.c"
		}
	}
#line 412 "../lib/PositionManager.vala"
	plank_position_manager_update_caches (self, theme);
#line 413 "../lib/PositionManager.vala"
	plank_position_manager_update_max_icon_size (self, theme);
#line 1359 "PositionManager.c"
}

static void
plank_position_manager_update_dimensions (PlankPositionManager* self)
{
	gint height = 0;
	gint _tmp0_;
	gint background_height = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_;
	gint dock_height = 0;
	gint width = 0;
	GtkAlign _tmp4_;
	gint background_width = 0;
	gint _tmp16_;
#line 416 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 418 "../lib/PositionManager.vala"
	plank_logger_verbose ("PositionManager.update_dimensions ()", NULL);
#line 421 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_IconSize;
#line 421 "../lib/PositionManager.vala"
	height = (_tmp0_ + self->priv->top_offset) + self->priv->bottom_offset;
#line 424 "../lib/PositionManager.vala"
	background_height = MAX (0, height);
#line 426 "../lib/PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 427 "../lib/PositionManager.vala"
		height -= self->priv->top_offset;
#line 1389 "PositionManager.c"
	}
#line 430 "../lib/PositionManager.vala"
	_tmp2_ = self->priv->_screen_is_composited;
#line 430 "../lib/PositionManager.vala"
	if (_tmp2_) {
#line 1395 "PositionManager.c"
		gint _tmp3_;
#line 430 "../lib/PositionManager.vala"
		_tmp3_ = self->priv->_UrgentBounceHeight;
#line 430 "../lib/PositionManager.vala"
		_tmp1_ = _tmp3_;
#line 1401 "PositionManager.c"
	} else {
#line 430 "../lib/PositionManager.vala"
		_tmp1_ = 0;
#line 1405 "PositionManager.c"
	}
#line 430 "../lib/PositionManager.vala"
	dock_height = height + _tmp1_;
#line 432 "../lib/PositionManager.vala"
	width = 0;
#line 433 "../lib/PositionManager.vala"
	_tmp4_ = self->priv->_Alignment;
#line 433 "../lib/PositionManager.vala"
	switch (_tmp4_) {
#line 1415 "PositionManager.c"
		default:
#line 433 "../lib/PositionManager.vala"
		case GTK_ALIGN_START:
#line 433 "../lib/PositionManager.vala"
		case GTK_ALIGN_END:
#line 433 "../lib/PositionManager.vala"
		case GTK_ALIGN_CENTER:
#line 1423 "PositionManager.c"
		{
			PlankDockController* _tmp5_;
			GeeArrayList* _tmp6_;
			GeeArrayList* _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gint _tmp13_;
#line 438 "../lib/PositionManager.vala"
			_tmp5_ = self->priv->_controller;
#line 438 "../lib/PositionManager.vala"
			_tmp6_ = plank_dock_controller_get_VisibleItems (_tmp5_);
#line 438 "../lib/PositionManager.vala"
			_tmp7_ = _tmp6_;
#line 438 "../lib/PositionManager.vala"
			_tmp8_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp7_);
#line 438 "../lib/PositionManager.vala"
			_tmp9_ = _tmp8_;
#line 438 "../lib/PositionManager.vala"
			_tmp10_ = self->priv->_ItemPadding;
#line 438 "../lib/PositionManager.vala"
			_tmp11_ = self->priv->_IconSize;
#line 438 "../lib/PositionManager.vala"
			_tmp12_ = self->priv->_HorizPadding;
#line 438 "../lib/PositionManager.vala"
			_tmp13_ = self->priv->_LineWidth;
#line 438 "../lib/PositionManager.vala"
			width = ((_tmp9_ * (_tmp10_ + _tmp11_)) + (2 * _tmp12_)) + (4 * _tmp13_);
#line 439 "../lib/PositionManager.vala"
			break;
#line 1456 "PositionManager.c"
		}
#line 433 "../lib/PositionManager.vala"
		case GTK_ALIGN_FILL:
#line 1460 "PositionManager.c"
		{
#line 441 "../lib/PositionManager.vala"
			if (plank_position_manager_is_horizontal_dock (self)) {
#line 1464 "PositionManager.c"
				GdkRectangle _tmp14_;
#line 442 "../lib/PositionManager.vala"
				_tmp14_ = self->priv->monitor_geo;
#line 442 "../lib/PositionManager.vala"
				width = _tmp14_.width;
#line 1470 "PositionManager.c"
			} else {
				GdkRectangle _tmp15_;
#line 444 "../lib/PositionManager.vala"
				_tmp15_ = self->priv->monitor_geo;
#line 444 "../lib/PositionManager.vala"
				width = _tmp15_.height;
#line 1477 "PositionManager.c"
			}
#line 445 "../lib/PositionManager.vala"
			break;
#line 1481 "PositionManager.c"
		}
	}
#line 449 "../lib/PositionManager.vala"
	background_width = MAX (0, width);
#line 452 "../lib/PositionManager.vala"
	_tmp16_ = self->priv->_HorizPadding;
#line 452 "../lib/PositionManager.vala"
	if (_tmp16_ < 0) {
#line 1490 "PositionManager.c"
		gint _tmp17_;
#line 453 "../lib/PositionManager.vala"
		_tmp17_ = self->priv->_HorizPadding;
#line 453 "../lib/PositionManager.vala"
		width -= 2 * _tmp17_;
#line 1496 "PositionManager.c"
	}
#line 455 "../lib/PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 1500 "PositionManager.c"
		GdkRectangle _tmp18_;
		gint _tmp19_ = 0;
		gboolean _tmp20_;
		GdkRectangle _tmp22_;
		gint _tmp23_;
		gint _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 456 "../lib/PositionManager.vala"
		_tmp18_ = self->priv->monitor_geo;
#line 456 "../lib/PositionManager.vala"
		width = MIN (_tmp18_.width, width);
#line 457 "../lib/PositionManager.vala"
		self->priv->VisibleDockHeight = height;
#line 458 "../lib/PositionManager.vala"
		self->priv->VisibleDockWidth = width;
#line 459 "../lib/PositionManager.vala"
		self->priv->DockHeight = dock_height;
#line 460 "../lib/PositionManager.vala"
		_tmp20_ = self->priv->_screen_is_composited;
#line 460 "../lib/PositionManager.vala"
		if (_tmp20_) {
#line 1523 "PositionManager.c"
			GdkRectangle _tmp21_;
#line 460 "../lib/PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 460 "../lib/PositionManager.vala"
			_tmp19_ = _tmp21_.width;
#line 1529 "PositionManager.c"
		} else {
#line 460 "../lib/PositionManager.vala"
			_tmp19_ = width;
#line 1533 "PositionManager.c"
		}
#line 460 "../lib/PositionManager.vala"
		self->priv->DockWidth = _tmp19_;
#line 461 "../lib/PositionManager.vala"
		self->priv->DockBackgroundHeight = background_height;
#line 462 "../lib/PositionManager.vala"
		self->priv->DockBackgroundWidth = background_width;
#line 463 "../lib/PositionManager.vala"
		_tmp22_ = self->priv->monitor_geo;
#line 463 "../lib/PositionManager.vala"
		_tmp23_ = self->priv->_HorizPadding;
#line 463 "../lib/PositionManager.vala"
		_tmp24_ = self->priv->_LineWidth;
#line 463 "../lib/PositionManager.vala"
		_tmp25_ = self->priv->_ItemPadding;
#line 463 "../lib/PositionManager.vala"
		_tmp26_ = self->priv->_IconSize;
#line 463 "../lib/PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, (gint) floor (((gdouble) ((_tmp22_.width - (2 * _tmp23_)) + (4 * _tmp24_))) / (_tmp25_ + _tmp26_)));
#line 1553 "PositionManager.c"
	} else {
		GdkRectangle _tmp27_;
		gint _tmp28_ = 0;
		gboolean _tmp29_;
		GdkRectangle _tmp31_;
		gint _tmp32_;
		gint _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 465 "../lib/PositionManager.vala"
		_tmp27_ = self->priv->monitor_geo;
#line 465 "../lib/PositionManager.vala"
		width = MIN (_tmp27_.height, width);
#line 466 "../lib/PositionManager.vala"
		self->priv->VisibleDockHeight = width;
#line 467 "../lib/PositionManager.vala"
		self->priv->VisibleDockWidth = height;
#line 468 "../lib/PositionManager.vala"
		_tmp29_ = self->priv->_screen_is_composited;
#line 468 "../lib/PositionManager.vala"
		if (_tmp29_) {
#line 1575 "PositionManager.c"
			GdkRectangle _tmp30_;
#line 468 "../lib/PositionManager.vala"
			_tmp30_ = self->priv->monitor_geo;
#line 468 "../lib/PositionManager.vala"
			_tmp28_ = _tmp30_.height;
#line 1581 "PositionManager.c"
		} else {
#line 468 "../lib/PositionManager.vala"
			_tmp28_ = width;
#line 1585 "PositionManager.c"
		}
#line 468 "../lib/PositionManager.vala"
		self->priv->DockHeight = _tmp28_;
#line 469 "../lib/PositionManager.vala"
		self->priv->DockWidth = dock_height;
#line 470 "../lib/PositionManager.vala"
		self->priv->DockBackgroundHeight = background_width;
#line 471 "../lib/PositionManager.vala"
		self->priv->DockBackgroundWidth = background_height;
#line 472 "../lib/PositionManager.vala"
		_tmp31_ = self->priv->monitor_geo;
#line 472 "../lib/PositionManager.vala"
		_tmp32_ = self->priv->_HorizPadding;
#line 472 "../lib/PositionManager.vala"
		_tmp33_ = self->priv->_LineWidth;
#line 472 "../lib/PositionManager.vala"
		_tmp34_ = self->priv->_ItemPadding;
#line 472 "../lib/PositionManager.vala"
		_tmp35_ = self->priv->_IconSize;
#line 472 "../lib/PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, (gint) floor (((gdouble) ((_tmp31_.height - (2 * _tmp32_)) + (4 * _tmp33_))) / (_tmp34_ + _tmp35_)));
#line 1607 "PositionManager.c"
	}
}

/**
 * Return whether or not a dock is a horizontal dock.
 *
 * @return true if the dock's position indicates it is horizontal
 */
gboolean
plank_position_manager_is_horizontal_dock (PlankPositionManager* self)
{
	gboolean _tmp0_ = FALSE;
	GtkPositionType _tmp1_;
	gboolean result;
#line 481 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 483 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 483 "../lib/PositionManager.vala"
	if (_tmp1_ == GTK_POS_TOP) {
#line 483 "../lib/PositionManager.vala"
		_tmp0_ = TRUE;
#line 1630 "PositionManager.c"
	} else {
		GtkPositionType _tmp2_;
#line 483 "../lib/PositionManager.vala"
		_tmp2_ = self->priv->_Position;
#line 483 "../lib/PositionManager.vala"
		_tmp0_ = _tmp2_ == GTK_POS_BOTTOM;
#line 1637 "PositionManager.c"
	}
#line 483 "../lib/PositionManager.vala"
	result = _tmp0_;
#line 483 "../lib/PositionManager.vala"
	return result;
#line 1643 "PositionManager.c"
}

/**
 * Returns the cursor region for the dock.
 * This is the region that the cursor can interact with the dock.
 *
 * @return the cursor region for the dock
 */
void
plank_position_manager_get_cursor_region (PlankPositionManager* self,
                                          GdkRectangle* result)
{
	GdkRectangle cursor_region = {0};
	GdkRectangle _tmp0_;
	gdouble progress = 0.0;
	PlankDockController* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockRenderer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	PlankDockController* _tmp6_;
	PlankDockWindow* _tmp7_;
	PlankDockWindow* _tmp8_;
	GdkWindow* _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkPositionType _tmp25_;
#line 492 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 494 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 494 "../lib/PositionManager.vala"
	cursor_region = _tmp0_;
#line 495 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 495 "../lib/PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_renderer (_tmp1_);
#line 495 "../lib/PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 495 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_renderer_get_hide_progress (_tmp3_);
#line 495 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 495 "../lib/PositionManager.vala"
	progress = 1.0 - _tmp5_;
#line 496 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->_controller;
#line 496 "../lib/PositionManager.vala"
	_tmp7_ = plank_dock_controller_get_window (_tmp6_);
#line 496 "../lib/PositionManager.vala"
	_tmp8_ = _tmp7_;
#line 496 "../lib/PositionManager.vala"
	_tmp9_ = gtk_widget_get_window ((GtkWidget*) _tmp8_);
#line 496 "../lib/PositionManager.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp9_);
#line 499 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 499 "../lib/PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 499 "../lib/PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 499 "../lib/PositionManager.vala"
	_tmp13_ = plank_dock_preferences_get_ZoomEnabled (_tmp12_);
#line 499 "../lib/PositionManager.vala"
	_tmp14_ = _tmp13_;
#line 499 "../lib/PositionManager.vala"
	if (_tmp14_) {
#line 1714 "PositionManager.c"
		PlankDockItem* hovered_item = NULL;
		PlankDockController* _tmp15_;
		PlankDockWindow* _tmp16_;
		PlankDockWindow* _tmp17_;
		PlankDockItem* _tmp18_;
		PlankDockItem* _tmp19_;
		PlankDockItem* _tmp20_;
#line 500 "../lib/PositionManager.vala"
		_tmp15_ = self->priv->_controller;
#line 500 "../lib/PositionManager.vala"
		_tmp16_ = plank_dock_controller_get_window (_tmp15_);
#line 500 "../lib/PositionManager.vala"
		_tmp17_ = _tmp16_;
#line 500 "../lib/PositionManager.vala"
		_tmp18_ = plank_dock_window_get_HoveredItem (_tmp17_);
#line 500 "../lib/PositionManager.vala"
		_tmp19_ = _tmp18_;
#line 500 "../lib/PositionManager.vala"
		hovered_item = _tmp19_;
#line 501 "../lib/PositionManager.vala"
		_tmp20_ = hovered_item;
#line 501 "../lib/PositionManager.vala"
		if (_tmp20_ != NULL) {
#line 1738 "PositionManager.c"
			GdkRectangle hover_region = {0};
			PlankDockItem* _tmp21_;
			GdkRectangle _tmp22_ = {0};
			GdkRectangle _tmp23_;
			GdkRectangle _tmp24_ = {0};
#line 502 "../lib/PositionManager.vala"
			_tmp21_ = hovered_item;
#line 502 "../lib/PositionManager.vala"
			plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) _tmp21_, &_tmp22_);
#line 502 "../lib/PositionManager.vala"
			hover_region = _tmp22_;
#line 503 "../lib/PositionManager.vala"
			_tmp23_ = hover_region;
#line 503 "../lib/PositionManager.vala"
			gdk_rectangle_union (&cursor_region, &_tmp23_, &_tmp24_);
#line 503 "../lib/PositionManager.vala"
			cursor_region = _tmp24_;
#line 1756 "PositionManager.c"
		}
	}
#line 507 "../lib/PositionManager.vala"
	_tmp25_ = self->priv->_Position;
#line 507 "../lib/PositionManager.vala"
	switch (_tmp25_) {
#line 1763 "PositionManager.c"
		default:
#line 507 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 1767 "PositionManager.c"
		{
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
#line 510 "../lib/PositionManager.vala"
			_tmp26_ = cursor_region;
#line 510 "../lib/PositionManager.vala"
			cursor_region.height = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp26_.height));
#line 511 "../lib/PositionManager.vala"
			_tmp27_ = cursor_region;
#line 511 "../lib/PositionManager.vala"
			cursor_region.y = (self->priv->DockHeight - _tmp27_.height) + (self->priv->window_scale_factor - 1);
#line 512 "../lib/PositionManager.vala"
			break;
#line 1781 "PositionManager.c"
		}
#line 507 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 1785 "PositionManager.c"
		{
			GdkRectangle _tmp28_;
#line 514 "../lib/PositionManager.vala"
			_tmp28_ = cursor_region;
#line 514 "../lib/PositionManager.vala"
			cursor_region.height = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp28_.height));
#line 515 "../lib/PositionManager.vala"
			cursor_region.y = 0;
#line 516 "../lib/PositionManager.vala"
			break;
#line 1796 "PositionManager.c"
		}
#line 507 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 1800 "PositionManager.c"
		{
			GdkRectangle _tmp29_;
#line 518 "../lib/PositionManager.vala"
			_tmp29_ = cursor_region;
#line 518 "../lib/PositionManager.vala"
			cursor_region.width = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp29_.width));
#line 519 "../lib/PositionManager.vala"
			cursor_region.x = 0;
#line 520 "../lib/PositionManager.vala"
			break;
#line 1811 "PositionManager.c"
		}
#line 507 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 1815 "PositionManager.c"
		{
			GdkRectangle _tmp30_;
			GdkRectangle _tmp31_;
#line 522 "../lib/PositionManager.vala"
			_tmp30_ = cursor_region;
#line 522 "../lib/PositionManager.vala"
			cursor_region.width = MAX (1 * self->priv->window_scale_factor, (gint) (progress * _tmp30_.width));
#line 523 "../lib/PositionManager.vala"
			_tmp31_ = cursor_region;
#line 523 "../lib/PositionManager.vala"
			cursor_region.x = (self->priv->DockWidth - _tmp31_.width) + (self->priv->window_scale_factor - 1);
#line 524 "../lib/PositionManager.vala"
			break;
#line 1829 "PositionManager.c"
		}
	}
#line 527 "../lib/PositionManager.vala"
	*result = cursor_region;
#line 527 "../lib/PositionManager.vala"
	return;
#line 1836 "PositionManager.c"
}

/**
 * Returns the static dock region for the dock.
 * This is the region that the dock occupies when not hidden.
 *
 * @return the static dock region for the dock
 */
void
plank_position_manager_get_static_dock_region (PlankPositionManager* self,
                                               GdkRectangle* result)
{
	GdkRectangle dock_region = {0};
	GdkRectangle _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
#line 536 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 538 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 538 "../lib/PositionManager.vala"
	dock_region = _tmp0_;
#line 539 "../lib/PositionManager.vala"
	dock_region.x = dock_region.x + self->priv->win_x;
#line 540 "../lib/PositionManager.vala"
	dock_region.y = dock_region.y + self->priv->win_y;
#line 543 "../lib/PositionManager.vala"
	_tmp2_ = self->priv->_screen_is_composited;
#line 543 "../lib/PositionManager.vala"
	if (!_tmp2_) {
#line 1867 "PositionManager.c"
		PlankDockController* _tmp3_;
		PlankHideManager* _tmp4_;
		PlankHideManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 543 "../lib/PositionManager.vala"
		_tmp3_ = self->priv->_controller;
#line 543 "../lib/PositionManager.vala"
		_tmp4_ = plank_dock_controller_get_hide_manager (_tmp3_);
#line 543 "../lib/PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 543 "../lib/PositionManager.vala"
		_tmp6_ = plank_hide_manager_get_Hidden (_tmp5_);
#line 543 "../lib/PositionManager.vala"
		_tmp7_ = _tmp6_;
#line 543 "../lib/PositionManager.vala"
		_tmp1_ = _tmp7_;
#line 1885 "PositionManager.c"
	} else {
#line 543 "../lib/PositionManager.vala"
		_tmp1_ = FALSE;
#line 1889 "PositionManager.c"
	}
#line 543 "../lib/PositionManager.vala"
	if (_tmp1_) {
#line 1893 "PositionManager.c"
		GtkPositionType _tmp8_;
#line 544 "../lib/PositionManager.vala"
		_tmp8_ = self->priv->_Position;
#line 544 "../lib/PositionManager.vala"
		switch (_tmp8_) {
#line 1899 "PositionManager.c"
			default:
#line 544 "../lib/PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 1903 "PositionManager.c"
			{
#line 547 "../lib/PositionManager.vala"
				dock_region.y = dock_region.y - (self->priv->DockHeight - 1);
#line 548 "../lib/PositionManager.vala"
				break;
#line 1909 "PositionManager.c"
			}
#line 544 "../lib/PositionManager.vala"
			case GTK_POS_TOP:
#line 1913 "PositionManager.c"
			{
#line 550 "../lib/PositionManager.vala"
				dock_region.y = dock_region.y + (self->priv->DockHeight - 1);
#line 551 "../lib/PositionManager.vala"
				break;
#line 1919 "PositionManager.c"
			}
#line 544 "../lib/PositionManager.vala"
			case GTK_POS_LEFT:
#line 1923 "PositionManager.c"
			{
#line 553 "../lib/PositionManager.vala"
				dock_region.x = dock_region.x + (self->priv->DockWidth - 1);
#line 554 "../lib/PositionManager.vala"
				break;
#line 1929 "PositionManager.c"
			}
#line 544 "../lib/PositionManager.vala"
			case GTK_POS_RIGHT:
#line 1933 "PositionManager.c"
			{
#line 556 "../lib/PositionManager.vala"
				dock_region.x = dock_region.x - (self->priv->DockWidth - 1);
#line 557 "../lib/PositionManager.vala"
				break;
#line 1939 "PositionManager.c"
			}
		}
	}
#line 561 "../lib/PositionManager.vala"
	*result = dock_region;
#line 561 "../lib/PositionManager.vala"
	return;
#line 1947 "PositionManager.c"
}

/**
 * Call when any cached region needs updating.
 */
void
plank_position_manager_update_regions (PlankPositionManager* self)
{
	GdkRectangle old_region = {0};
	GdkRectangle _tmp0_;
	PlankDockController* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint xoffset = 0;
	GdkRectangle _tmp8_;
	gint yoffset = 0;
	GdkRectangle _tmp9_;
	gboolean _tmp10_;
	GtkPositionType _tmp21_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_;
#line 567 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 569 "../lib/PositionManager.vala"
	plank_logger_verbose ("PositionManager.update_regions ()", NULL);
#line 571 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->static_dock_region;
#line 571 "../lib/PositionManager.vala"
	old_region = _tmp0_;
#line 574 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 574 "../lib/PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_VisibleItems (_tmp1_);
#line 574 "../lib/PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 574 "../lib/PositionManager.vala"
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 574 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 574 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->_ItemPadding;
#line 574 "../lib/PositionManager.vala"
	_tmp7_ = self->priv->_IconSize;
#line 574 "../lib/PositionManager.vala"
	self->priv->items_width = _tmp5_ * (_tmp6_ + _tmp7_);
#line 576 "../lib/PositionManager.vala"
	self->priv->static_dock_region.width = self->priv->VisibleDockWidth;
#line 577 "../lib/PositionManager.vala"
	self->priv->static_dock_region.height = self->priv->VisibleDockHeight;
#line 579 "../lib/PositionManager.vala"
	_tmp8_ = self->priv->static_dock_region;
#line 579 "../lib/PositionManager.vala"
	xoffset = (self->priv->DockWidth - _tmp8_.width) / 2;
#line 580 "../lib/PositionManager.vala"
	_tmp9_ = self->priv->static_dock_region;
#line 580 "../lib/PositionManager.vala"
	yoffset = (self->priv->DockHeight - _tmp9_.height) / 2;
#line 582 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_screen_is_composited;
#line 582 "../lib/PositionManager.vala"
	if (_tmp10_) {
#line 2016 "PositionManager.c"
		gint offset = 0;
		gint _tmp11_;
		GtkAlign _tmp12_;
#line 583 "../lib/PositionManager.vala"
		_tmp11_ = self->priv->_Offset;
#line 583 "../lib/PositionManager.vala"
		offset = _tmp11_;
#line 584 "../lib/PositionManager.vala"
		xoffset = (gint) ((1 + (offset / 100.0)) * xoffset);
#line 585 "../lib/PositionManager.vala"
		yoffset = (gint) ((1 + (offset / 100.0)) * yoffset);
#line 587 "../lib/PositionManager.vala"
		_tmp12_ = self->priv->_Alignment;
#line 587 "../lib/PositionManager.vala"
		switch (_tmp12_) {
#line 2032 "PositionManager.c"
			default:
#line 587 "../lib/PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 587 "../lib/PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 2038 "PositionManager.c"
			{
#line 591 "../lib/PositionManager.vala"
				break;
#line 2042 "PositionManager.c"
			}
#line 587 "../lib/PositionManager.vala"
			case GTK_ALIGN_START:
#line 2046 "PositionManager.c"
			{
#line 593 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2050 "PositionManager.c"
					GdkRectangle _tmp13_;
					GdkRectangle _tmp14_;
#line 594 "../lib/PositionManager.vala"
					xoffset = 0;
#line 595 "../lib/PositionManager.vala"
					_tmp13_ = self->priv->monitor_geo;
#line 595 "../lib/PositionManager.vala"
					_tmp14_ = self->priv->static_dock_region;
#line 595 "../lib/PositionManager.vala"
					yoffset = _tmp13_.height - _tmp14_.height;
#line 2061 "PositionManager.c"
				} else {
					GdkRectangle _tmp15_;
					GdkRectangle _tmp16_;
#line 597 "../lib/PositionManager.vala"
					_tmp15_ = self->priv->monitor_geo;
#line 597 "../lib/PositionManager.vala"
					_tmp16_ = self->priv->static_dock_region;
#line 597 "../lib/PositionManager.vala"
					xoffset = _tmp15_.width - _tmp16_.width;
#line 598 "../lib/PositionManager.vala"
					yoffset = 0;
#line 2073 "PositionManager.c"
				}
#line 600 "../lib/PositionManager.vala"
				break;
#line 2077 "PositionManager.c"
			}
#line 587 "../lib/PositionManager.vala"
			case GTK_ALIGN_END:
#line 2081 "PositionManager.c"
			{
#line 602 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2085 "PositionManager.c"
					GdkRectangle _tmp17_;
					GdkRectangle _tmp18_;
#line 603 "../lib/PositionManager.vala"
					_tmp17_ = self->priv->monitor_geo;
#line 603 "../lib/PositionManager.vala"
					_tmp18_ = self->priv->static_dock_region;
#line 603 "../lib/PositionManager.vala"
					xoffset = _tmp17_.width - _tmp18_.width;
#line 604 "../lib/PositionManager.vala"
					yoffset = 0;
#line 2096 "PositionManager.c"
				} else {
					GdkRectangle _tmp19_;
					GdkRectangle _tmp20_;
#line 606 "../lib/PositionManager.vala"
					xoffset = 0;
#line 607 "../lib/PositionManager.vala"
					_tmp19_ = self->priv->monitor_geo;
#line 607 "../lib/PositionManager.vala"
					_tmp20_ = self->priv->static_dock_region;
#line 607 "../lib/PositionManager.vala"
					yoffset = _tmp19_.height - _tmp20_.height;
#line 2108 "PositionManager.c"
				}
#line 609 "../lib/PositionManager.vala"
				break;
#line 2112 "PositionManager.c"
			}
		}
	}
#line 613 "../lib/PositionManager.vala"
	_tmp21_ = self->priv->_Position;
#line 613 "../lib/PositionManager.vala"
	switch (_tmp21_) {
#line 2120 "PositionManager.c"
		default:
#line 613 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 2124 "PositionManager.c"
		{
			GdkRectangle _tmp22_;
#line 616 "../lib/PositionManager.vala"
			self->priv->static_dock_region.x = xoffset;
#line 617 "../lib/PositionManager.vala"
			_tmp22_ = self->priv->static_dock_region;
#line 617 "../lib/PositionManager.vala"
			self->priv->static_dock_region.y = self->priv->DockHeight - _tmp22_.height;
#line 618 "../lib/PositionManager.vala"
			break;
#line 2135 "PositionManager.c"
		}
#line 613 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 2139 "PositionManager.c"
		{
#line 620 "../lib/PositionManager.vala"
			self->priv->static_dock_region.x = xoffset;
#line 621 "../lib/PositionManager.vala"
			self->priv->static_dock_region.y = 0;
#line 622 "../lib/PositionManager.vala"
			break;
#line 2147 "PositionManager.c"
		}
#line 613 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 2151 "PositionManager.c"
		{
#line 624 "../lib/PositionManager.vala"
			self->priv->static_dock_region.y = yoffset;
#line 625 "../lib/PositionManager.vala"
			self->priv->static_dock_region.x = 0;
#line 626 "../lib/PositionManager.vala"
			break;
#line 2159 "PositionManager.c"
		}
#line 613 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 2163 "PositionManager.c"
		{
			GdkRectangle _tmp23_;
#line 628 "../lib/PositionManager.vala"
			self->priv->static_dock_region.y = yoffset;
#line 629 "../lib/PositionManager.vala"
			_tmp23_ = self->priv->static_dock_region;
#line 629 "../lib/PositionManager.vala"
			self->priv->static_dock_region.x = self->priv->DockWidth - _tmp23_.width;
#line 630 "../lib/PositionManager.vala"
			break;
#line 2174 "PositionManager.c"
		}
	}
#line 633 "../lib/PositionManager.vala"
	plank_position_manager_update_dock_position (self);
#line 635 "../lib/PositionManager.vala"
	_tmp28_ = self->priv->_screen_is_composited;
#line 635 "../lib/PositionManager.vala"
	if (!_tmp28_) {
#line 635 "../lib/PositionManager.vala"
		_tmp27_ = TRUE;
#line 2185 "PositionManager.c"
	} else {
		GdkRectangle _tmp29_;
		GdkRectangle _tmp30_;
#line 636 "../lib/PositionManager.vala"
		_tmp29_ = old_region;
#line 636 "../lib/PositionManager.vala"
		_tmp30_ = self->priv->static_dock_region;
#line 636 "../lib/PositionManager.vala"
		_tmp27_ = _tmp29_.x != _tmp30_.x;
#line 2195 "PositionManager.c"
	}
#line 635 "../lib/PositionManager.vala"
	if (_tmp27_) {
#line 635 "../lib/PositionManager.vala"
		_tmp26_ = TRUE;
#line 2201 "PositionManager.c"
	} else {
		GdkRectangle _tmp31_;
		GdkRectangle _tmp32_;
#line 637 "../lib/PositionManager.vala"
		_tmp31_ = old_region;
#line 637 "../lib/PositionManager.vala"
		_tmp32_ = self->priv->static_dock_region;
#line 637 "../lib/PositionManager.vala"
		_tmp26_ = _tmp31_.y != _tmp32_.y;
#line 2211 "PositionManager.c"
	}
#line 635 "../lib/PositionManager.vala"
	if (_tmp26_) {
#line 635 "../lib/PositionManager.vala"
		_tmp25_ = TRUE;
#line 2217 "PositionManager.c"
	} else {
		GdkRectangle _tmp33_;
		GdkRectangle _tmp34_;
#line 638 "../lib/PositionManager.vala"
		_tmp33_ = old_region;
#line 638 "../lib/PositionManager.vala"
		_tmp34_ = self->priv->static_dock_region;
#line 638 "../lib/PositionManager.vala"
		_tmp25_ = _tmp33_.width != _tmp34_.width;
#line 2227 "PositionManager.c"
	}
#line 635 "../lib/PositionManager.vala"
	if (_tmp25_) {
#line 635 "../lib/PositionManager.vala"
		_tmp24_ = TRUE;
#line 2233 "PositionManager.c"
	} else {
		GdkRectangle _tmp35_;
		GdkRectangle _tmp36_;
#line 639 "../lib/PositionManager.vala"
		_tmp35_ = old_region;
#line 639 "../lib/PositionManager.vala"
		_tmp36_ = self->priv->static_dock_region;
#line 639 "../lib/PositionManager.vala"
		_tmp24_ = _tmp35_.height != _tmp36_.height;
#line 2243 "PositionManager.c"
	}
#line 635 "../lib/PositionManager.vala"
	if (_tmp24_) {
#line 2247 "PositionManager.c"
		PlankDockController* _tmp37_;
		PlankDockWindow* _tmp38_;
		PlankDockWindow* _tmp39_;
		PlankDockController* _tmp40_;
		PlankHideManager* _tmp41_;
		PlankHideManager* _tmp42_;
		gboolean _tmp43_;
#line 640 "../lib/PositionManager.vala"
		_tmp37_ = self->priv->_controller;
#line 640 "../lib/PositionManager.vala"
		_tmp38_ = plank_dock_controller_get_window (_tmp37_);
#line 640 "../lib/PositionManager.vala"
		_tmp39_ = _tmp38_;
#line 640 "../lib/PositionManager.vala"
		plank_dock_window_update_size_and_position (_tmp39_);
#line 642 "../lib/PositionManager.vala"
		_tmp40_ = self->priv->_controller;
#line 642 "../lib/PositionManager.vala"
		_tmp41_ = plank_dock_controller_get_hide_manager (_tmp40_);
#line 642 "../lib/PositionManager.vala"
		_tmp42_ = _tmp41_;
#line 642 "../lib/PositionManager.vala"
		plank_hide_manager_update_barrier (_tmp42_);
#line 647 "../lib/PositionManager.vala"
		_tmp43_ = self->priv->_screen_is_composited;
#line 647 "../lib/PositionManager.vala"
		if (_tmp43_) {
#line 2275 "PositionManager.c"
			PlankDockController* _tmp44_;
			PlankDockRenderer* _tmp45_;
			PlankDockRenderer* _tmp46_;
#line 648 "../lib/PositionManager.vala"
			_tmp44_ = self->priv->_controller;
#line 648 "../lib/PositionManager.vala"
			_tmp45_ = plank_dock_controller_get_renderer (_tmp44_);
#line 648 "../lib/PositionManager.vala"
			_tmp46_ = _tmp45_;
#line 648 "../lib/PositionManager.vala"
			plank_renderer_animated_draw ((PlankRenderer*) _tmp46_);
#line 2287 "PositionManager.c"
		}
	} else {
		PlankDockController* _tmp47_;
		PlankDockRenderer* _tmp48_;
		PlankDockRenderer* _tmp49_;
#line 650 "../lib/PositionManager.vala"
		_tmp47_ = self->priv->_controller;
#line 650 "../lib/PositionManager.vala"
		_tmp48_ = plank_dock_controller_get_renderer (_tmp47_);
#line 650 "../lib/PositionManager.vala"
		_tmp49_ = _tmp48_;
#line 650 "../lib/PositionManager.vala"
		plank_renderer_animated_draw ((PlankRenderer*) _tmp49_);
#line 2301 "PositionManager.c"
	}
}

/**
 * The draw-value for a dock item.
 *
 * @param item the dock item to find the drawvalue for
 * @return the region for the dock item
 */
PlankDockItemDrawValue*
plank_position_manager_get_draw_value_for_item (PlankPositionManager* self,
                                                PlankDockItem* item)
{
	GeeHashMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	PlankDockItemDrawValue* draw_value = NULL;
	GeeHashMap* _tmp6_;
	gpointer _tmp7_;
	PlankDockItemDrawValue* _tmp8_;
	PlankDockItemDrawValue* result;
#line 660 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 660 "../lib/PositionManager.vala"
	g_return_val_if_fail (item != NULL, NULL);
#line 662 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->draw_values;
#line 662 "../lib/PositionManager.vala"
	_tmp1_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp0_);
#line 662 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 662 "../lib/PositionManager.vala"
	if (_tmp2_ == 0) {
#line 2335 "PositionManager.c"
		PlankDockController* _tmp3_;
		GeeArrayList* _tmp4_;
		GeeArrayList* _tmp5_;
#line 663 "../lib/PositionManager.vala"
		g_debug ("PositionManager.vala:663: Without draw_values there is trouble ahead");
#line 664 "../lib/PositionManager.vala"
		_tmp3_ = self->priv->_controller;
#line 664 "../lib/PositionManager.vala"
		_tmp4_ = plank_dock_controller_get_VisibleItems (_tmp3_);
#line 664 "../lib/PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 664 "../lib/PositionManager.vala"
		plank_position_manager_update_draw_values (self, _tmp5_, NULL, NULL, NULL, NULL);
#line 2349 "PositionManager.c"
	}
#line 667 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->draw_values;
#line 667 "../lib/PositionManager.vala"
	_tmp7_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp6_, (PlankDockElement*) item);
#line 667 "../lib/PositionManager.vala"
	draw_value = (PlankDockItemDrawValue*) _tmp7_;
#line 668 "../lib/PositionManager.vala"
	_tmp8_ = draw_value;
#line 668 "../lib/PositionManager.vala"
	if (_tmp8_ == NULL) {
#line 2361 "PositionManager.c"
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		PlankDockItemDrawValue* _tmp11_;
#line 669 "../lib/PositionManager.vala"
		_tmp9_ = plank_dock_element_get_Text ((PlankDockElement*) item);
#line 669 "../lib/PositionManager.vala"
		_tmp10_ = _tmp9_;
#line 669 "../lib/PositionManager.vala"
		g_warning ("PositionManager.vala:669: Without a draw_value there is trouble ahead " \
"for '%s'", _tmp10_);
#line 670 "../lib/PositionManager.vala"
		_tmp11_ = plank_dock_item_draw_value_new ();
#line 670 "../lib/PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (draw_value);
#line 670 "../lib/PositionManager.vala"
		draw_value = _tmp11_;
#line 2377 "PositionManager.c"
	}
#line 673 "../lib/PositionManager.vala"
	result = draw_value;
#line 673 "../lib/PositionManager.vala"
	return result;
#line 2383 "PositionManager.c"
}

/**
 * Update and recalculated all internal draw-values using the given methodes for custom manipulations.
 *
 * @param items the ordered list of all current item which are suppose to be shown on the dock
 * @param func a function which adjusts the draw-value per item
 * @param post_func a function which post-processes all draw-values
 */
static gboolean
__lambda29_ (PlankPositionManager* self,
             PlankDockElement* i,
             PlankDockItemDrawValue* val)
{
	GdkRectangle _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	GdkRectangle _tmp2_ = {0};
	gboolean result;
#line 881 "../lib/PositionManager.vala"
	g_return_val_if_fail (i != NULL, FALSE);
#line 881 "../lib/PositionManager.vala"
	g_return_val_if_fail (val != NULL, FALSE);
#line 882 "../lib/PositionManager.vala"
	plank_position_manager_get_item_draw_region (self, val, &_tmp0_);
#line 882 "../lib/PositionManager.vala"
	val->draw_region = _tmp0_;
#line 883 "../lib/PositionManager.vala"
	plank_position_manager_get_item_hover_region (self, val, &_tmp1_);
#line 883 "../lib/PositionManager.vala"
	val->hover_region = _tmp1_;
#line 884 "../lib/PositionManager.vala"
	plank_position_manager_get_item_background_region (self, val, &_tmp2_);
#line 884 "../lib/PositionManager.vala"
	val->background_region = _tmp2_;
#line 885 "../lib/PositionManager.vala"
	result = TRUE;
#line 885 "../lib/PositionManager.vala"
	return result;
#line 2422 "PositionManager.c"
}

static gboolean
___lambda29__gee_forall_map_func (gconstpointer k,
                                  gconstpointer v,
                                  gpointer self)
{
	gboolean result;
	result = __lambda29_ ((PlankPositionManager*) self, (PlankDockElement*) k, (PlankDockItemDrawValue*) v);
#line 881 "../lib/PositionManager.vala"
	return result;
#line 2434 "PositionManager.c"
}

void
plank_position_manager_update_draw_values (PlankPositionManager* self,
                                           GeeArrayList* items,
                                           PlankDrawValueFunc func,
                                           gpointer func_target,
                                           PlankDrawValuesFunc post_func,
                                           gpointer post_func_target)
{
	PlankDockPreferences* prefs = NULL;
	PlankDockController* _tmp0_;
	PlankDockPreferences* _tmp1_;
	PlankDockPreferences* _tmp2_;
	PlankDockRenderer* renderer = NULL;
	PlankDockController* _tmp3_;
	PlankDockRenderer* _tmp4_;
	PlankDockRenderer* _tmp5_;
	GeeHashMap* _tmp6_;
	gint width = 0;
	gint height = 0;
	gint icon_size = 0;
	gint _tmp7_;
	GdkPoint cursor = {0};
	PlankDockRenderer* _tmp8_;
	GdkPoint _tmp9_ = {0};
	GdkPoint _tmp10_;
	GtkPositionType _tmp11_;
	gdouble _tmp16_ = 0.0;
	gdouble center_y = 0.0;
	gdouble center_x = 0.0;
	gint _tmp19_;
	GtkAlign _tmp20_;
	PlankPointD center = {0};
	PlankPointD _tmp32_ = {0};
	gboolean _tmp33_ = FALSE;
	PlankDockController* _tmp34_;
	PlankDragManager* _tmp35_;
	PlankDragManager* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp38_;
	gboolean expand_for_drop = FALSE;
	gboolean zoom_enabled = FALSE;
	gdouble _tmp42_ = 0.0;
	gboolean _tmp43_ = FALSE;
	gdouble zoom_in_progress = 0.0;
	gdouble zoom_in_percent = 0.0;
	gdouble zoom_icon_size = 0.0;
	gint _tmp47_;
	GeeHashMap* _tmp106_;
	gpointer _tmp107_;
	gpointer _tmp108_;
	PlankDockItemDrawValue* _tmp109_;
	GeeHashMap* _tmp110_;
	gpointer _tmp111_;
	gpointer _tmp112_;
	PlankDockItemDrawValue* _tmp113_;
	GeeHashMap* _tmp114_;
	GeeMapIterator* _tmp115_;
	GeeMapIterator* _tmp116_;
#line 683 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 683 "../lib/PositionManager.vala"
	g_return_if_fail (items != NULL);
#line 686 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 686 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_prefs (_tmp0_);
#line 686 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 686 "../lib/PositionManager.vala"
	prefs = _tmp2_;
#line 687 "../lib/PositionManager.vala"
	_tmp3_ = self->priv->_controller;
#line 687 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_controller_get_renderer (_tmp3_);
#line 687 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 687 "../lib/PositionManager.vala"
	renderer = _tmp5_;
#line 689 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->draw_values;
#line 689 "../lib/PositionManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp6_);
#line 694 "../lib/PositionManager.vala"
	width = self->priv->DockWidth;
#line 695 "../lib/PositionManager.vala"
	height = self->priv->DockHeight;
#line 696 "../lib/PositionManager.vala"
	_tmp7_ = self->priv->_IconSize;
#line 696 "../lib/PositionManager.vala"
	icon_size = _tmp7_;
#line 698 "../lib/PositionManager.vala"
	_tmp8_ = renderer;
#line 698 "../lib/PositionManager.vala"
	plank_dock_renderer_get_local_cursor (_tmp8_, &_tmp9_);
#line 698 "../lib/PositionManager.vala"
	_tmp10_ = _tmp9_;
#line 698 "../lib/PositionManager.vala"
	cursor = _tmp10_;
#line 701 "../lib/PositionManager.vala"
	_tmp11_ = self->priv->_Position;
#line 701 "../lib/PositionManager.vala"
	switch (_tmp11_) {
#line 701 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 2541 "PositionManager.c"
		{
			GdkPoint _tmp12_;
#line 703 "../lib/PositionManager.vala"
			_tmp12_ = cursor;
#line 703 "../lib/PositionManager.vala"
			cursor.x = width - _tmp12_.x;
#line 704 "../lib/PositionManager.vala"
			break;
#line 2550 "PositionManager.c"
		}
#line 701 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 2554 "PositionManager.c"
		{
			GdkPoint _tmp13_;
#line 706 "../lib/PositionManager.vala"
			_tmp13_ = cursor;
#line 706 "../lib/PositionManager.vala"
			cursor.y = height - _tmp13_.y;
#line 707 "../lib/PositionManager.vala"
			break;
#line 2563 "PositionManager.c"
		}
		default:
		{
#line 709 "../lib/PositionManager.vala"
			break;
#line 2569 "PositionManager.c"
		}
	}
#line 713 "../lib/PositionManager.vala"
	if (!plank_position_manager_is_horizontal_dock (self)) {
#line 2574 "PositionManager.c"
		gint tmp = 0;
		GdkPoint _tmp14_;
		GdkPoint _tmp15_;
#line 714 "../lib/PositionManager.vala"
		_tmp14_ = cursor;
#line 714 "../lib/PositionManager.vala"
		tmp = _tmp14_.y;
#line 715 "../lib/PositionManager.vala"
		_tmp15_ = cursor;
#line 715 "../lib/PositionManager.vala"
		cursor.y = _tmp15_.x;
#line 716 "../lib/PositionManager.vala"
		cursor.x = tmp;
#line 718 "../lib/PositionManager.vala"
		tmp = width;
#line 719 "../lib/PositionManager.vala"
		width = height;
#line 720 "../lib/PositionManager.vala"
		height = tmp;
#line 2594 "PositionManager.c"
	}
#line 725 "../lib/PositionManager.vala"
	if (plank_position_manager_is_horizontal_dock (self)) {
#line 2598 "PositionManager.c"
		GdkRectangle _tmp17_;
#line 725 "../lib/PositionManager.vala"
		_tmp17_ = self->priv->static_dock_region;
#line 725 "../lib/PositionManager.vala"
		_tmp16_ = _tmp17_.height / 2.0;
#line 2604 "PositionManager.c"
	} else {
		GdkRectangle _tmp18_;
#line 725 "../lib/PositionManager.vala"
		_tmp18_ = self->priv->static_dock_region;
#line 725 "../lib/PositionManager.vala"
		_tmp16_ = _tmp18_.width / 2.0;
#line 2611 "PositionManager.c"
	}
#line 725 "../lib/PositionManager.vala"
	center_y = _tmp16_;
#line 727 "../lib/PositionManager.vala"
	_tmp19_ = self->priv->_ItemPadding;
#line 727 "../lib/PositionManager.vala"
	center_x = ((icon_size + _tmp19_) / 2.0) + self->priv->items_offset;
#line 728 "../lib/PositionManager.vala"
	_tmp20_ = self->priv->_Alignment;
#line 728 "../lib/PositionManager.vala"
	if (_tmp20_ == GTK_ALIGN_FILL) {
#line 2623 "PositionManager.c"
		GtkAlign _tmp21_;
#line 729 "../lib/PositionManager.vala"
		_tmp21_ = self->priv->_ItemsAlignment;
#line 729 "../lib/PositionManager.vala"
		switch (_tmp21_) {
#line 2629 "PositionManager.c"
			default:
#line 729 "../lib/PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 729 "../lib/PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 2635 "PositionManager.c"
			{
#line 733 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2639 "PositionManager.c"
					GdkRectangle _tmp22_;
					GdkRectangle _tmp23_;
#line 734 "../lib/PositionManager.vala"
					_tmp22_ = self->priv->static_dock_region;
#line 734 "../lib/PositionManager.vala"
					_tmp23_ = self->priv->static_dock_region;
#line 734 "../lib/PositionManager.vala"
					center_x += (gdouble) (_tmp22_.x + (((_tmp23_.width - (2 * self->priv->items_offset)) - self->priv->items_width) / 2));
#line 2648 "PositionManager.c"
				} else {
					GdkRectangle _tmp24_;
					GdkRectangle _tmp25_;
#line 736 "../lib/PositionManager.vala"
					_tmp24_ = self->priv->static_dock_region;
#line 736 "../lib/PositionManager.vala"
					_tmp25_ = self->priv->static_dock_region;
#line 736 "../lib/PositionManager.vala"
					center_x += (gdouble) (_tmp24_.y + (((_tmp25_.height - (2 * self->priv->items_offset)) - self->priv->items_width) / 2));
#line 2658 "PositionManager.c"
				}
#line 737 "../lib/PositionManager.vala"
				break;
#line 2662 "PositionManager.c"
			}
#line 729 "../lib/PositionManager.vala"
			case GTK_ALIGN_START:
#line 2666 "PositionManager.c"
			{
#line 739 "../lib/PositionManager.vala"
				break;
#line 2670 "PositionManager.c"
			}
#line 729 "../lib/PositionManager.vala"
			case GTK_ALIGN_END:
#line 2674 "PositionManager.c"
			{
#line 741 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 2678 "PositionManager.c"
					GdkRectangle _tmp26_;
					GdkRectangle _tmp27_;
#line 742 "../lib/PositionManager.vala"
					_tmp26_ = self->priv->static_dock_region;
#line 742 "../lib/PositionManager.vala"
					_tmp27_ = self->priv->static_dock_region;
#line 742 "../lib/PositionManager.vala"
					center_x += (gdouble) (_tmp26_.x + ((_tmp27_.width - (2 * self->priv->items_offset)) - self->priv->items_width));
#line 2687 "PositionManager.c"
				} else {
					GdkRectangle _tmp28_;
					GdkRectangle _tmp29_;
#line 744 "../lib/PositionManager.vala"
					_tmp28_ = self->priv->static_dock_region;
#line 744 "../lib/PositionManager.vala"
					_tmp29_ = self->priv->static_dock_region;
#line 744 "../lib/PositionManager.vala"
					center_x += (gdouble) (_tmp28_.y + ((_tmp29_.height - (2 * self->priv->items_offset)) - self->priv->items_width));
#line 2697 "PositionManager.c"
				}
#line 745 "../lib/PositionManager.vala"
				break;
#line 2701 "PositionManager.c"
			}
		}
	} else {
#line 748 "../lib/PositionManager.vala"
		if (plank_position_manager_is_horizontal_dock (self)) {
#line 2707 "PositionManager.c"
			GdkRectangle _tmp30_;
#line 749 "../lib/PositionManager.vala"
			_tmp30_ = self->priv->static_dock_region;
#line 749 "../lib/PositionManager.vala"
			center_x += (gdouble) _tmp30_.x;
#line 2713 "PositionManager.c"
		} else {
			GdkRectangle _tmp31_;
#line 751 "../lib/PositionManager.vala"
			_tmp31_ = self->priv->static_dock_region;
#line 751 "../lib/PositionManager.vala"
			center_x += (gdouble) _tmp31_.y;
#line 2720 "PositionManager.c"
		}
	}
#line 754 "../lib/PositionManager.vala"
	_tmp32_.x = floor (center_x);
#line 754 "../lib/PositionManager.vala"
	_tmp32_.y = floor (center_y);
#line 754 "../lib/PositionManager.vala"
	center = _tmp32_;
#line 761 "../lib/PositionManager.vala"
	_tmp34_ = self->priv->_controller;
#line 761 "../lib/PositionManager.vala"
	_tmp35_ = plank_dock_controller_get_drag_manager (_tmp34_);
#line 761 "../lib/PositionManager.vala"
	_tmp36_ = _tmp35_;
#line 761 "../lib/PositionManager.vala"
	_tmp37_ = plank_drag_manager_get_ExternalDragActive (_tmp36_);
#line 761 "../lib/PositionManager.vala"
	_tmp38_ = _tmp37_;
#line 761 "../lib/PositionManager.vala"
	if (_tmp38_) {
#line 2741 "PositionManager.c"
		PlankDockPreferences* _tmp39_;
		gboolean _tmp40_;
		gboolean _tmp41_;
#line 761 "../lib/PositionManager.vala"
		_tmp39_ = prefs;
#line 761 "../lib/PositionManager.vala"
		_tmp40_ = plank_dock_preferences_get_LockItems (_tmp39_);
#line 761 "../lib/PositionManager.vala"
		_tmp41_ = _tmp40_;
#line 761 "../lib/PositionManager.vala"
		_tmp33_ = !_tmp41_;
#line 2753 "PositionManager.c"
	} else {
#line 761 "../lib/PositionManager.vala"
		_tmp33_ = FALSE;
#line 2757 "PositionManager.c"
	}
#line 761 "../lib/PositionManager.vala"
	expand_for_drop = _tmp33_;
#line 762 "../lib/PositionManager.vala"
	zoom_enabled = FALSE;
#line 763 "../lib/PositionManager.vala"
	if (zoom_enabled) {
#line 763 "../lib/PositionManager.vala"
		_tmp43_ = TRUE;
#line 2767 "PositionManager.c"
	} else {
#line 763 "../lib/PositionManager.vala"
		_tmp43_ = expand_for_drop;
#line 2771 "PositionManager.c"
	}
#line 763 "../lib/PositionManager.vala"
	if (_tmp43_) {
#line 2775 "PositionManager.c"
		PlankDockRenderer* _tmp44_;
		gdouble _tmp45_;
		gdouble _tmp46_;
#line 763 "../lib/PositionManager.vala"
		_tmp44_ = renderer;
#line 763 "../lib/PositionManager.vala"
		_tmp45_ = plank_dock_renderer_get_zoom_in_progress (_tmp44_);
#line 763 "../lib/PositionManager.vala"
		_tmp46_ = _tmp45_;
#line 763 "../lib/PositionManager.vala"
		_tmp42_ = _tmp46_;
#line 2787 "PositionManager.c"
	} else {
#line 763 "../lib/PositionManager.vala"
		_tmp42_ = 0.0;
#line 2791 "PositionManager.c"
	}
#line 763 "../lib/PositionManager.vala"
	zoom_in_progress = _tmp42_;
#line 764 "../lib/PositionManager.vala"
	zoom_in_percent = self->priv->ZoomPercent;
#line 765 "../lib/PositionManager.vala"
	_tmp47_ = self->priv->_ZoomIconSize;
#line 765 "../lib/PositionManager.vala"
	zoom_icon_size = (gdouble) _tmp47_;
#line 2801 "PositionManager.c"
	{
		GeeArrayList* _item_list = NULL;
		gint _item_size = 0;
		GeeArrayList* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		gint _item_index = 0;
#line 767 "../lib/PositionManager.vala"
		_item_list = items;
#line 767 "../lib/PositionManager.vala"
		_tmp48_ = _item_list;
#line 767 "../lib/PositionManager.vala"
		_tmp49_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp48_);
#line 767 "../lib/PositionManager.vala"
		_tmp50_ = _tmp49_;
#line 767 "../lib/PositionManager.vala"
		_item_size = _tmp50_;
#line 767 "../lib/PositionManager.vala"
		_item_index = -1;
#line 767 "../lib/PositionManager.vala"
		while (TRUE) {
#line 2823 "PositionManager.c"
			gint _tmp51_;
			gint _tmp52_;
			PlankDockItem* item = NULL;
			GeeArrayList* _tmp53_;
			gpointer _tmp54_;
			PlankDockItemDrawValue* val = NULL;
			PlankDockItemDrawValue* _tmp55_;
			PlankDockItemDrawValue* _tmp56_;
			PlankDockItemDrawValue* _tmp57_;
			PlankDockItemDrawValue* _tmp58_;
			PlankDockItemDrawValue* _tmp59_;
			PlankDockItemDrawValue* _tmp60_;
			PlankDockItemDrawValue* _tmp61_;
			PlankPointD _tmp62_;
			gdouble cursor_position = 0.0;
			GdkPoint _tmp63_;
			gdouble center_position = 0.0;
			PlankPointD _tmp64_;
			gdouble offset = 0.0;
			gdouble offset_percent = 0.0;
			gdouble zoom = 0.0;
			gdouble zoomed_center_height = 0.0;
			PlankDockItemDrawValue* _tmp65_;
			PlankPointD _tmp66_ = {0};
			PlankDockItemDrawValue* _tmp67_;
			PlankDockItemDrawValue* _tmp68_;
			GtkPositionType _tmp81_;
			PlankDockItemDrawValue* _tmp94_;
			GtkPositionType _tmp95_;
			GeeHashMap* _tmp98_;
			PlankDockItem* _tmp99_;
			PlankDockItemDrawValue* _tmp100_;
			PlankDockItem* _tmp101_;
			gint64 _tmp102_;
			gint64 _tmp103_;
#line 767 "../lib/PositionManager.vala"
			_item_index = _item_index + 1;
#line 767 "../lib/PositionManager.vala"
			_tmp51_ = _item_index;
#line 767 "../lib/PositionManager.vala"
			_tmp52_ = _item_size;
#line 767 "../lib/PositionManager.vala"
			if (!(_tmp51_ < _tmp52_)) {
#line 767 "../lib/PositionManager.vala"
				break;
#line 2869 "PositionManager.c"
			}
#line 767 "../lib/PositionManager.vala"
			_tmp53_ = _item_list;
#line 767 "../lib/PositionManager.vala"
			_tmp54_ = gee_abstract_list_get ((GeeAbstractList*) _tmp53_, _item_index);
#line 767 "../lib/PositionManager.vala"
			item = (PlankDockItem*) _tmp54_;
#line 768 "../lib/PositionManager.vala"
			_tmp55_ = plank_dock_item_draw_value_new ();
#line 768 "../lib/PositionManager.vala"
			val = _tmp55_;
#line 769 "../lib/PositionManager.vala"
			_tmp56_ = val;
#line 769 "../lib/PositionManager.vala"
			_tmp56_->opacity = 1.0;
#line 770 "../lib/PositionManager.vala"
			_tmp57_ = val;
#line 770 "../lib/PositionManager.vala"
			_tmp57_->darken = 0.0;
#line 771 "../lib/PositionManager.vala"
			_tmp58_ = val;
#line 771 "../lib/PositionManager.vala"
			_tmp58_->lighten = 0.0;
#line 772 "../lib/PositionManager.vala"
			_tmp59_ = val;
#line 772 "../lib/PositionManager.vala"
			_tmp59_->show_indicator = TRUE;
#line 773 "../lib/PositionManager.vala"
			_tmp60_ = val;
#line 773 "../lib/PositionManager.vala"
			_tmp60_->zoom = 1.0;
#line 775 "../lib/PositionManager.vala"
			_tmp61_ = val;
#line 775 "../lib/PositionManager.vala"
			_tmp62_ = center;
#line 775 "../lib/PositionManager.vala"
			_tmp61_->static_center = _tmp62_;
#line 778 "../lib/PositionManager.vala"
			_tmp63_ = cursor;
#line 778 "../lib/PositionManager.vala"
			cursor_position = (gdouble) _tmp63_.x;
#line 779 "../lib/PositionManager.vala"
			_tmp64_ = center;
#line 779 "../lib/PositionManager.vala"
			center_position = _tmp64_.x;
#line 782 "../lib/PositionManager.vala"
			offset = MIN (fabs (cursor_position - center_position), zoom_icon_size);
#line 785 "../lib/PositionManager.vala"
			if (expand_for_drop) {
#line 787 "../lib/PositionManager.vala"
				offset += (offset * zoom_icon_size) / icon_size;
#line 788 "../lib/PositionManager.vala"
				offset_percent = MIN (1.0, offset / (2.0 * zoom_icon_size));
#line 2923 "PositionManager.c"
			} else {
#line 790 "../lib/PositionManager.vala"
				offset_percent = offset / zoom_icon_size;
#line 2927 "PositionManager.c"
			}
#line 793 "../lib/PositionManager.vala"
			if (offset_percent > 0.99) {
#line 794 "../lib/PositionManager.vala"
				offset_percent = 1.0;
#line 2933 "PositionManager.c"
			}
#line 806 "../lib/PositionManager.vala"
			if (expand_for_drop) {
#line 807 "../lib/PositionManager.vala"
				offset *= zoom_in_progress / 2.0;
#line 2939 "PositionManager.c"
			} else {
#line 809 "../lib/PositionManager.vala"
				offset *= zoom_in_percent - 1.0;
#line 2943 "PositionManager.c"
			}
#line 810 "../lib/PositionManager.vala"
			offset *= 1.0 - (offset_percent / 3.0);
#line 812 "../lib/PositionManager.vala"
			if (cursor_position > center_position) {
#line 813 "../lib/PositionManager.vala"
				center_position -= offset;
#line 2951 "PositionManager.c"
			} else {
#line 815 "../lib/PositionManager.vala"
				center_position += offset;
#line 2955 "PositionManager.c"
			}
#line 822 "../lib/PositionManager.vala"
			zoom = 1.0 - pow (offset_percent, (gdouble) 2);
#line 825 "../lib/PositionManager.vala"
			zoom = 1.0 + (zoom * (zoom_in_percent - 1.0));
#line 827 "../lib/PositionManager.vala"
			zoomed_center_height = (icon_size * zoom) / 2.0;
#line 829 "../lib/PositionManager.vala"
			if (zoom == 1.0) {
#line 830 "../lib/PositionManager.vala"
				center_position = round (center_position);
#line 2967 "PositionManager.c"
			}
#line 832 "../lib/PositionManager.vala"
			_tmp65_ = val;
#line 832 "../lib/PositionManager.vala"
			_tmp66_.x = center_position;
#line 832 "../lib/PositionManager.vala"
			_tmp66_.y = zoomed_center_height;
#line 832 "../lib/PositionManager.vala"
			_tmp65_->center = _tmp66_;
#line 833 "../lib/PositionManager.vala"
			_tmp67_ = val;
#line 833 "../lib/PositionManager.vala"
			_tmp67_->zoom = zoom;
#line 834 "../lib/PositionManager.vala"
			_tmp68_ = val;
#line 834 "../lib/PositionManager.vala"
			_tmp68_->icon_size = round (zoom * icon_size);
#line 837 "../lib/PositionManager.vala"
			if (!plank_position_manager_is_horizontal_dock (self)) {
#line 2987 "PositionManager.c"
				gdouble tmp = 0.0;
				PlankDockItemDrawValue* _tmp69_;
				PlankPointD _tmp70_;
				PlankDockItemDrawValue* _tmp71_;
				PlankDockItemDrawValue* _tmp72_;
				PlankPointD _tmp73_;
				PlankDockItemDrawValue* _tmp74_;
				PlankDockItemDrawValue* _tmp75_;
				PlankPointD _tmp76_;
				PlankDockItemDrawValue* _tmp77_;
				PlankDockItemDrawValue* _tmp78_;
				PlankPointD _tmp79_;
				PlankDockItemDrawValue* _tmp80_;
#line 838 "../lib/PositionManager.vala"
				_tmp69_ = val;
#line 838 "../lib/PositionManager.vala"
				_tmp70_ = _tmp69_->center;
#line 838 "../lib/PositionManager.vala"
				tmp = _tmp70_.y;
#line 839 "../lib/PositionManager.vala"
				_tmp71_ = val;
#line 839 "../lib/PositionManager.vala"
				_tmp72_ = val;
#line 839 "../lib/PositionManager.vala"
				_tmp73_ = _tmp72_->center;
#line 839 "../lib/PositionManager.vala"
				_tmp71_->center.y = _tmp73_.x;
#line 840 "../lib/PositionManager.vala"
				_tmp74_ = val;
#line 840 "../lib/PositionManager.vala"
				_tmp74_->center.x = tmp;
#line 842 "../lib/PositionManager.vala"
				_tmp75_ = val;
#line 842 "../lib/PositionManager.vala"
				_tmp76_ = _tmp75_->static_center;
#line 842 "../lib/PositionManager.vala"
				tmp = _tmp76_.y;
#line 843 "../lib/PositionManager.vala"
				_tmp77_ = val;
#line 843 "../lib/PositionManager.vala"
				_tmp78_ = val;
#line 843 "../lib/PositionManager.vala"
				_tmp79_ = _tmp78_->static_center;
#line 843 "../lib/PositionManager.vala"
				_tmp77_->static_center.y = _tmp79_.x;
#line 844 "../lib/PositionManager.vala"
				_tmp80_ = val;
#line 844 "../lib/PositionManager.vala"
				_tmp80_->static_center.x = tmp;
#line 3037 "PositionManager.c"
			}
#line 847 "../lib/PositionManager.vala"
			_tmp81_ = self->priv->_Position;
#line 847 "../lib/PositionManager.vala"
			switch (_tmp81_) {
#line 847 "../lib/PositionManager.vala"
				case GTK_POS_RIGHT:
#line 3045 "PositionManager.c"
				{
					PlankDockItemDrawValue* _tmp82_;
					PlankDockItemDrawValue* _tmp83_;
					PlankPointD _tmp84_;
					PlankDockItemDrawValue* _tmp85_;
					PlankDockItemDrawValue* _tmp86_;
					PlankPointD _tmp87_;
#line 849 "../lib/PositionManager.vala"
					_tmp82_ = val;
#line 849 "../lib/PositionManager.vala"
					_tmp83_ = val;
#line 849 "../lib/PositionManager.vala"
					_tmp84_ = _tmp83_->center;
#line 849 "../lib/PositionManager.vala"
					_tmp82_->center.x = height - _tmp84_.x;
#line 850 "../lib/PositionManager.vala"
					_tmp85_ = val;
#line 850 "../lib/PositionManager.vala"
					_tmp86_ = val;
#line 850 "../lib/PositionManager.vala"
					_tmp87_ = _tmp86_->static_center;
#line 850 "../lib/PositionManager.vala"
					_tmp85_->static_center.x = height - _tmp87_.x;
#line 851 "../lib/PositionManager.vala"
					break;
#line 3071 "PositionManager.c"
				}
#line 847 "../lib/PositionManager.vala"
				case GTK_POS_BOTTOM:
#line 3075 "PositionManager.c"
				{
					PlankDockItemDrawValue* _tmp88_;
					PlankDockItemDrawValue* _tmp89_;
					PlankPointD _tmp90_;
					PlankDockItemDrawValue* _tmp91_;
					PlankDockItemDrawValue* _tmp92_;
					PlankPointD _tmp93_;
#line 853 "../lib/PositionManager.vala"
					_tmp88_ = val;
#line 853 "../lib/PositionManager.vala"
					_tmp89_ = val;
#line 853 "../lib/PositionManager.vala"
					_tmp90_ = _tmp89_->center;
#line 853 "../lib/PositionManager.vala"
					_tmp88_->center.y = height - _tmp90_.y;
#line 854 "../lib/PositionManager.vala"
					_tmp91_ = val;
#line 854 "../lib/PositionManager.vala"
					_tmp92_ = val;
#line 854 "../lib/PositionManager.vala"
					_tmp93_ = _tmp92_->static_center;
#line 854 "../lib/PositionManager.vala"
					_tmp91_->static_center.y = height - _tmp93_.y;
#line 855 "../lib/PositionManager.vala"
					break;
#line 3101 "PositionManager.c"
				}
				default:
				{
#line 857 "../lib/PositionManager.vala"
					break;
#line 3107 "PositionManager.c"
				}
			}
#line 861 "../lib/PositionManager.vala"
			_tmp94_ = val;
#line 861 "../lib/PositionManager.vala"
			_tmp95_ = self->priv->_Position;
#line 861 "../lib/PositionManager.vala"
			plank_dock_item_draw_value_move_in (_tmp94_, _tmp95_, (gdouble) self->priv->bottom_offset);
#line 864 "../lib/PositionManager.vala"
			if (func != NULL) {
#line 3118 "PositionManager.c"
				PlankDockItem* _tmp96_;
				PlankDockItemDrawValue* _tmp97_;
#line 865 "../lib/PositionManager.vala"
				_tmp96_ = item;
#line 865 "../lib/PositionManager.vala"
				_tmp97_ = val;
#line 865 "../lib/PositionManager.vala"
				func (_tmp96_, _tmp97_, func_target);
#line 3127 "PositionManager.c"
			}
#line 867 "../lib/PositionManager.vala"
			_tmp98_ = self->priv->draw_values;
#line 867 "../lib/PositionManager.vala"
			_tmp99_ = item;
#line 867 "../lib/PositionManager.vala"
			_tmp100_ = val;
#line 867 "../lib/PositionManager.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp98_, (PlankDockElement*) _tmp99_, _tmp100_);
#line 871 "../lib/PositionManager.vala"
			_tmp101_ = item;
#line 871 "../lib/PositionManager.vala"
			_tmp102_ = plank_dock_element_get_RemoveTime ((PlankDockElement*) _tmp101_);
#line 871 "../lib/PositionManager.vala"
			_tmp103_ = _tmp102_;
#line 871 "../lib/PositionManager.vala"
			if (_tmp103_ == ((gint64) 0)) {
#line 3145 "PositionManager.c"
				gint _tmp104_;
#line 872 "../lib/PositionManager.vala"
				_tmp104_ = self->priv->_ItemPadding;
#line 872 "../lib/PositionManager.vala"
				center.x = center.x + (icon_size + _tmp104_);
#line 3151 "PositionManager.c"
			}
#line 767 "../lib/PositionManager.vala"
			_plank_dock_item_draw_value_unref0 (val);
#line 3155 "PositionManager.c"
		}
	}
#line 875 "../lib/PositionManager.vala"
	if (post_func != NULL) {
#line 3160 "PositionManager.c"
		GeeHashMap* _tmp105_;
#line 876 "../lib/PositionManager.vala"
		_tmp105_ = self->priv->draw_values;
#line 876 "../lib/PositionManager.vala"
		post_func (_tmp105_, post_func_target);
#line 3166 "PositionManager.c"
	}
#line 878 "../lib/PositionManager.vala"
	_tmp106_ = self->priv->draw_values;
#line 878 "../lib/PositionManager.vala"
	_tmp107_ = gee_list_first ((GeeList*) items);
#line 878 "../lib/PositionManager.vala"
	_tmp108_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp106_, (PlankDockElement*) ((PlankDockItem*) _tmp107_));
#line 878 "../lib/PositionManager.vala"
	_tmp109_ = (PlankDockItemDrawValue*) _tmp108_;
#line 878 "../lib/PositionManager.vala"
	_tmp110_ = self->priv->draw_values;
#line 878 "../lib/PositionManager.vala"
	_tmp111_ = gee_list_last ((GeeList*) items);
#line 878 "../lib/PositionManager.vala"
	_tmp112_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp110_, (PlankDockElement*) ((PlankDockItem*) _tmp111_));
#line 878 "../lib/PositionManager.vala"
	_tmp113_ = (PlankDockItemDrawValue*) _tmp112_;
#line 878 "../lib/PositionManager.vala"
	plank_position_manager_update_background_region (self, _tmp109_, _tmp113_);
#line 878 "../lib/PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp113_);
#line 878 "../lib/PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp109_);
#line 881 "../lib/PositionManager.vala"
	_tmp114_ = self->priv->draw_values;
#line 881 "../lib/PositionManager.vala"
	_tmp115_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp114_);
#line 881 "../lib/PositionManager.vala"
	_tmp116_ = _tmp115_;
#line 881 "../lib/PositionManager.vala"
	gee_map_iterator_foreach (_tmp116_, ___lambda29__gee_forall_map_func, self);
#line 881 "../lib/PositionManager.vala"
	_g_object_unref0 (_tmp116_);
#line 3200 "PositionManager.c"
}

/**
 * The region for drawing a dock item.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_draw_region (PlankPositionManager* self,
                                             PlankDockItemDrawValue* val,
                                             GdkRectangle* result)
{
	gdouble width = 0.0;
	gdouble height = 0.0;
	PlankPointD _tmp0_;
	PlankPointD _tmp1_;
	GdkRectangle _tmp2_ = {0};
#line 894 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 894 "../lib/PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 896 "../lib/PositionManager.vala"
	width = val->icon_size;
#line 896 "../lib/PositionManager.vala"
	height = val->icon_size;
#line 898 "../lib/PositionManager.vala"
	_tmp0_ = val->center;
#line 898 "../lib/PositionManager.vala"
	_tmp1_ = val->center;
#line 898 "../lib/PositionManager.vala"
	_tmp2_.x = (gint) round (_tmp0_.x - (width / 2.0));
#line 898 "../lib/PositionManager.vala"
	_tmp2_.y = (gint) round (_tmp1_.y - (height / 2.0));
#line 898 "../lib/PositionManager.vala"
	_tmp2_.width = (gint) width;
#line 898 "../lib/PositionManager.vala"
	_tmp2_.height = (gint) height;
#line 898 "../lib/PositionManager.vala"
	*result = _tmp2_;
#line 898 "../lib/PositionManager.vala"
	return;
#line 3243 "PositionManager.c"
}

/**
 * The intersecting region of a dock item's hover region and the background.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_background_region (PlankPositionManager* self,
                                                   PlankDockItemDrawValue* val,
                                                   GdkRectangle* result)
{
	GdkRectangle rect = {0};
	GdkRectangle hover_region = {0};
	GdkRectangle _tmp0_;
	GtkPositionType _tmp1_;
	GdkRectangle _tmp16_;
	GdkRectangle _tmp17_ = {0};
	gboolean _tmp18_;
#line 910 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 910 "../lib/PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 913 "../lib/PositionManager.vala"
	_tmp0_ = val->hover_region;
#line 913 "../lib/PositionManager.vala"
	hover_region = _tmp0_;
#line 916 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 916 "../lib/PositionManager.vala"
	switch (_tmp1_) {
#line 3276 "PositionManager.c"
		default:
#line 916 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3280 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
#line 919 "../lib/PositionManager.vala"
			_tmp2_ = self->priv->background_rect;
#line 919 "../lib/PositionManager.vala"
			_tmp3_ = self->priv->background_rect;
#line 919 "../lib/PositionManager.vala"
			_tmp4_ = hover_region;
#line 919 "../lib/PositionManager.vala"
			hover_region.height = abs ((_tmp2_.y + _tmp3_.height) - _tmp4_.y);
#line 920 "../lib/PositionManager.vala"
			break;
#line 3295 "PositionManager.c"
		}
#line 916 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 3299 "PositionManager.c"
		{
			GdkRectangle _tmp5_;
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 922 "../lib/PositionManager.vala"
			_tmp5_ = self->priv->background_rect;
#line 922 "../lib/PositionManager.vala"
			hover_region.y = _tmp5_.y;
#line 923 "../lib/PositionManager.vala"
			_tmp6_ = hover_region;
#line 923 "../lib/PositionManager.vala"
			_tmp7_ = self->priv->background_rect;
#line 923 "../lib/PositionManager.vala"
			_tmp8_ = self->priv->background_rect;
#line 923 "../lib/PositionManager.vala"
			hover_region.height = abs ((_tmp6_.y - _tmp7_.y) + _tmp8_.height);
#line 924 "../lib/PositionManager.vala"
			break;
#line 3319 "PositionManager.c"
		}
#line 916 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 3323 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
#line 926 "../lib/PositionManager.vala"
			_tmp9_ = self->priv->background_rect;
#line 926 "../lib/PositionManager.vala"
			hover_region.x = _tmp9_.x;
#line 927 "../lib/PositionManager.vala"
			_tmp10_ = hover_region;
#line 927 "../lib/PositionManager.vala"
			_tmp11_ = self->priv->background_rect;
#line 927 "../lib/PositionManager.vala"
			_tmp12_ = self->priv->background_rect;
#line 927 "../lib/PositionManager.vala"
			hover_region.width = abs ((_tmp10_.x - _tmp11_.x) + _tmp12_.width);
#line 928 "../lib/PositionManager.vala"
			break;
#line 3343 "PositionManager.c"
		}
#line 916 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3347 "PositionManager.c"
		{
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 930 "../lib/PositionManager.vala"
			_tmp13_ = self->priv->background_rect;
#line 930 "../lib/PositionManager.vala"
			_tmp14_ = self->priv->background_rect;
#line 930 "../lib/PositionManager.vala"
			_tmp15_ = hover_region;
#line 930 "../lib/PositionManager.vala"
			hover_region.width = abs ((_tmp13_.x + _tmp14_.width) - _tmp15_.x);
#line 931 "../lib/PositionManager.vala"
			break;
#line 3362 "PositionManager.c"
		}
	}
#line 934 "../lib/PositionManager.vala"
	_tmp16_ = self->priv->background_rect;
#line 934 "../lib/PositionManager.vala"
	_tmp18_ = gdk_rectangle_intersect (&hover_region, &_tmp16_, &_tmp17_);
#line 934 "../lib/PositionManager.vala"
	rect = _tmp17_;
#line 934 "../lib/PositionManager.vala"
	if (!_tmp18_) {
#line 3373 "PositionManager.c"
		GdkRectangle _tmp19_ = {0};
#line 935 "../lib/PositionManager.vala"
		*result = _tmp19_;
#line 935 "../lib/PositionManager.vala"
		return;
#line 3379 "PositionManager.c"
	}
#line 937 "../lib/PositionManager.vala"
	*result = rect;
#line 937 "../lib/PositionManager.vala"
	return;
#line 3385 "PositionManager.c"
}

/**
 * The cursor region for interacting with a dock element.
 *
 * @param val the item's DockItemDrawValue
 * @return the region for the dock item
 */
static void
plank_position_manager_get_item_hover_region (PlankPositionManager* self,
                                              PlankDockItemDrawValue* val,
                                              GdkRectangle* result)
{
	GdkRectangle rect = {0};
	gint item_padding = 0;
	gint _tmp0_;
	gint _tmp1_ = 0;
	gint top_padding = 0;
	gint bottom_padding = 0;
	gdouble width = 0.0;
	gdouble height = 0.0;
	GtkPositionType _tmp2_;
	PlankPointD _tmp3_;
	PlankPointD _tmp4_;
	GdkRectangle _tmp5_ = {0};
	GtkPositionType _tmp6_;
	GdkRectangle background_region = {0};
	GdkRectangle _tmp7_ = {0};
	GdkRectangle _tmp8_ = {0};
	gboolean _tmp9_;
#line 946 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 946 "../lib/PositionManager.vala"
	g_return_if_fail (val != NULL);
#line 950 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_ItemPadding;
#line 950 "../lib/PositionManager.vala"
	item_padding = _tmp0_;
#line 951 "../lib/PositionManager.vala"
	if (self->priv->top_offset < 0) {
#line 951 "../lib/PositionManager.vala"
		_tmp1_ = 0;
#line 3428 "PositionManager.c"
	} else {
#line 951 "../lib/PositionManager.vala"
		_tmp1_ = self->priv->top_offset;
#line 3432 "PositionManager.c"
	}
#line 951 "../lib/PositionManager.vala"
	top_padding = _tmp1_;
#line 952 "../lib/PositionManager.vala"
	bottom_padding = self->priv->bottom_offset;
#line 953 "../lib/PositionManager.vala"
	width = val->icon_size;
#line 953 "../lib/PositionManager.vala"
	height = val->icon_size;
#line 956 "../lib/PositionManager.vala"
	_tmp2_ = self->priv->_Position;
#line 956 "../lib/PositionManager.vala"
	switch (_tmp2_) {
#line 3446 "PositionManager.c"
		default:
#line 956 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3450 "PositionManager.c"
		{
#line 959 "../lib/PositionManager.vala"
			width += (gdouble) item_padding;
#line 960 "../lib/PositionManager.vala"
			break;
#line 3456 "PositionManager.c"
		}
#line 956 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 3460 "PositionManager.c"
		{
#line 962 "../lib/PositionManager.vala"
			width += (gdouble) item_padding;
#line 963 "../lib/PositionManager.vala"
			break;
#line 3466 "PositionManager.c"
		}
#line 956 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 3470 "PositionManager.c"
		{
#line 965 "../lib/PositionManager.vala"
			height += (gdouble) item_padding;
#line 966 "../lib/PositionManager.vala"
			break;
#line 3476 "PositionManager.c"
		}
#line 956 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3480 "PositionManager.c"
		{
#line 968 "../lib/PositionManager.vala"
			height += (gdouble) item_padding;
#line 969 "../lib/PositionManager.vala"
			break;
#line 3486 "PositionManager.c"
		}
	}
#line 972 "../lib/PositionManager.vala"
	_tmp3_ = val->center;
#line 972 "../lib/PositionManager.vala"
	_tmp4_ = val->center;
#line 972 "../lib/PositionManager.vala"
	_tmp5_.x = (gint) round (_tmp3_.x - (width / 2.0));
#line 972 "../lib/PositionManager.vala"
	_tmp5_.y = (gint) round (_tmp4_.y - (height / 2.0));
#line 972 "../lib/PositionManager.vala"
	_tmp5_.width = (gint) width;
#line 972 "../lib/PositionManager.vala"
	_tmp5_.height = (gint) height;
#line 972 "../lib/PositionManager.vala"
	rect = _tmp5_;
#line 978 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 978 "../lib/PositionManager.vala"
	switch (_tmp6_) {
#line 3507 "PositionManager.c"
		default:
#line 978 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 3511 "PositionManager.c"
		{
#line 981 "../lib/PositionManager.vala"
			rect.y = rect.y - top_padding;
#line 982 "../lib/PositionManager.vala"
			rect.height = rect.height + (bottom_padding + top_padding);
#line 983 "../lib/PositionManager.vala"
			break;
#line 3519 "PositionManager.c"
		}
#line 978 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 3523 "PositionManager.c"
		{
#line 985 "../lib/PositionManager.vala"
			rect.y = rect.y - bottom_padding;
#line 986 "../lib/PositionManager.vala"
			rect.height = rect.height + (bottom_padding + top_padding);
#line 987 "../lib/PositionManager.vala"
			break;
#line 3531 "PositionManager.c"
		}
#line 978 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 3535 "PositionManager.c"
		{
#line 989 "../lib/PositionManager.vala"
			rect.x = rect.x - bottom_padding;
#line 990 "../lib/PositionManager.vala"
			rect.width = rect.width + (bottom_padding + top_padding);
#line 991 "../lib/PositionManager.vala"
			break;
#line 3543 "PositionManager.c"
		}
#line 978 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 3547 "PositionManager.c"
		{
#line 993 "../lib/PositionManager.vala"
			rect.x = rect.x - top_padding;
#line 994 "../lib/PositionManager.vala"
			rect.width = rect.width + (bottom_padding + top_padding);
#line 995 "../lib/PositionManager.vala"
			break;
#line 3555 "PositionManager.c"
		}
	}
#line 1000 "../lib/PositionManager.vala"
	plank_position_manager_get_background_region (self, &_tmp7_);
#line 1000 "../lib/PositionManager.vala"
	_tmp9_ = gdk_rectangle_intersect (&rect, &_tmp7_, &_tmp8_);
#line 1000 "../lib/PositionManager.vala"
	background_region = _tmp8_;
#line 1000 "../lib/PositionManager.vala"
	if (_tmp9_) {
#line 3566 "PositionManager.c"
		GdkRectangle _tmp10_ = {0};
		GdkRectangle _tmp11_ = {0};
#line 1001 "../lib/PositionManager.vala"
		plank_position_manager_get_item_draw_region (self, val, &_tmp10_);
#line 1001 "../lib/PositionManager.vala"
		gdk_rectangle_union (&background_region, &_tmp10_, &_tmp11_);
#line 1001 "../lib/PositionManager.vala"
		rect = _tmp11_;
#line 3575 "PositionManager.c"
	}
#line 1003 "../lib/PositionManager.vala"
	*result = rect;
#line 1003 "../lib/PositionManager.vala"
	return;
#line 3581 "PositionManager.c"
}

/**
 * The cursor region for interacting with a dock element.
 *
 * @param element the dock element to find a region for
 * @return the region for the dock item
 */
void
plank_position_manager_get_hover_region_for_element (PlankPositionManager* self,
                                                     PlankDockElement* element,
                                                     GdkRectangle* result)
{
	PlankDockItem* item = NULL;
	PlankDockItem* _tmp0_;
	PlankDockContainer* container = NULL;
	PlankDockContainer* _tmp6_;
	GeeArrayList* items = NULL;
	PlankDockContainer* _tmp8_;
	GeeArrayList* _tmp9_;
	GeeArrayList* _tmp10_;
	GeeArrayList* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	GdkRectangle first_rect = {0};
	GeeArrayList* _tmp15_;
	gpointer _tmp16_;
	PlankDockElement* _tmp17_;
	GdkRectangle _tmp18_ = {0};
	GdkRectangle _tmp19_;
	GeeArrayList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GdkRectangle last_rect = {0};
	GeeArrayList* _tmp23_;
	gpointer _tmp24_;
	PlankDockElement* _tmp25_;
	GdkRectangle _tmp26_ = {0};
	GdkRectangle _tmp27_;
	GdkRectangle _result_ = {0};
	GdkRectangle _tmp28_;
	GdkRectangle _tmp29_ = {0};
#line 1012 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../lib/PositionManager.vala"
	g_return_if_fail (element != NULL);
#line 1014 "../lib/PositionManager.vala"
	item = PLANK_IS_DOCK_ITEM (element) ? ((PlankDockItem*) element) : NULL;
#line 1015 "../lib/PositionManager.vala"
	_tmp0_ = item;
#line 1015 "../lib/PositionManager.vala"
	if (_tmp0_ != NULL) {
#line 3634 "PositionManager.c"
		PlankDockItem* _tmp1_;
		PlankDockItemDrawValue* _tmp2_;
		PlankDockItemDrawValue* _tmp3_;
		GdkRectangle _tmp4_;
		GdkRectangle _tmp5_;
#line 1016 "../lib/PositionManager.vala"
		_tmp1_ = item;
#line 1016 "../lib/PositionManager.vala"
		_tmp2_ = plank_position_manager_get_draw_value_for_item (self, _tmp1_);
#line 1016 "../lib/PositionManager.vala"
		_tmp3_ = _tmp2_;
#line 1016 "../lib/PositionManager.vala"
		_tmp4_ = _tmp3_->hover_region;
#line 1016 "../lib/PositionManager.vala"
		_tmp5_ = _tmp4_;
#line 1016 "../lib/PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (_tmp3_);
#line 1016 "../lib/PositionManager.vala"
		*result = _tmp5_;
#line 1016 "../lib/PositionManager.vala"
		return;
#line 3656 "PositionManager.c"
	}
#line 1018 "../lib/PositionManager.vala"
	container = PLANK_IS_DOCK_CONTAINER (element) ? ((PlankDockContainer*) element) : NULL;
#line 1019 "../lib/PositionManager.vala"
	_tmp6_ = container;
#line 1019 "../lib/PositionManager.vala"
	if (_tmp6_ == NULL) {
#line 3664 "PositionManager.c"
		GdkRectangle _tmp7_ = {0};
#line 1020 "../lib/PositionManager.vala"
		*result = _tmp7_;
#line 1020 "../lib/PositionManager.vala"
		return;
#line 3670 "PositionManager.c"
	}
#line 1022 "../lib/PositionManager.vala"
	_tmp8_ = container;
#line 1022 "../lib/PositionManager.vala"
	_tmp9_ = plank_dock_container_get_VisibleElements (_tmp8_);
#line 1022 "../lib/PositionManager.vala"
	_tmp10_ = _tmp9_;
#line 1022 "../lib/PositionManager.vala"
	items = _tmp10_;
#line 1024 "../lib/PositionManager.vala"
	_tmp11_ = items;
#line 1024 "../lib/PositionManager.vala"
	_tmp12_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp11_);
#line 1024 "../lib/PositionManager.vala"
	_tmp13_ = _tmp12_;
#line 1024 "../lib/PositionManager.vala"
	if (_tmp13_ == 0) {
#line 3688 "PositionManager.c"
		GdkRectangle _tmp14_ = {0};
#line 1025 "../lib/PositionManager.vala"
		*result = _tmp14_;
#line 1025 "../lib/PositionManager.vala"
		return;
#line 3694 "PositionManager.c"
	}
#line 1027 "../lib/PositionManager.vala"
	_tmp15_ = items;
#line 1027 "../lib/PositionManager.vala"
	_tmp16_ = gee_list_first ((GeeList*) _tmp15_);
#line 1027 "../lib/PositionManager.vala"
	_tmp17_ = (PlankDockElement*) _tmp16_;
#line 1027 "../lib/PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, _tmp17_, &_tmp18_);
#line 1027 "../lib/PositionManager.vala"
	_tmp19_ = _tmp18_;
#line 1027 "../lib/PositionManager.vala"
	_g_object_unref0 (_tmp17_);
#line 1027 "../lib/PositionManager.vala"
	first_rect = _tmp19_;
#line 1028 "../lib/PositionManager.vala"
	_tmp20_ = items;
#line 1028 "../lib/PositionManager.vala"
	_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 1028 "../lib/PositionManager.vala"
	_tmp22_ = _tmp21_;
#line 1028 "../lib/PositionManager.vala"
	if (_tmp22_ == 1) {
#line 1029 "../lib/PositionManager.vala"
		*result = first_rect;
#line 1029 "../lib/PositionManager.vala"
		return;
#line 3722 "PositionManager.c"
	}
#line 1031 "../lib/PositionManager.vala"
	_tmp23_ = items;
#line 1031 "../lib/PositionManager.vala"
	_tmp24_ = gee_list_last ((GeeList*) _tmp23_);
#line 1031 "../lib/PositionManager.vala"
	_tmp25_ = (PlankDockElement*) _tmp24_;
#line 1031 "../lib/PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, _tmp25_, &_tmp26_);
#line 1031 "../lib/PositionManager.vala"
	_tmp27_ = _tmp26_;
#line 1031 "../lib/PositionManager.vala"
	_g_object_unref0 (_tmp25_);
#line 1031 "../lib/PositionManager.vala"
	last_rect = _tmp27_;
#line 1034 "../lib/PositionManager.vala"
	_tmp28_ = last_rect;
#line 1034 "../lib/PositionManager.vala"
	gdk_rectangle_union (&first_rect, &_tmp28_, &_tmp29_);
#line 1034 "../lib/PositionManager.vala"
	_result_ = _tmp29_;
#line 1035 "../lib/PositionManager.vala"
	*result = _result_;
#line 1035 "../lib/PositionManager.vala"
	return;
#line 3748 "PositionManager.c"
}

/**
 * Get the item which is the nearest at the given coordinates. If a container is given
 * the result will be restricted to its children.
 *
 * @param x the x position
 * @param y the y position
 * @param container a container or NULL 
 */
PlankDockItem*
plank_position_manager_get_nearest_item_at (PlankPositionManager* self,
                                            gint x,
                                            gint y,
                                            PlankDockContainer* container)
{
	PlankDockItem* _result_ = NULL;
	gdouble square_distance = 0.0;
	GeeMapIterator* draw_values_it = NULL;
	GeeHashMap* _tmp0_;
	GeeMapIterator* _tmp1_;
	PlankDockItem* _tmp21_;
	PlankDockItem* result;
#line 1046 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1048 "../lib/PositionManager.vala"
	_result_ = NULL;
#line 1049 "../lib/PositionManager.vala"
	square_distance = DBL_MAX;
#line 1051 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->draw_values;
#line 1051 "../lib/PositionManager.vala"
	_tmp1_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp0_);
#line 1051 "../lib/PositionManager.vala"
	draw_values_it = _tmp1_;
#line 1052 "../lib/PositionManager.vala"
	while (TRUE) {
#line 3786 "PositionManager.c"
		GeeMapIterator* _tmp2_;
		PlankDockItemDrawValue* val = NULL;
		GeeMapIterator* _tmp3_;
		gpointer _tmp4_;
		PlankPointD center = {0};
		PlankDockItemDrawValue* _tmp5_;
		PlankPointD _tmp6_;
		gdouble new_square_distance = 0.0;
		PlankPointD _tmp7_;
		PlankPointD _tmp8_;
		PlankPointD _tmp9_;
		PlankPointD _tmp10_;
#line 1052 "../lib/PositionManager.vala"
		_tmp2_ = draw_values_it;
#line 1052 "../lib/PositionManager.vala"
		if (!gee_map_iterator_next (_tmp2_)) {
#line 1052 "../lib/PositionManager.vala"
			break;
#line 3805 "PositionManager.c"
		}
#line 1053 "../lib/PositionManager.vala"
		_tmp3_ = draw_values_it;
#line 1053 "../lib/PositionManager.vala"
		_tmp4_ = gee_map_iterator_get_value (_tmp3_);
#line 1053 "../lib/PositionManager.vala"
		val = (PlankDockItemDrawValue*) _tmp4_;
#line 1054 "../lib/PositionManager.vala"
		_tmp5_ = val;
#line 1054 "../lib/PositionManager.vala"
		_tmp6_ = _tmp5_->static_center;
#line 1054 "../lib/PositionManager.vala"
		center = _tmp6_;
#line 1055 "../lib/PositionManager.vala"
		_tmp7_ = center;
#line 1055 "../lib/PositionManager.vala"
		_tmp8_ = center;
#line 1055 "../lib/PositionManager.vala"
		_tmp9_ = center;
#line 1055 "../lib/PositionManager.vala"
		_tmp10_ = center;
#line 1055 "../lib/PositionManager.vala"
		new_square_distance = ((x - _tmp7_.x) * (x - _tmp8_.x)) + ((y - _tmp9_.y) * (y - _tmp10_.y));
#line 1056 "../lib/PositionManager.vala"
		if (square_distance > new_square_distance) {
#line 3831 "PositionManager.c"
			PlankDockItem* item = NULL;
			GeeMapIterator* _tmp11_;
			gpointer _tmp12_;
			PlankDockElement* _tmp13_;
			PlankDockItem* _tmp14_;
			PlankDockItem* _tmp15_;
			gboolean _tmp16_ = FALSE;
#line 1057 "../lib/PositionManager.vala"
			_tmp11_ = draw_values_it;
#line 1057 "../lib/PositionManager.vala"
			_tmp12_ = gee_map_iterator_get_key (_tmp11_);
#line 1057 "../lib/PositionManager.vala"
			_tmp13_ = (PlankDockElement*) _tmp12_;
#line 1057 "../lib/PositionManager.vala"
			_tmp14_ = PLANK_IS_DOCK_ITEM (_tmp13_) ? ((PlankDockItem*) _tmp13_) : NULL;
#line 1057 "../lib/PositionManager.vala"
			if (_tmp14_ == NULL) {
#line 1057 "../lib/PositionManager.vala"
				_g_object_unref0 (_tmp13_);
#line 3851 "PositionManager.c"
			}
#line 1057 "../lib/PositionManager.vala"
			item = _tmp14_;
#line 1058 "../lib/PositionManager.vala"
			_tmp15_ = item;
#line 1058 "../lib/PositionManager.vala"
			if (_tmp15_ == NULL) {
#line 1059 "../lib/PositionManager.vala"
				_g_object_unref0 (item);
#line 1059 "../lib/PositionManager.vala"
				_plank_dock_item_draw_value_unref0 (val);
#line 1059 "../lib/PositionManager.vala"
				continue;
#line 3865 "PositionManager.c"
			}
#line 1060 "../lib/PositionManager.vala"
			if (container == NULL) {
#line 1060 "../lib/PositionManager.vala"
				_tmp16_ = TRUE;
#line 3871 "PositionManager.c"
			} else {
				PlankDockItem* _tmp17_;
				PlankDockContainer* _tmp18_;
				PlankDockContainer* _tmp19_;
#line 1060 "../lib/PositionManager.vala"
				_tmp17_ = item;
#line 1060 "../lib/PositionManager.vala"
				_tmp18_ = plank_dock_element_get_Container ((PlankDockElement*) _tmp17_);
#line 1060 "../lib/PositionManager.vala"
				_tmp19_ = _tmp18_;
#line 1060 "../lib/PositionManager.vala"
				_tmp16_ = _tmp19_ == container;
#line 3884 "PositionManager.c"
			}
#line 1060 "../lib/PositionManager.vala"
			if (_tmp16_) {
#line 3888 "PositionManager.c"
				PlankDockItem* _tmp20_;
#line 1061 "../lib/PositionManager.vala"
				square_distance = new_square_distance;
#line 1062 "../lib/PositionManager.vala"
				_tmp20_ = item;
#line 1062 "../lib/PositionManager.vala"
				_result_ = _tmp20_;
#line 3896 "PositionManager.c"
			}
#line 1056 "../lib/PositionManager.vala"
			_g_object_unref0 (item);
#line 3900 "PositionManager.c"
		}
#line 1052 "../lib/PositionManager.vala"
		_plank_dock_item_draw_value_unref0 (val);
#line 3904 "PositionManager.c"
	}
#line 1067 "../lib/PositionManager.vala"
	_tmp21_ = _result_;
#line 1067 "../lib/PositionManager.vala"
	result = _tmp21_;
#line 1067 "../lib/PositionManager.vala"
	_g_object_unref0 (draw_values_it);
#line 1067 "../lib/PositionManager.vala"
	return result;
#line 3914 "PositionManager.c"
}

/**
 * Get the item which is the appropriate target for a drag'n'drop action.
 * The returned item may not hovered and is meant to be used as target
 * for e.g. DockContainer.add/move_to functions.
 * If a container is given the result will be restricted to its children.
 *
 * @param container a container or NULL 
 */
PlankDockItem*
plank_position_manager_get_current_target_item (PlankPositionManager* self,
                                                PlankDockContainer* container)
{
	PlankDockRenderer* renderer = NULL;
	PlankDockController* _tmp0_;
	PlankDockRenderer* _tmp1_;
	PlankDockRenderer* _tmp2_;
	GdkPoint cursor = {0};
	GdkPoint _tmp3_ = {0};
	GdkPoint _tmp4_;
	gint offset = 0;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GdkPoint _tmp9_;
	GdkPoint _tmp10_;
	PlankDockItem* _tmp11_;
	PlankDockItem* result;
#line 1078 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1080 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1080 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_renderer (_tmp0_);
#line 1080 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1080 "../lib/PositionManager.vala"
	renderer = _tmp2_;
#line 1081 "../lib/PositionManager.vala"
	plank_dock_renderer_get_local_cursor (renderer, &_tmp3_);
#line 1081 "../lib/PositionManager.vala"
	_tmp4_ = _tmp3_;
#line 1081 "../lib/PositionManager.vala"
	cursor = _tmp4_;
#line 1082 "../lib/PositionManager.vala"
	_tmp5_ = plank_dock_renderer_get_zoom_in_progress (renderer);
#line 1082 "../lib/PositionManager.vala"
	_tmp6_ = _tmp5_;
#line 1082 "../lib/PositionManager.vala"
	_tmp7_ = self->priv->_ZoomIconSize;
#line 1082 "../lib/PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 1082 "../lib/PositionManager.vala"
	offset = (gint) (((_tmp6_ * _tmp7_) + _tmp8_) / 2.0);
#line 1084 "../lib/PositionManager.vala"
	_tmp9_ = cursor;
#line 1084 "../lib/PositionManager.vala"
	_tmp10_ = cursor;
#line 1084 "../lib/PositionManager.vala"
	_tmp11_ = plank_position_manager_get_nearest_item_at (self, _tmp9_.x + offset, _tmp10_.y + offset, container);
#line 1084 "../lib/PositionManager.vala"
	result = _tmp11_;
#line 1084 "../lib/PositionManager.vala"
	return result;
#line 3981 "PositionManager.c"
}

/**
 * Get's the x and y position to display a menu for a dock item.
 *
 * @param hovered the item that is hovered
 * @param requisition the menu's requisition
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_menu_position (PlankPositionManager* self,
                                          PlankDockItem* hovered,
                                          GtkRequisition* requisition,
                                          gint* x,
                                          gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	gint offset = 0;
	GtkPositionType _tmp1_;
#line 1095 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1095 "../lib/PositionManager.vala"
	g_return_if_fail (hovered != NULL);
#line 1095 "../lib/PositionManager.vala"
	g_return_if_fail (requisition != NULL);
#line 1097 "../lib/PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) hovered, &_tmp0_);
#line 1097 "../lib/PositionManager.vala"
	rect = _tmp0_;
#line 1099 "../lib/PositionManager.vala"
	offset = 10;
#line 1100 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1100 "../lib/PositionManager.vala"
	switch (_tmp1_) {
#line 4021 "PositionManager.c"
		default:
#line 1100 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4025 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GtkRequisition _tmp4_;
			GdkRectangle _tmp5_;
			GtkRequisition _tmp6_;
#line 1103 "../lib/PositionManager.vala"
			_tmp2_ = rect;
#line 1103 "../lib/PositionManager.vala"
			_tmp3_ = rect;
#line 1103 "../lib/PositionManager.vala"
			_tmp4_ = *requisition;
#line 1103 "../lib/PositionManager.vala"
			_vala_x = (self->priv->win_x + _tmp2_.x) + ((_tmp3_.width - _tmp4_.width) / 2);
#line 1104 "../lib/PositionManager.vala"
			_tmp5_ = rect;
#line 1104 "../lib/PositionManager.vala"
			_tmp6_ = *requisition;
#line 1104 "../lib/PositionManager.vala"
			_vala_y = ((self->priv->win_y + _tmp5_.y) - _tmp6_.height) - offset;
#line 1105 "../lib/PositionManager.vala"
			break;
#line 4048 "PositionManager.c"
		}
#line 1100 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4052 "PositionManager.c"
		{
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
			GtkRequisition _tmp9_;
			GdkRectangle _tmp10_;
#line 1107 "../lib/PositionManager.vala"
			_tmp7_ = rect;
#line 1107 "../lib/PositionManager.vala"
			_tmp8_ = rect;
#line 1107 "../lib/PositionManager.vala"
			_tmp9_ = *requisition;
#line 1107 "../lib/PositionManager.vala"
			_vala_x = (self->priv->win_x + _tmp7_.x) + ((_tmp8_.width - _tmp9_.width) / 2);
#line 1108 "../lib/PositionManager.vala"
			_tmp10_ = rect;
#line 1108 "../lib/PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp10_.height) + offset;
#line 1109 "../lib/PositionManager.vala"
			break;
#line 4072 "PositionManager.c"
		}
#line 1100 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4076 "PositionManager.c"
		{
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
			GtkRequisition _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 1111 "../lib/PositionManager.vala"
			_tmp11_ = rect;
#line 1111 "../lib/PositionManager.vala"
			_tmp12_ = rect;
#line 1111 "../lib/PositionManager.vala"
			_tmp13_ = *requisition;
#line 1111 "../lib/PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp11_.y) + ((_tmp12_.height - _tmp13_.height) / 2);
#line 1112 "../lib/PositionManager.vala"
			_tmp14_ = rect;
#line 1112 "../lib/PositionManager.vala"
			_tmp15_ = rect;
#line 1112 "../lib/PositionManager.vala"
			_vala_x = ((self->priv->win_x + _tmp14_.x) + _tmp15_.width) + offset;
#line 1113 "../lib/PositionManager.vala"
			break;
#line 4099 "PositionManager.c"
		}
#line 1100 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4103 "PositionManager.c"
		{
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
			GtkRequisition _tmp18_;
			GdkRectangle _tmp19_;
			GtkRequisition _tmp20_;
#line 1115 "../lib/PositionManager.vala"
			_tmp16_ = rect;
#line 1115 "../lib/PositionManager.vala"
			_tmp17_ = rect;
#line 1115 "../lib/PositionManager.vala"
			_tmp18_ = *requisition;
#line 1115 "../lib/PositionManager.vala"
			_vala_y = (self->priv->win_y + _tmp16_.y) + ((_tmp17_.height - _tmp18_.height) / 2);
#line 1116 "../lib/PositionManager.vala"
			_tmp19_ = rect;
#line 1116 "../lib/PositionManager.vala"
			_tmp20_ = *requisition;
#line 1116 "../lib/PositionManager.vala"
			_vala_x = ((self->priv->win_x + _tmp19_.x) - _tmp20_.width) - offset;
#line 1117 "../lib/PositionManager.vala"
			break;
#line 4126 "PositionManager.c"
		}
	}
#line 1095 "../lib/PositionManager.vala"
	if (x) {
#line 1095 "../lib/PositionManager.vala"
		*x = _vala_x;
#line 4133 "PositionManager.c"
	}
#line 1095 "../lib/PositionManager.vala"
	if (y) {
#line 1095 "../lib/PositionManager.vala"
		*y = _vala_y;
#line 4139 "PositionManager.c"
	}
}

/**
 * Get's the x and y position to display a hover window for a dock item.
 *
 * @param hovered the item that is hovered
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_hover_position (PlankPositionManager* self,
                                           PlankDockItem* hovered,
                                           gint* x,
                                           gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	PlankPointD center = {0};
	PlankDockItemDrawValue* _tmp0_;
	PlankDockItemDrawValue* _tmp1_;
	PlankPointD _tmp2_;
	PlankPointD _tmp3_;
	gdouble offset = 0.0;
	gint _tmp4_;
	gint _tmp5_;
	GtkPositionType _tmp6_;
#line 1128 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1128 "../lib/PositionManager.vala"
	g_return_if_fail (hovered != NULL);
#line 1130 "../lib/PositionManager.vala"
	_tmp0_ = plank_position_manager_get_draw_value_for_item (self, hovered);
#line 1130 "../lib/PositionManager.vala"
	_tmp1_ = _tmp0_;
#line 1130 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_->static_center;
#line 1130 "../lib/PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 1130 "../lib/PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp1_);
#line 1130 "../lib/PositionManager.vala"
	center = _tmp3_;
#line 1131 "../lib/PositionManager.vala"
	_tmp4_ = self->priv->_ZoomIconSize;
#line 1131 "../lib/PositionManager.vala"
	_tmp5_ = self->priv->_IconSize;
#line 1131 "../lib/PositionManager.vala"
	offset = _tmp4_ - (_tmp5_ / 2.0);
#line 1133 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 1133 "../lib/PositionManager.vala"
	switch (_tmp6_) {
#line 4193 "PositionManager.c"
		default:
#line 1133 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4197 "PositionManager.c"
		{
			PlankPointD _tmp7_;
			PlankPointD _tmp8_;
#line 1136 "../lib/PositionManager.vala"
			_tmp7_ = center;
#line 1136 "../lib/PositionManager.vala"
			_vala_x = (gint) round (_tmp7_.x + self->priv->win_x);
#line 1137 "../lib/PositionManager.vala"
			_tmp8_ = center;
#line 1137 "../lib/PositionManager.vala"
			_vala_y = (gint) round ((_tmp8_.y + self->priv->win_y) - offset);
#line 1138 "../lib/PositionManager.vala"
			break;
#line 4211 "PositionManager.c"
		}
#line 1133 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4215 "PositionManager.c"
		{
			PlankPointD _tmp9_;
			PlankPointD _tmp10_;
#line 1140 "../lib/PositionManager.vala"
			_tmp9_ = center;
#line 1140 "../lib/PositionManager.vala"
			_vala_x = (gint) round (_tmp9_.x + self->priv->win_x);
#line 1141 "../lib/PositionManager.vala"
			_tmp10_ = center;
#line 1141 "../lib/PositionManager.vala"
			_vala_y = (gint) round ((_tmp10_.y + self->priv->win_y) + offset);
#line 1142 "../lib/PositionManager.vala"
			break;
#line 4229 "PositionManager.c"
		}
#line 1133 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4233 "PositionManager.c"
		{
			PlankPointD _tmp11_;
			PlankPointD _tmp12_;
#line 1144 "../lib/PositionManager.vala"
			_tmp11_ = center;
#line 1144 "../lib/PositionManager.vala"
			_vala_x = (gint) round ((_tmp11_.x + self->priv->win_x) + offset);
#line 1145 "../lib/PositionManager.vala"
			_tmp12_ = center;
#line 1145 "../lib/PositionManager.vala"
			_vala_y = (gint) round (_tmp12_.y + self->priv->win_y);
#line 1146 "../lib/PositionManager.vala"
			break;
#line 4247 "PositionManager.c"
		}
#line 1133 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4251 "PositionManager.c"
		{
			PlankPointD _tmp13_;
			PlankPointD _tmp14_;
#line 1148 "../lib/PositionManager.vala"
			_tmp13_ = center;
#line 1148 "../lib/PositionManager.vala"
			_vala_x = (gint) round ((_tmp13_.x + self->priv->win_x) - offset);
#line 1149 "../lib/PositionManager.vala"
			_tmp14_ = center;
#line 1149 "../lib/PositionManager.vala"
			_vala_y = (gint) round (_tmp14_.y + self->priv->win_y);
#line 1150 "../lib/PositionManager.vala"
			break;
#line 4265 "PositionManager.c"
		}
	}
#line 1128 "../lib/PositionManager.vala"
	if (x) {
#line 1128 "../lib/PositionManager.vala"
		*x = _vala_x;
#line 4272 "PositionManager.c"
	}
#line 1128 "../lib/PositionManager.vala"
	if (y) {
#line 1128 "../lib/PositionManager.vala"
		*y = _vala_y;
#line 4278 "PositionManager.c"
	}
}

/**
 * Get's the x and y position to display a hover window for the given coordinates.
 *
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_hover_position_at (PlankPositionManager* self,
                                              gint* x,
                                              gint* y)
{
	PlankPointD center = {0};
	PlankDockController* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
	gpointer _tmp3_;
	PlankDockItemDrawValue* _tmp4_;
	PlankDockItemDrawValue* _tmp5_;
	PlankPointD _tmp6_;
	PlankPointD _tmp7_;
	gdouble offset = 0.0;
	gint _tmp8_;
	gint _tmp9_;
	GtkPositionType _tmp10_;
#line 1160 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1163 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1163 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_VisibleItems (_tmp0_);
#line 1163 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1163 "../lib/PositionManager.vala"
	_tmp3_ = gee_list_first ((GeeList*) _tmp2_);
#line 1163 "../lib/PositionManager.vala"
	_tmp4_ = plank_position_manager_get_draw_value_for_item (self, (PlankDockItem*) _tmp3_);
#line 1163 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 1163 "../lib/PositionManager.vala"
	_tmp6_ = _tmp5_->static_center;
#line 1163 "../lib/PositionManager.vala"
	_tmp7_ = _tmp6_;
#line 1163 "../lib/PositionManager.vala"
	_plank_dock_item_draw_value_unref0 (_tmp5_);
#line 1163 "../lib/PositionManager.vala"
	center = _tmp7_;
#line 1164 "../lib/PositionManager.vala"
	_tmp8_ = self->priv->_ZoomIconSize;
#line 1164 "../lib/PositionManager.vala"
	_tmp9_ = self->priv->_IconSize;
#line 1164 "../lib/PositionManager.vala"
	offset = _tmp8_ - (_tmp9_ / 2.0);
#line 1166 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_Position;
#line 1166 "../lib/PositionManager.vala"
	switch (_tmp10_) {
#line 4338 "PositionManager.c"
		default:
#line 1166 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4342 "PositionManager.c"
		{
			PlankPointD _tmp11_;
#line 1169 "../lib/PositionManager.vala"
			_tmp11_ = center;
#line 1169 "../lib/PositionManager.vala"
			*y = (gint) round ((_tmp11_.y + self->priv->win_y) - offset);
#line 1170 "../lib/PositionManager.vala"
			break;
#line 4351 "PositionManager.c"
		}
#line 1166 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4355 "PositionManager.c"
		{
			PlankPointD _tmp12_;
#line 1172 "../lib/PositionManager.vala"
			_tmp12_ = center;
#line 1172 "../lib/PositionManager.vala"
			*y = (gint) round ((_tmp12_.y + self->priv->win_y) + offset);
#line 1173 "../lib/PositionManager.vala"
			break;
#line 4364 "PositionManager.c"
		}
#line 1166 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4368 "PositionManager.c"
		{
			PlankPointD _tmp13_;
#line 1175 "../lib/PositionManager.vala"
			_tmp13_ = center;
#line 1175 "../lib/PositionManager.vala"
			*x = (gint) round ((_tmp13_.x + self->priv->win_x) + offset);
#line 1176 "../lib/PositionManager.vala"
			break;
#line 4377 "PositionManager.c"
		}
#line 1166 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4381 "PositionManager.c"
		{
			PlankPointD _tmp14_;
#line 1178 "../lib/PositionManager.vala"
			_tmp14_ = center;
#line 1178 "../lib/PositionManager.vala"
			*x = (gint) round ((_tmp14_.x + self->priv->win_x) - offset);
#line 1179 "../lib/PositionManager.vala"
			break;
#line 4390 "PositionManager.c"
		}
	}
}

/**
 * Get's the x and y position to display the urgent-glow for a dock item.
 *
 * @param item the item to show urgent-glow for
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_urgent_glow_position (PlankPositionManager* self,
                                                 PlankDockItem* item,
                                                 gint* x,
                                                 gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	gint glow_size = 0;
	gint _tmp1_;
	GtkPositionType _tmp2_;
#line 1190 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1190 "../lib/PositionManager.vala"
	g_return_if_fail (item != NULL);
#line 1192 "../lib/PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) item, &_tmp0_);
#line 1192 "../lib/PositionManager.vala"
	rect = _tmp0_;
#line 1193 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_GlowSize;
#line 1193 "../lib/PositionManager.vala"
	glow_size = _tmp1_;
#line 1195 "../lib/PositionManager.vala"
	_tmp2_ = self->priv->_Position;
#line 1195 "../lib/PositionManager.vala"
	switch (_tmp2_) {
#line 4431 "PositionManager.c"
		default:
#line 1195 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4435 "PositionManager.c"
		{
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
#line 1198 "../lib/PositionManager.vala"
			_tmp3_ = rect;
#line 1198 "../lib/PositionManager.vala"
			_tmp4_ = rect;
#line 1198 "../lib/PositionManager.vala"
			_vala_x = _tmp3_.x + ((_tmp4_.width - glow_size) / 2);
#line 1199 "../lib/PositionManager.vala"
			_vala_y = self->priv->DockHeight - (glow_size / 2);
#line 1200 "../lib/PositionManager.vala"
			break;
#line 4449 "PositionManager.c"
		}
#line 1195 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4453 "PositionManager.c"
		{
			GdkRectangle _tmp5_;
			GdkRectangle _tmp6_;
#line 1202 "../lib/PositionManager.vala"
			_tmp5_ = rect;
#line 1202 "../lib/PositionManager.vala"
			_tmp6_ = rect;
#line 1202 "../lib/PositionManager.vala"
			_vala_x = _tmp5_.x + ((_tmp6_.width - glow_size) / 2);
#line 1203 "../lib/PositionManager.vala"
			_vala_y = (-glow_size) / 2;
#line 1204 "../lib/PositionManager.vala"
			break;
#line 4467 "PositionManager.c"
		}
#line 1195 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4471 "PositionManager.c"
		{
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 1206 "../lib/PositionManager.vala"
			_tmp7_ = rect;
#line 1206 "../lib/PositionManager.vala"
			_tmp8_ = rect;
#line 1206 "../lib/PositionManager.vala"
			_vala_y = _tmp7_.y + ((_tmp8_.height - glow_size) / 2);
#line 1207 "../lib/PositionManager.vala"
			_vala_x = (-glow_size) / 2;
#line 1208 "../lib/PositionManager.vala"
			break;
#line 4485 "PositionManager.c"
		}
#line 1195 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4489 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
#line 1210 "../lib/PositionManager.vala"
			_tmp9_ = rect;
#line 1210 "../lib/PositionManager.vala"
			_tmp10_ = rect;
#line 1210 "../lib/PositionManager.vala"
			_vala_y = _tmp9_.y + ((_tmp10_.height - glow_size) / 2);
#line 1211 "../lib/PositionManager.vala"
			_vala_x = self->priv->DockWidth - (glow_size / 2);
#line 1212 "../lib/PositionManager.vala"
			break;
#line 4503 "PositionManager.c"
		}
	}
#line 1190 "../lib/PositionManager.vala"
	if (x) {
#line 1190 "../lib/PositionManager.vala"
		*x = _vala_x;
#line 4510 "PositionManager.c"
	}
#line 1190 "../lib/PositionManager.vala"
	if (y) {
#line 1190 "../lib/PositionManager.vala"
		*y = _vala_y;
#line 4516 "PositionManager.c"
	}
}

/**
 * Caches the x and y position of the dock window.
 */
void
plank_position_manager_update_dock_position (PlankPositionManager* self)
{
	gint xoffset = 0;
	gint yoffset = 0;
	gboolean _tmp0_;
	GtkPositionType _tmp13_;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_;
#line 1219 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1221 "../lib/PositionManager.vala"
	xoffset = 0;
#line 1222 "../lib/PositionManager.vala"
	yoffset = 0;
#line 1224 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1224 "../lib/PositionManager.vala"
	if (!_tmp0_) {
#line 4542 "PositionManager.c"
		gint offset = 0;
		gint _tmp1_;
		GdkRectangle _tmp2_;
		GdkRectangle _tmp3_;
		GtkAlign _tmp4_;
#line 1225 "../lib/PositionManager.vala"
		_tmp1_ = self->priv->_Offset;
#line 1225 "../lib/PositionManager.vala"
		offset = _tmp1_;
#line 1226 "../lib/PositionManager.vala"
		_tmp2_ = self->priv->monitor_geo;
#line 1226 "../lib/PositionManager.vala"
		xoffset = (gint) (((1 + (offset / 100.0)) * (_tmp2_.width - self->priv->DockWidth)) / 2);
#line 1227 "../lib/PositionManager.vala"
		_tmp3_ = self->priv->monitor_geo;
#line 1227 "../lib/PositionManager.vala"
		yoffset = (gint) (((1 + (offset / 100.0)) * (_tmp3_.height - self->priv->DockHeight)) / 2);
#line 1229 "../lib/PositionManager.vala"
		_tmp4_ = self->priv->_Alignment;
#line 1229 "../lib/PositionManager.vala"
		switch (_tmp4_) {
#line 4564 "PositionManager.c"
			default:
#line 1229 "../lib/PositionManager.vala"
			case GTK_ALIGN_CENTER:
#line 1229 "../lib/PositionManager.vala"
			case GTK_ALIGN_FILL:
#line 4570 "PositionManager.c"
			{
#line 1233 "../lib/PositionManager.vala"
				break;
#line 4574 "PositionManager.c"
			}
#line 1229 "../lib/PositionManager.vala"
			case GTK_ALIGN_START:
#line 4578 "PositionManager.c"
			{
#line 1235 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 4582 "PositionManager.c"
					GdkRectangle _tmp5_;
					GdkRectangle _tmp6_;
#line 1236 "../lib/PositionManager.vala"
					xoffset = 0;
#line 1237 "../lib/PositionManager.vala"
					_tmp5_ = self->priv->monitor_geo;
#line 1237 "../lib/PositionManager.vala"
					_tmp6_ = self->priv->static_dock_region;
#line 1237 "../lib/PositionManager.vala"
					yoffset = _tmp5_.height - _tmp6_.height;
#line 4593 "PositionManager.c"
				} else {
					GdkRectangle _tmp7_;
					GdkRectangle _tmp8_;
#line 1239 "../lib/PositionManager.vala"
					_tmp7_ = self->priv->monitor_geo;
#line 1239 "../lib/PositionManager.vala"
					_tmp8_ = self->priv->static_dock_region;
#line 1239 "../lib/PositionManager.vala"
					xoffset = _tmp7_.width - _tmp8_.width;
#line 1240 "../lib/PositionManager.vala"
					yoffset = 0;
#line 4605 "PositionManager.c"
				}
#line 1242 "../lib/PositionManager.vala"
				break;
#line 4609 "PositionManager.c"
			}
#line 1229 "../lib/PositionManager.vala"
			case GTK_ALIGN_END:
#line 4613 "PositionManager.c"
			{
#line 1244 "../lib/PositionManager.vala"
				if (plank_position_manager_is_horizontal_dock (self)) {
#line 4617 "PositionManager.c"
					GdkRectangle _tmp9_;
					GdkRectangle _tmp10_;
#line 1245 "../lib/PositionManager.vala"
					_tmp9_ = self->priv->monitor_geo;
#line 1245 "../lib/PositionManager.vala"
					_tmp10_ = self->priv->static_dock_region;
#line 1245 "../lib/PositionManager.vala"
					xoffset = _tmp9_.width - _tmp10_.width;
#line 1246 "../lib/PositionManager.vala"
					yoffset = 0;
#line 4628 "PositionManager.c"
				} else {
					GdkRectangle _tmp11_;
					GdkRectangle _tmp12_;
#line 1248 "../lib/PositionManager.vala"
					xoffset = 0;
#line 1249 "../lib/PositionManager.vala"
					_tmp11_ = self->priv->monitor_geo;
#line 1249 "../lib/PositionManager.vala"
					_tmp12_ = self->priv->static_dock_region;
#line 1249 "../lib/PositionManager.vala"
					yoffset = _tmp11_.height - _tmp12_.height;
#line 4640 "PositionManager.c"
				}
#line 1251 "../lib/PositionManager.vala"
				break;
#line 4644 "PositionManager.c"
			}
		}
	}
#line 1255 "../lib/PositionManager.vala"
	_tmp13_ = self->priv->_Position;
#line 1255 "../lib/PositionManager.vala"
	switch (_tmp13_) {
#line 4652 "PositionManager.c"
		default:
#line 1255 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4656 "PositionManager.c"
		{
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
#line 1258 "../lib/PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1258 "../lib/PositionManager.vala"
			self->priv->win_x = _tmp14_.x + xoffset;
#line 1259 "../lib/PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1259 "../lib/PositionManager.vala"
			_tmp16_ = self->priv->monitor_geo;
#line 1259 "../lib/PositionManager.vala"
			self->priv->win_y = (_tmp15_.y + _tmp16_.height) - self->priv->DockHeight;
#line 1260 "../lib/PositionManager.vala"
			break;
#line 4673 "PositionManager.c"
		}
#line 1255 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4677 "PositionManager.c"
		{
			GdkRectangle _tmp17_;
			GdkRectangle _tmp18_;
#line 1262 "../lib/PositionManager.vala"
			_tmp17_ = self->priv->monitor_geo;
#line 1262 "../lib/PositionManager.vala"
			self->priv->win_x = _tmp17_.x + xoffset;
#line 1263 "../lib/PositionManager.vala"
			_tmp18_ = self->priv->monitor_geo;
#line 1263 "../lib/PositionManager.vala"
			self->priv->win_y = _tmp18_.y;
#line 1264 "../lib/PositionManager.vala"
			break;
#line 4691 "PositionManager.c"
		}
#line 1255 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4695 "PositionManager.c"
		{
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
#line 1266 "../lib/PositionManager.vala"
			_tmp19_ = self->priv->monitor_geo;
#line 1266 "../lib/PositionManager.vala"
			self->priv->win_y = _tmp19_.y + yoffset;
#line 1267 "../lib/PositionManager.vala"
			_tmp20_ = self->priv->monitor_geo;
#line 1267 "../lib/PositionManager.vala"
			self->priv->win_x = _tmp20_.x;
#line 1268 "../lib/PositionManager.vala"
			break;
#line 4709 "PositionManager.c"
		}
#line 1255 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4713 "PositionManager.c"
		{
			GdkRectangle _tmp21_;
			GdkRectangle _tmp22_;
			GdkRectangle _tmp23_;
#line 1270 "../lib/PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 1270 "../lib/PositionManager.vala"
			self->priv->win_y = _tmp21_.y + yoffset;
#line 1271 "../lib/PositionManager.vala"
			_tmp22_ = self->priv->monitor_geo;
#line 1271 "../lib/PositionManager.vala"
			_tmp23_ = self->priv->monitor_geo;
#line 1271 "../lib/PositionManager.vala"
			self->priv->win_x = (_tmp22_.x + _tmp23_.width) - self->priv->DockWidth;
#line 1272 "../lib/PositionManager.vala"
			break;
#line 4730 "PositionManager.c"
		}
	}
#line 1276 "../lib/PositionManager.vala"
	_tmp25_ = self->priv->_screen_is_composited;
#line 1276 "../lib/PositionManager.vala"
	if (!_tmp25_) {
#line 4737 "PositionManager.c"
		PlankDockController* _tmp26_;
		PlankHideManager* _tmp27_;
		PlankHideManager* _tmp28_;
		gboolean _tmp29_;
		gboolean _tmp30_;
#line 1276 "../lib/PositionManager.vala"
		_tmp26_ = self->priv->_controller;
#line 1276 "../lib/PositionManager.vala"
		_tmp27_ = plank_dock_controller_get_hide_manager (_tmp26_);
#line 1276 "../lib/PositionManager.vala"
		_tmp28_ = _tmp27_;
#line 1276 "../lib/PositionManager.vala"
		_tmp29_ = plank_hide_manager_get_Hidden (_tmp28_);
#line 1276 "../lib/PositionManager.vala"
		_tmp30_ = _tmp29_;
#line 1276 "../lib/PositionManager.vala"
		_tmp24_ = _tmp30_;
#line 4755 "PositionManager.c"
	} else {
#line 1276 "../lib/PositionManager.vala"
		_tmp24_ = FALSE;
#line 4759 "PositionManager.c"
	}
#line 1276 "../lib/PositionManager.vala"
	if (_tmp24_) {
#line 4763 "PositionManager.c"
		GtkPositionType _tmp31_;
#line 1277 "../lib/PositionManager.vala"
		_tmp31_ = self->priv->_Position;
#line 1277 "../lib/PositionManager.vala"
		switch (_tmp31_) {
#line 4769 "PositionManager.c"
			default:
#line 1277 "../lib/PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 4773 "PositionManager.c"
			{
#line 1280 "../lib/PositionManager.vala"
				self->priv->win_y = self->priv->win_y + (self->priv->DockHeight - 1);
#line 1281 "../lib/PositionManager.vala"
				break;
#line 4779 "PositionManager.c"
			}
#line 1277 "../lib/PositionManager.vala"
			case GTK_POS_TOP:
#line 4783 "PositionManager.c"
			{
#line 1283 "../lib/PositionManager.vala"
				self->priv->win_y = self->priv->win_y - (self->priv->DockHeight - 1);
#line 1284 "../lib/PositionManager.vala"
				break;
#line 4789 "PositionManager.c"
			}
#line 1277 "../lib/PositionManager.vala"
			case GTK_POS_LEFT:
#line 4793 "PositionManager.c"
			{
#line 1286 "../lib/PositionManager.vala"
				self->priv->win_x = self->priv->win_x - (self->priv->DockWidth - 1);
#line 1287 "../lib/PositionManager.vala"
				break;
#line 4799 "PositionManager.c"
			}
#line 1277 "../lib/PositionManager.vala"
			case GTK_POS_RIGHT:
#line 4803 "PositionManager.c"
			{
#line 1289 "../lib/PositionManager.vala"
				self->priv->win_x = self->priv->win_x + (self->priv->DockWidth - 1);
#line 1290 "../lib/PositionManager.vala"
				break;
#line 4809 "PositionManager.c"
			}
		}
	}
}

/**
 * Get's the x and y position to display the main dock buffer.
 *
 * @param x the resulting x position
 * @param y the resulting y position
 */
void
plank_position_manager_get_dock_draw_position (PlankPositionManager* self,
                                               gint* x,
                                               gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gboolean _tmp0_;
	gdouble progress = 0.0;
	PlankDockController* _tmp1_;
	PlankDockRenderer* _tmp2_;
	PlankDockRenderer* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	GtkPositionType _tmp6_;
#line 1301 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1303 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1303 "../lib/PositionManager.vala"
	if (!_tmp0_) {
#line 1304 "../lib/PositionManager.vala"
		_vala_x = 0;
#line 1305 "../lib/PositionManager.vala"
		_vala_y = 0;
#line 1306 "../lib/PositionManager.vala"
		if (x) {
#line 1306 "../lib/PositionManager.vala"
			*x = _vala_x;
#line 4850 "PositionManager.c"
		}
#line 1306 "../lib/PositionManager.vala"
		if (y) {
#line 1306 "../lib/PositionManager.vala"
			*y = _vala_y;
#line 4856 "PositionManager.c"
		}
#line 1306 "../lib/PositionManager.vala"
		return;
#line 4860 "PositionManager.c"
	}
#line 1309 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_controller;
#line 1309 "../lib/PositionManager.vala"
	_tmp2_ = plank_dock_controller_get_renderer (_tmp1_);
#line 1309 "../lib/PositionManager.vala"
	_tmp3_ = _tmp2_;
#line 1309 "../lib/PositionManager.vala"
	_tmp4_ = plank_dock_renderer_get_hide_progress (_tmp3_);
#line 1309 "../lib/PositionManager.vala"
	_tmp5_ = _tmp4_;
#line 1309 "../lib/PositionManager.vala"
	progress = _tmp5_;
#line 1311 "../lib/PositionManager.vala"
	_tmp6_ = self->priv->_Position;
#line 1311 "../lib/PositionManager.vala"
	switch (_tmp6_) {
#line 4878 "PositionManager.c"
		default:
#line 1311 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4882 "PositionManager.c"
		{
#line 1314 "../lib/PositionManager.vala"
			_vala_x = 0;
#line 1315 "../lib/PositionManager.vala"
			_vala_y = (gint) ((self->priv->VisibleDockHeight + self->priv->extra_hide_offset) * progress);
#line 1316 "../lib/PositionManager.vala"
			break;
#line 4890 "PositionManager.c"
		}
#line 1311 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 4894 "PositionManager.c"
		{
#line 1318 "../lib/PositionManager.vala"
			_vala_x = 0;
#line 1319 "../lib/PositionManager.vala"
			_vala_y = (gint) ((-(self->priv->VisibleDockHeight + self->priv->extra_hide_offset)) * progress);
#line 1320 "../lib/PositionManager.vala"
			break;
#line 4902 "PositionManager.c"
		}
#line 1311 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 4906 "PositionManager.c"
		{
#line 1322 "../lib/PositionManager.vala"
			_vala_x = (gint) ((-(self->priv->VisibleDockWidth + self->priv->extra_hide_offset)) * progress);
#line 1323 "../lib/PositionManager.vala"
			_vala_y = 0;
#line 1324 "../lib/PositionManager.vala"
			break;
#line 4914 "PositionManager.c"
		}
#line 1311 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 4918 "PositionManager.c"
		{
#line 1326 "../lib/PositionManager.vala"
			_vala_x = (gint) ((self->priv->VisibleDockWidth + self->priv->extra_hide_offset) * progress);
#line 1327 "../lib/PositionManager.vala"
			_vala_y = 0;
#line 1328 "../lib/PositionManager.vala"
			break;
#line 4926 "PositionManager.c"
		}
	}
#line 1301 "../lib/PositionManager.vala"
	if (x) {
#line 1301 "../lib/PositionManager.vala"
		*x = _vala_x;
#line 4933 "PositionManager.c"
	}
#line 1301 "../lib/PositionManager.vala"
	if (y) {
#line 1301 "../lib/PositionManager.vala"
		*y = _vala_y;
#line 4939 "PositionManager.c"
	}
}

/**
 * Get's the region to display the dock window at.
 *
 * @return the region for the dock window
 */
void
plank_position_manager_get_dock_window_region (PlankPositionManager* self,
                                               GdkRectangle* result)
{
	GdkRectangle _tmp0_ = {0};
#line 1337 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1339 "../lib/PositionManager.vala"
	_tmp0_.x = self->priv->win_x;
#line 1339 "../lib/PositionManager.vala"
	_tmp0_.y = self->priv->win_y;
#line 1339 "../lib/PositionManager.vala"
	_tmp0_.width = self->priv->DockWidth;
#line 1339 "../lib/PositionManager.vala"
	_tmp0_.height = self->priv->DockHeight;
#line 1339 "../lib/PositionManager.vala"
	*result = _tmp0_;
#line 1339 "../lib/PositionManager.vala"
	return;
#line 4967 "PositionManager.c"
}

/**
 * Get's the padding between background and icons of the dock.
 *
 * @param x the horizontal padding
 * @param y the vertical padding
 */
void
plank_position_manager_get_background_padding (PlankPositionManager* self,
                                               gint* x,
                                               gint* y)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	GtkPositionType _tmp0_;
#line 1348 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1350 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_Position;
#line 1350 "../lib/PositionManager.vala"
	switch (_tmp0_) {
#line 4990 "PositionManager.c"
		default:
#line 1350 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 4994 "PositionManager.c"
		{
#line 1353 "../lib/PositionManager.vala"
			_vala_x = 0;
#line 1354 "../lib/PositionManager.vala"
			_vala_y = (self->priv->VisibleDockHeight - self->priv->DockBackgroundHeight) + self->priv->extra_hide_offset;
#line 1355 "../lib/PositionManager.vala"
			break;
#line 5002 "PositionManager.c"
		}
#line 1350 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 5006 "PositionManager.c"
		{
#line 1357 "../lib/PositionManager.vala"
			_vala_x = 0;
#line 1358 "../lib/PositionManager.vala"
			_vala_y = -((self->priv->VisibleDockHeight - self->priv->DockBackgroundHeight) + self->priv->extra_hide_offset);
#line 1359 "../lib/PositionManager.vala"
			break;
#line 5014 "PositionManager.c"
		}
#line 1350 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 5018 "PositionManager.c"
		{
#line 1361 "../lib/PositionManager.vala"
			_vala_x = -((self->priv->VisibleDockWidth - self->priv->DockBackgroundWidth) + self->priv->extra_hide_offset);
#line 1362 "../lib/PositionManager.vala"
			_vala_y = 0;
#line 1363 "../lib/PositionManager.vala"
			break;
#line 5026 "PositionManager.c"
		}
#line 1350 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5030 "PositionManager.c"
		{
#line 1365 "../lib/PositionManager.vala"
			_vala_x = (self->priv->VisibleDockWidth - self->priv->DockBackgroundWidth) + self->priv->extra_hide_offset;
#line 1366 "../lib/PositionManager.vala"
			_vala_y = 0;
#line 1367 "../lib/PositionManager.vala"
			break;
#line 5038 "PositionManager.c"
		}
	}
#line 1348 "../lib/PositionManager.vala"
	if (x) {
#line 1348 "../lib/PositionManager.vala"
		*x = _vala_x;
#line 5045 "PositionManager.c"
	}
#line 1348 "../lib/PositionManager.vala"
	if (y) {
#line 1348 "../lib/PositionManager.vala"
		*y = _vala_y;
#line 5051 "PositionManager.c"
	}
}

/**
 * Get's the region for background of the dock.
 *
 * @return the region for the dock background
 */
void
plank_position_manager_get_background_region (PlankPositionManager* self,
                                              GdkRectangle* result)
{
	GdkRectangle _tmp0_;
#line 1376 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1378 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->background_rect;
#line 1378 "../lib/PositionManager.vala"
	*result = _tmp0_;
#line 1378 "../lib/PositionManager.vala"
	return;
#line 5073 "PositionManager.c"
}

static void
plank_position_manager_update_background_region (PlankPositionManager* self,
                                                 PlankDockItemDrawValue* val_first,
                                                 PlankDockItemDrawValue* val_last)
{
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gboolean _tmp0_;
	GtkAlign _tmp3_;
	PlankPointD center_first = {0};
	PlankPointD _tmp6_;
	PlankPointD center_last = {0};
	PlankPointD _tmp7_;
	gint padding = 0;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gdouble padding_first = 0.0;
	gdouble padding_last = 0.0;
	GtkPositionType _tmp11_;
	GdkRectangle _tmp24_ = {0};
#line 1381 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1381 "../lib/PositionManager.vala"
	g_return_if_fail (val_first != NULL);
#line 1381 "../lib/PositionManager.vala"
	g_return_if_fail (val_last != NULL);
#line 1383 "../lib/PositionManager.vala"
	x = 0;
#line 1383 "../lib/PositionManager.vala"
	y = 0;
#line 1383 "../lib/PositionManager.vala"
	width = 0;
#line 1383 "../lib/PositionManager.vala"
	height = 0;
#line 1385 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_screen_is_composited;
#line 1385 "../lib/PositionManager.vala"
	if (_tmp0_) {
#line 5117 "PositionManager.c"
		GdkRectangle _tmp1_;
		GdkRectangle _tmp2_;
#line 1386 "../lib/PositionManager.vala"
		_tmp1_ = self->priv->static_dock_region;
#line 1386 "../lib/PositionManager.vala"
		x = _tmp1_.x;
#line 1387 "../lib/PositionManager.vala"
		_tmp2_ = self->priv->static_dock_region;
#line 1387 "../lib/PositionManager.vala"
		y = _tmp2_.y;
#line 1388 "../lib/PositionManager.vala"
		width = self->priv->VisibleDockWidth;
#line 1389 "../lib/PositionManager.vala"
		height = self->priv->VisibleDockHeight;
#line 5132 "PositionManager.c"
	} else {
#line 1391 "../lib/PositionManager.vala"
		width = self->priv->DockWidth;
#line 1392 "../lib/PositionManager.vala"
		height = self->priv->DockHeight;
#line 5138 "PositionManager.c"
	}
#line 1395 "../lib/PositionManager.vala"
	_tmp3_ = self->priv->_Alignment;
#line 1395 "../lib/PositionManager.vala"
	if (_tmp3_ == GTK_ALIGN_FILL) {
#line 5144 "PositionManager.c"
		GtkPositionType _tmp4_;
		GdkRectangle _tmp5_ = {0};
#line 1396 "../lib/PositionManager.vala"
		_tmp4_ = self->priv->_Position;
#line 1396 "../lib/PositionManager.vala"
		switch (_tmp4_) {
#line 5151 "PositionManager.c"
			default:
#line 1396 "../lib/PositionManager.vala"
			case GTK_POS_BOTTOM:
#line 5155 "PositionManager.c"
			{
#line 1399 "../lib/PositionManager.vala"
				x += (width - self->priv->DockBackgroundWidth) / 2;
#line 1400 "../lib/PositionManager.vala"
				y += height - self->priv->DockBackgroundHeight;
#line 1401 "../lib/PositionManager.vala"
				break;
#line 5163 "PositionManager.c"
			}
#line 1396 "../lib/PositionManager.vala"
			case GTK_POS_TOP:
#line 5167 "PositionManager.c"
			{
#line 1403 "../lib/PositionManager.vala"
				x += (width - self->priv->DockBackgroundWidth) / 2;
#line 1404 "../lib/PositionManager.vala"
				y = 0;
#line 1405 "../lib/PositionManager.vala"
				break;
#line 5175 "PositionManager.c"
			}
#line 1396 "../lib/PositionManager.vala"
			case GTK_POS_LEFT:
#line 5179 "PositionManager.c"
			{
#line 1407 "../lib/PositionManager.vala"
				x = 0;
#line 1408 "../lib/PositionManager.vala"
				y += (height - self->priv->DockBackgroundHeight) / 2;
#line 1409 "../lib/PositionManager.vala"
				break;
#line 5187 "PositionManager.c"
			}
#line 1396 "../lib/PositionManager.vala"
			case GTK_POS_RIGHT:
#line 5191 "PositionManager.c"
			{
#line 1411 "../lib/PositionManager.vala"
				x += width - self->priv->DockBackgroundWidth;
#line 1412 "../lib/PositionManager.vala"
				y += (height - self->priv->DockBackgroundHeight) / 2;
#line 1413 "../lib/PositionManager.vala"
				break;
#line 5199 "PositionManager.c"
			}
		}
#line 1416 "../lib/PositionManager.vala"
		_tmp5_.x = x;
#line 1416 "../lib/PositionManager.vala"
		_tmp5_.y = y;
#line 1416 "../lib/PositionManager.vala"
		_tmp5_.width = self->priv->DockBackgroundWidth;
#line 1416 "../lib/PositionManager.vala"
		_tmp5_.height = self->priv->DockBackgroundHeight;
#line 1416 "../lib/PositionManager.vala"
		self->priv->background_rect = _tmp5_;
#line 1417 "../lib/PositionManager.vala"
		return;
#line 5214 "PositionManager.c"
	}
#line 1420 "../lib/PositionManager.vala"
	_tmp6_ = val_first->center;
#line 1420 "../lib/PositionManager.vala"
	center_first = _tmp6_;
#line 1421 "../lib/PositionManager.vala"
	_tmp7_ = val_last->center;
#line 1421 "../lib/PositionManager.vala"
	center_last = _tmp7_;
#line 1422 "../lib/PositionManager.vala"
	_tmp8_ = self->priv->_ItemPadding;
#line 1422 "../lib/PositionManager.vala"
	_tmp9_ = self->priv->_HorizPadding;
#line 1422 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_LineWidth;
#line 1422 "../lib/PositionManager.vala"
	padding = (_tmp8_ + (2 * _tmp9_)) + (4 * _tmp10_);
#line 1423 "../lib/PositionManager.vala"
	padding_first = (val_first->icon_size + padding) / 2.0;
#line 1424 "../lib/PositionManager.vala"
	padding_last = (val_last->icon_size + padding) / 2.0;
#line 1426 "../lib/PositionManager.vala"
	_tmp11_ = self->priv->_Position;
#line 1426 "../lib/PositionManager.vala"
	switch (_tmp11_) {
#line 5240 "PositionManager.c"
		default:
#line 1426 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5244 "PositionManager.c"
		{
			PlankPointD _tmp12_;
			PlankPointD _tmp13_;
			PlankPointD _tmp14_;
#line 1429 "../lib/PositionManager.vala"
			_tmp12_ = center_first;
#line 1429 "../lib/PositionManager.vala"
			x = (gint) round (_tmp12_.x - padding_first);
#line 1430 "../lib/PositionManager.vala"
			y += height - self->priv->DockBackgroundHeight;
#line 1431 "../lib/PositionManager.vala"
			_tmp13_ = center_last;
#line 1431 "../lib/PositionManager.vala"
			_tmp14_ = center_first;
#line 1431 "../lib/PositionManager.vala"
			width = (gint) round (((_tmp13_.x - _tmp14_.x) + padding_first) + padding_last);
#line 1432 "../lib/PositionManager.vala"
			height = self->priv->DockBackgroundHeight;
#line 1433 "../lib/PositionManager.vala"
			break;
#line 5265 "PositionManager.c"
		}
#line 1426 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 5269 "PositionManager.c"
		{
			PlankPointD _tmp15_;
			PlankPointD _tmp16_;
			PlankPointD _tmp17_;
#line 1435 "../lib/PositionManager.vala"
			_tmp15_ = center_first;
#line 1435 "../lib/PositionManager.vala"
			x = (gint) round (_tmp15_.x - padding_first);
#line 1436 "../lib/PositionManager.vala"
			y = 0;
#line 1437 "../lib/PositionManager.vala"
			_tmp16_ = center_last;
#line 1437 "../lib/PositionManager.vala"
			_tmp17_ = center_first;
#line 1437 "../lib/PositionManager.vala"
			width = (gint) round (((_tmp16_.x - _tmp17_.x) + padding_first) + padding_last);
#line 1438 "../lib/PositionManager.vala"
			height = self->priv->DockBackgroundHeight;
#line 1439 "../lib/PositionManager.vala"
			break;
#line 5290 "PositionManager.c"
		}
#line 1426 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 5294 "PositionManager.c"
		{
			PlankPointD _tmp18_;
			PlankPointD _tmp19_;
			PlankPointD _tmp20_;
#line 1441 "../lib/PositionManager.vala"
			x = 0;
#line 1442 "../lib/PositionManager.vala"
			_tmp18_ = center_first;
#line 1442 "../lib/PositionManager.vala"
			y = (gint) round (_tmp18_.y - padding_first);
#line 1443 "../lib/PositionManager.vala"
			width = self->priv->DockBackgroundWidth;
#line 1444 "../lib/PositionManager.vala"
			_tmp19_ = center_last;
#line 1444 "../lib/PositionManager.vala"
			_tmp20_ = center_first;
#line 1444 "../lib/PositionManager.vala"
			height = (gint) round (((_tmp19_.y - _tmp20_.y) + padding_first) + padding_last);
#line 1445 "../lib/PositionManager.vala"
			break;
#line 5315 "PositionManager.c"
		}
#line 1426 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5319 "PositionManager.c"
		{
			PlankPointD _tmp21_;
			PlankPointD _tmp22_;
			PlankPointD _tmp23_;
#line 1447 "../lib/PositionManager.vala"
			x += width - self->priv->DockBackgroundWidth;
#line 1448 "../lib/PositionManager.vala"
			_tmp21_ = center_first;
#line 1448 "../lib/PositionManager.vala"
			y = (gint) round (_tmp21_.y - padding_first);
#line 1449 "../lib/PositionManager.vala"
			width = self->priv->DockBackgroundWidth;
#line 1450 "../lib/PositionManager.vala"
			_tmp22_ = center_last;
#line 1450 "../lib/PositionManager.vala"
			_tmp23_ = center_first;
#line 1450 "../lib/PositionManager.vala"
			height = (gint) round (((_tmp22_.y - _tmp23_.y) + padding_first) + padding_last);
#line 1451 "../lib/PositionManager.vala"
			break;
#line 5340 "PositionManager.c"
		}
	}
#line 1454 "../lib/PositionManager.vala"
	_tmp24_.x = x;
#line 1454 "../lib/PositionManager.vala"
	_tmp24_.y = y;
#line 1454 "../lib/PositionManager.vala"
	_tmp24_.width = width;
#line 1454 "../lib/PositionManager.vala"
	_tmp24_.height = height;
#line 1454 "../lib/PositionManager.vala"
	self->priv->background_rect = _tmp24_;
#line 5353 "PositionManager.c"
}

/**
 * Get the item's icon geometry for the dock.
 *
 * @param item an application-dockitem of the dock
 * @param for_hidden whether the geometry should apply for a hidden dock
 * @return icon geometry for the given application-dockitem
 */
void
plank_position_manager_get_icon_geometry (PlankPositionManager* self,
                                          PlankApplicationDockItem* item,
                                          gboolean for_hidden,
                                          GdkRectangle* result)
{
	GdkRectangle region = {0};
	GdkRectangle _tmp0_ = {0};
	gint x = 0;
	gint y = 0;
	GtkPositionType _tmp1_;
	GdkRectangle _tmp10_ = {0};
#line 1464 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1464 "../lib/PositionManager.vala"
	g_return_if_fail (item != NULL);
#line 1466 "../lib/PositionManager.vala"
	plank_position_manager_get_hover_region_for_element (self, (PlankDockElement*) item, &_tmp0_);
#line 1466 "../lib/PositionManager.vala"
	region = _tmp0_;
#line 1468 "../lib/PositionManager.vala"
	if (!for_hidden) {
#line 1469 "../lib/PositionManager.vala"
		region.x = region.x + self->priv->win_x;
#line 1470 "../lib/PositionManager.vala"
		region.y = region.y + self->priv->win_y;
#line 1472 "../lib/PositionManager.vala"
		*result = region;
#line 1472 "../lib/PositionManager.vala"
		return;
#line 5393 "PositionManager.c"
	}
#line 1475 "../lib/PositionManager.vala"
	x = self->priv->win_x;
#line 1475 "../lib/PositionManager.vala"
	y = self->priv->win_y;
#line 1477 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1477 "../lib/PositionManager.vala"
	switch (_tmp1_) {
#line 5403 "PositionManager.c"
		default:
#line 1477 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5407 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
#line 1480 "../lib/PositionManager.vala"
			_tmp2_ = region;
#line 1480 "../lib/PositionManager.vala"
			_tmp3_ = region;
#line 1480 "../lib/PositionManager.vala"
			x += _tmp2_.x + (_tmp3_.width / 2);
#line 1481 "../lib/PositionManager.vala"
			y += self->priv->DockHeight;
#line 1482 "../lib/PositionManager.vala"
			break;
#line 5421 "PositionManager.c"
		}
#line 1477 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 5425 "PositionManager.c"
		{
			GdkRectangle _tmp4_;
			GdkRectangle _tmp5_;
#line 1484 "../lib/PositionManager.vala"
			_tmp4_ = region;
#line 1484 "../lib/PositionManager.vala"
			_tmp5_ = region;
#line 1484 "../lib/PositionManager.vala"
			x += _tmp4_.x + (_tmp5_.width / 2);
#line 1485 "../lib/PositionManager.vala"
			y += 0;
#line 1486 "../lib/PositionManager.vala"
			break;
#line 5439 "PositionManager.c"
		}
#line 1477 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 5443 "PositionManager.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
#line 1488 "../lib/PositionManager.vala"
			x += 0;
#line 1489 "../lib/PositionManager.vala"
			_tmp6_ = region;
#line 1489 "../lib/PositionManager.vala"
			_tmp7_ = region;
#line 1489 "../lib/PositionManager.vala"
			y += _tmp6_.y + (_tmp7_.height / 2);
#line 1490 "../lib/PositionManager.vala"
			break;
#line 5457 "PositionManager.c"
		}
#line 1477 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5461 "PositionManager.c"
		{
			GdkRectangle _tmp8_;
			GdkRectangle _tmp9_;
#line 1492 "../lib/PositionManager.vala"
			x += self->priv->DockWidth;
#line 1493 "../lib/PositionManager.vala"
			_tmp8_ = region;
#line 1493 "../lib/PositionManager.vala"
			_tmp9_ = region;
#line 1493 "../lib/PositionManager.vala"
			y += _tmp8_.y + (_tmp9_.height / 2);
#line 1494 "../lib/PositionManager.vala"
			break;
#line 5475 "PositionManager.c"
		}
	}
#line 1497 "../lib/PositionManager.vala"
	_tmp10_.x = x;
#line 1497 "../lib/PositionManager.vala"
	_tmp10_.y = y;
#line 1497 "../lib/PositionManager.vala"
	_tmp10_.width = 0;
#line 1497 "../lib/PositionManager.vala"
	_tmp10_.height = 0;
#line 1497 "../lib/PositionManager.vala"
	*result = _tmp10_;
#line 1497 "../lib/PositionManager.vala"
	return;
#line 5490 "PositionManager.c"
}

/**
 * Computes the struts for the dock.
 *
 * @param struts the array to contain the struts
 */
void
plank_position_manager_get_struts (PlankPositionManager* self,
                                   gulong** struts,
                                   gint* struts_length1)
{
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkWindow* _tmp3_;
	GtkPositionType _tmp4_;
#line 1505 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1507 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 1507 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 1507 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 1507 "../lib/PositionManager.vala"
	_tmp3_ = gtk_widget_get_window ((GtkWidget*) _tmp2_);
#line 1507 "../lib/PositionManager.vala"
	self->priv->window_scale_factor = gdk_window_get_scale_factor (_tmp3_);
#line 1508 "../lib/PositionManager.vala"
	_tmp4_ = self->priv->_Position;
#line 1508 "../lib/PositionManager.vala"
	switch (_tmp4_) {
#line 5524 "PositionManager.c"
		default:
#line 1508 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5528 "PositionManager.c"
		{
			PlankDockController* _tmp5_;
			PlankDockWindow* _tmp6_;
			PlankDockWindow* _tmp7_;
			GdkScreen* _tmp8_;
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
#line 1511 "../lib/PositionManager.vala"
			_tmp5_ = self->priv->_controller;
#line 1511 "../lib/PositionManager.vala"
			_tmp6_ = plank_dock_controller_get_window (_tmp5_);
#line 1511 "../lib/PositionManager.vala"
			_tmp7_ = _tmp6_;
#line 1511 "../lib/PositionManager.vala"
			_tmp8_ = gtk_window_get_screen ((GtkWindow*) _tmp7_);
#line 1511 "../lib/PositionManager.vala"
			_tmp9_ = self->priv->monitor_geo;
#line 1511 "../lib/PositionManager.vala"
			_tmp10_ = self->priv->monitor_geo;
#line 1511 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM] = (gulong) ((((self->priv->VisibleDockHeight + gdk_screen_get_height (_tmp8_)) - _tmp9_.y) - _tmp10_.height) * self->priv->window_scale_factor);
#line 1512 "../lib/PositionManager.vala"
			_tmp11_ = self->priv->monitor_geo;
#line 1512 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM_START] = (gulong) (_tmp11_.x * self->priv->window_scale_factor);
#line 1513 "../lib/PositionManager.vala"
			_tmp12_ = self->priv->monitor_geo;
#line 1513 "../lib/PositionManager.vala"
			_tmp13_ = self->priv->monitor_geo;
#line 1513 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_BOTTOM_END] = (gulong) (((_tmp12_.x + _tmp13_.width) * self->priv->window_scale_factor) - 1);
#line 1514 "../lib/PositionManager.vala"
			break;
#line 5565 "PositionManager.c"
		}
#line 1508 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 5569 "PositionManager.c"
		{
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
			GdkRectangle _tmp16_;
			GdkRectangle _tmp17_;
#line 1516 "../lib/PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1516 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP] = (gulong) ((_tmp14_.y + self->priv->VisibleDockHeight) * self->priv->window_scale_factor);
#line 1517 "../lib/PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1517 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP_START] = (gulong) (_tmp15_.x * self->priv->window_scale_factor);
#line 1518 "../lib/PositionManager.vala"
			_tmp16_ = self->priv->monitor_geo;
#line 1518 "../lib/PositionManager.vala"
			_tmp17_ = self->priv->monitor_geo;
#line 1518 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_TOP_END] = (gulong) (((_tmp16_.x + _tmp17_.width) * self->priv->window_scale_factor) - 1);
#line 1519 "../lib/PositionManager.vala"
			break;
#line 5591 "PositionManager.c"
		}
#line 1508 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 5595 "PositionManager.c"
		{
			GdkRectangle _tmp18_;
			GdkRectangle _tmp19_;
			GdkRectangle _tmp20_;
			GdkRectangle _tmp21_;
#line 1521 "../lib/PositionManager.vala"
			_tmp18_ = self->priv->monitor_geo;
#line 1521 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT] = (gulong) ((_tmp18_.x + self->priv->VisibleDockWidth) * self->priv->window_scale_factor);
#line 1522 "../lib/PositionManager.vala"
			_tmp19_ = self->priv->monitor_geo;
#line 1522 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT_START] = (gulong) (_tmp19_.y * self->priv->window_scale_factor);
#line 1523 "../lib/PositionManager.vala"
			_tmp20_ = self->priv->monitor_geo;
#line 1523 "../lib/PositionManager.vala"
			_tmp21_ = self->priv->monitor_geo;
#line 1523 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_LEFT_END] = (gulong) (((_tmp20_.y + _tmp21_.height) * self->priv->window_scale_factor) - 1);
#line 1524 "../lib/PositionManager.vala"
			break;
#line 5617 "PositionManager.c"
		}
#line 1508 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5621 "PositionManager.c"
		{
			PlankDockController* _tmp22_;
			PlankDockWindow* _tmp23_;
			PlankDockWindow* _tmp24_;
			GdkScreen* _tmp25_;
			GdkRectangle _tmp26_;
			GdkRectangle _tmp27_;
			GdkRectangle _tmp28_;
			GdkRectangle _tmp29_;
			GdkRectangle _tmp30_;
#line 1526 "../lib/PositionManager.vala"
			_tmp22_ = self->priv->_controller;
#line 1526 "../lib/PositionManager.vala"
			_tmp23_ = plank_dock_controller_get_window (_tmp22_);
#line 1526 "../lib/PositionManager.vala"
			_tmp24_ = _tmp23_;
#line 1526 "../lib/PositionManager.vala"
			_tmp25_ = gtk_window_get_screen ((GtkWindow*) _tmp24_);
#line 1526 "../lib/PositionManager.vala"
			_tmp26_ = self->priv->monitor_geo;
#line 1526 "../lib/PositionManager.vala"
			_tmp27_ = self->priv->monitor_geo;
#line 1526 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT] = (gulong) ((((self->priv->VisibleDockWidth + gdk_screen_get_width (_tmp25_)) - _tmp26_.x) - _tmp27_.width) * self->priv->window_scale_factor);
#line 1527 "../lib/PositionManager.vala"
			_tmp28_ = self->priv->monitor_geo;
#line 1527 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT_START] = (gulong) (_tmp28_.y * self->priv->window_scale_factor);
#line 1528 "../lib/PositionManager.vala"
			_tmp29_ = self->priv->monitor_geo;
#line 1528 "../lib/PositionManager.vala"
			_tmp30_ = self->priv->monitor_geo;
#line 1528 "../lib/PositionManager.vala"
			(*struts)[PLANK_STRUTS_RIGHT_END] = (gulong) (((_tmp29_.y + _tmp30_.height) * self->priv->window_scale_factor) - 1);
#line 1529 "../lib/PositionManager.vala"
			break;
#line 5658 "PositionManager.c"
		}
	}
}

void
plank_position_manager_get_barrier (PlankPositionManager* self,
                                    GdkRectangle* result)
{
	GdkRectangle barrier = {0};
	GdkRectangle _tmp0_ = {0};
	GtkPositionType _tmp1_;
	gboolean _tmp16_ = FALSE;
	GdkRectangle _tmp17_;
#line 1534 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 1536 "../lib/PositionManager.vala"
	barrier = _tmp0_;
#line 1538 "../lib/PositionManager.vala"
	_tmp1_ = self->priv->_Position;
#line 1538 "../lib/PositionManager.vala"
	switch (_tmp1_) {
#line 5680 "PositionManager.c"
		default:
#line 1538 "../lib/PositionManager.vala"
		case GTK_POS_BOTTOM:
#line 5684 "PositionManager.c"
		{
			GdkRectangle _tmp2_;
			GdkRectangle _tmp3_;
			GdkRectangle _tmp4_;
			GdkRectangle _tmp5_;
#line 1541 "../lib/PositionManager.vala"
			_tmp2_ = self->priv->monitor_geo;
#line 1541 "../lib/PositionManager.vala"
			_tmp3_ = self->priv->monitor_geo;
#line 1541 "../lib/PositionManager.vala"
			barrier.x = _tmp2_.x + ((_tmp3_.width - self->priv->VisibleDockWidth) / 2);
#line 1542 "../lib/PositionManager.vala"
			_tmp4_ = self->priv->monitor_geo;
#line 1542 "../lib/PositionManager.vala"
			_tmp5_ = self->priv->monitor_geo;
#line 1542 "../lib/PositionManager.vala"
			barrier.y = _tmp4_.y + _tmp5_.height;
#line 1543 "../lib/PositionManager.vala"
			barrier.width = self->priv->VisibleDockWidth;
#line 1544 "../lib/PositionManager.vala"
			barrier.height = 0;
#line 1545 "../lib/PositionManager.vala"
			break;
#line 5708 "PositionManager.c"
		}
#line 1538 "../lib/PositionManager.vala"
		case GTK_POS_TOP:
#line 5712 "PositionManager.c"
		{
			GdkRectangle _tmp6_;
			GdkRectangle _tmp7_;
			GdkRectangle _tmp8_;
#line 1547 "../lib/PositionManager.vala"
			_tmp6_ = self->priv->monitor_geo;
#line 1547 "../lib/PositionManager.vala"
			_tmp7_ = self->priv->monitor_geo;
#line 1547 "../lib/PositionManager.vala"
			barrier.x = _tmp6_.x + ((_tmp7_.width - self->priv->VisibleDockWidth) / 2);
#line 1548 "../lib/PositionManager.vala"
			_tmp8_ = self->priv->monitor_geo;
#line 1548 "../lib/PositionManager.vala"
			barrier.y = _tmp8_.y;
#line 1549 "../lib/PositionManager.vala"
			barrier.width = self->priv->VisibleDockWidth;
#line 1550 "../lib/PositionManager.vala"
			barrier.height = 0;
#line 1551 "../lib/PositionManager.vala"
			break;
#line 5733 "PositionManager.c"
		}
#line 1538 "../lib/PositionManager.vala"
		case GTK_POS_LEFT:
#line 5737 "PositionManager.c"
		{
			GdkRectangle _tmp9_;
			GdkRectangle _tmp10_;
			GdkRectangle _tmp11_;
#line 1553 "../lib/PositionManager.vala"
			_tmp9_ = self->priv->monitor_geo;
#line 1553 "../lib/PositionManager.vala"
			barrier.x = _tmp9_.x;
#line 1554 "../lib/PositionManager.vala"
			_tmp10_ = self->priv->monitor_geo;
#line 1554 "../lib/PositionManager.vala"
			_tmp11_ = self->priv->monitor_geo;
#line 1554 "../lib/PositionManager.vala"
			barrier.y = _tmp10_.y + ((_tmp11_.height - self->priv->VisibleDockHeight) / 2);
#line 1555 "../lib/PositionManager.vala"
			barrier.width = 0;
#line 1556 "../lib/PositionManager.vala"
			barrier.height = self->priv->VisibleDockHeight;
#line 1557 "../lib/PositionManager.vala"
			break;
#line 5758 "PositionManager.c"
		}
#line 1538 "../lib/PositionManager.vala"
		case GTK_POS_RIGHT:
#line 5762 "PositionManager.c"
		{
			GdkRectangle _tmp12_;
			GdkRectangle _tmp13_;
			GdkRectangle _tmp14_;
			GdkRectangle _tmp15_;
#line 1559 "../lib/PositionManager.vala"
			_tmp12_ = self->priv->monitor_geo;
#line 1559 "../lib/PositionManager.vala"
			_tmp13_ = self->priv->monitor_geo;
#line 1559 "../lib/PositionManager.vala"
			barrier.x = _tmp12_.x + _tmp13_.width;
#line 1560 "../lib/PositionManager.vala"
			_tmp14_ = self->priv->monitor_geo;
#line 1560 "../lib/PositionManager.vala"
			_tmp15_ = self->priv->monitor_geo;
#line 1560 "../lib/PositionManager.vala"
			barrier.y = _tmp14_.y + ((_tmp15_.height - self->priv->VisibleDockHeight) / 2);
#line 1561 "../lib/PositionManager.vala"
			barrier.width = 0;
#line 1562 "../lib/PositionManager.vala"
			barrier.height = self->priv->VisibleDockHeight;
#line 1563 "../lib/PositionManager.vala"
			break;
#line 5786 "PositionManager.c"
		}
	}
#line 1566 "../lib/PositionManager.vala"
	_tmp17_ = barrier;
#line 1566 "../lib/PositionManager.vala"
	if (_tmp17_.width > 0) {
#line 1566 "../lib/PositionManager.vala"
		_tmp16_ = TRUE;
#line 5795 "PositionManager.c"
	} else {
		GdkRectangle _tmp18_;
#line 1566 "../lib/PositionManager.vala"
		_tmp18_ = barrier;
#line 1566 "../lib/PositionManager.vala"
		_tmp16_ = _tmp18_.height > 0;
#line 5802 "PositionManager.c"
	}
#line 1566 "../lib/PositionManager.vala"
	g_warn_if_fail (_tmp16_);
#line 1568 "../lib/PositionManager.vala"
	*result = barrier;
#line 1568 "../lib/PositionManager.vala"
	return;
#line 5810 "PositionManager.c"
}

static PlankDockController*
plank_position_manager_get_controller (PlankPositionManager* self)
{
	PlankDockController* result;
	PlankDockController* _tmp0_;
#line 27 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 27 "../lib/PositionManager.vala"
	result = _tmp0_;
#line 27 "../lib/PositionManager.vala"
	return result;
#line 5826 "PositionManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../lib/PositionManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 5834 "PositionManager.c"
}

static void
plank_position_manager_set_controller (PlankPositionManager* self,
                                       PlankDockController* value)
{
	PlankDockController* old_value;
#line 27 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 27 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_controller (self);
#line 27 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 5848 "PositionManager.c"
		PlankDockController* _tmp0_;
#line 27 "../lib/PositionManager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 27 "../lib/PositionManager.vala"
		_g_object_unref0 (self->priv->_controller);
#line 27 "../lib/PositionManager.vala"
		self->priv->_controller = _tmp0_;
#line 27 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY]);
#line 5858 "PositionManager.c"
	}
}

gboolean
plank_position_manager_get_screen_is_composited (PlankPositionManager* self)
{
	gboolean result;
#line 29 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../lib/PositionManager.vala"
	result = self->priv->_screen_is_composited;
#line 29 "../lib/PositionManager.vala"
	return result;
#line 5872 "PositionManager.c"
}

static void
plank_position_manager_set_screen_is_composited (PlankPositionManager* self,
                                                 gboolean value)
{
	gboolean old_value;
#line 29 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 29 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_screen_is_composited (self);
#line 29 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 29 "../lib/PositionManager.vala"
		self->priv->_screen_is_composited = value;
#line 29 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY]);
#line 5890 "PositionManager.c"
	}
}

gint
plank_position_manager_get_LineWidth (PlankPositionManager* self)
{
	gint result;
#line 171 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 171 "../lib/PositionManager.vala"
	result = self->priv->_LineWidth;
#line 171 "../lib/PositionManager.vala"
	return result;
#line 5904 "PositionManager.c"
}

static void
plank_position_manager_set_LineWidth (PlankPositionManager* self,
                                      gint value)
{
	gint old_value;
#line 171 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 171 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_LineWidth (self);
#line 171 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 171 "../lib/PositionManager.vala"
		self->priv->_LineWidth = value;
#line 171 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY]);
#line 5922 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IconSize (PlankPositionManager* self)
{
	gint result;
#line 176 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 176 "../lib/PositionManager.vala"
	result = self->priv->_IconSize;
#line 176 "../lib/PositionManager.vala"
	return result;
#line 5936 "PositionManager.c"
}

static void
plank_position_manager_set_IconSize (PlankPositionManager* self,
                                     gint value)
{
	gint old_value;
#line 176 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 176 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_IconSize (self);
#line 176 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 176 "../lib/PositionManager.vala"
		self->priv->_IconSize = value;
#line 176 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY]);
#line 5954 "PositionManager.c"
	}
}

gint
plank_position_manager_get_ZoomIconSize (PlankPositionManager* self)
{
	gint result;
#line 181 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 181 "../lib/PositionManager.vala"
	result = self->priv->_ZoomIconSize;
#line 181 "../lib/PositionManager.vala"
	return result;
#line 5968 "PositionManager.c"
}

static void
plank_position_manager_set_ZoomIconSize (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 181 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 181 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_ZoomIconSize (self);
#line 181 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 181 "../lib/PositionManager.vala"
		self->priv->_ZoomIconSize = value;
#line 181 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY]);
#line 5986 "PositionManager.c"
	}
}

GtkPositionType
plank_position_manager_get_Position (PlankPositionManager* self)
{
	GtkPositionType result;
#line 186 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 186 "../lib/PositionManager.vala"
	result = self->priv->_Position;
#line 186 "../lib/PositionManager.vala"
	return result;
#line 6000 "PositionManager.c"
}

static void
plank_position_manager_set_Position (PlankPositionManager* self,
                                     GtkPositionType value)
{
	GtkPositionType old_value;
#line 186 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 186 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_Position (self);
#line 186 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 186 "../lib/PositionManager.vala"
		self->priv->_Position = value;
#line 186 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_POSITION_PROPERTY]);
#line 6018 "PositionManager.c"
	}
}

GtkAlign
plank_position_manager_get_Alignment (PlankPositionManager* self)
{
	GtkAlign result;
#line 191 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 191 "../lib/PositionManager.vala"
	result = self->priv->_Alignment;
#line 191 "../lib/PositionManager.vala"
	return result;
#line 6032 "PositionManager.c"
}

static void
plank_position_manager_set_Alignment (PlankPositionManager* self,
                                      GtkAlign value)
{
	GtkAlign old_value;
#line 191 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 191 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_Alignment (self);
#line 191 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 191 "../lib/PositionManager.vala"
		self->priv->_Alignment = value;
#line 191 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY]);
#line 6050 "PositionManager.c"
	}
}

GtkAlign
plank_position_manager_get_ItemsAlignment (PlankPositionManager* self)
{
	GtkAlign result;
#line 196 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 196 "../lib/PositionManager.vala"
	result = self->priv->_ItemsAlignment;
#line 196 "../lib/PositionManager.vala"
	return result;
#line 6064 "PositionManager.c"
}

static void
plank_position_manager_set_ItemsAlignment (PlankPositionManager* self,
                                           GtkAlign value)
{
	GtkAlign old_value;
#line 196 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 196 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_ItemsAlignment (self);
#line 196 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 196 "../lib/PositionManager.vala"
		self->priv->_ItemsAlignment = value;
#line 196 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY]);
#line 6082 "PositionManager.c"
	}
}

gint
plank_position_manager_get_Offset (PlankPositionManager* self)
{
	gint result;
#line 201 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 201 "../lib/PositionManager.vala"
	result = self->priv->_Offset;
#line 201 "../lib/PositionManager.vala"
	return result;
#line 6096 "PositionManager.c"
}

static void
plank_position_manager_set_Offset (PlankPositionManager* self,
                                   gint value)
{
	gint old_value;
#line 201 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 201 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_Offset (self);
#line 201 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 201 "../lib/PositionManager.vala"
		self->priv->_Offset = value;
#line 201 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_OFFSET_PROPERTY]);
#line 6114 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IndicatorSize (PlankPositionManager* self)
{
	gint result;
#line 206 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 206 "../lib/PositionManager.vala"
	result = self->priv->_IndicatorSize;
#line 206 "../lib/PositionManager.vala"
	return result;
#line 6128 "PositionManager.c"
}

static void
plank_position_manager_set_IndicatorSize (PlankPositionManager* self,
                                          gint value)
{
	gint old_value;
#line 206 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 206 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_IndicatorSize (self);
#line 206 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 206 "../lib/PositionManager.vala"
		self->priv->_IndicatorSize = value;
#line 206 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY]);
#line 6146 "PositionManager.c"
	}
}

gint
plank_position_manager_get_IconShadowSize (PlankPositionManager* self)
{
	gint result;
#line 210 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 210 "../lib/PositionManager.vala"
	result = self->priv->_IconShadowSize;
#line 210 "../lib/PositionManager.vala"
	return result;
#line 6160 "PositionManager.c"
}

static void
plank_position_manager_set_IconShadowSize (PlankPositionManager* self,
                                           gint value)
{
	gint old_value;
#line 210 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 210 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_IconShadowSize (self);
#line 210 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 210 "../lib/PositionManager.vala"
		self->priv->_IconShadowSize = value;
#line 210 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY]);
#line 6178 "PositionManager.c"
	}
}

gint
plank_position_manager_get_GlowSize (PlankPositionManager* self)
{
	gint result;
#line 214 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 214 "../lib/PositionManager.vala"
	result = self->priv->_GlowSize;
#line 214 "../lib/PositionManager.vala"
	return result;
#line 6192 "PositionManager.c"
}

static void
plank_position_manager_set_GlowSize (PlankPositionManager* self,
                                     gint value)
{
	gint old_value;
#line 214 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 214 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_GlowSize (self);
#line 214 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 214 "../lib/PositionManager.vala"
		self->priv->_GlowSize = value;
#line 214 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY]);
#line 6210 "PositionManager.c"
	}
}

gint
plank_position_manager_get_HorizPadding (PlankPositionManager* self)
{
	gint result;
#line 218 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 218 "../lib/PositionManager.vala"
	result = self->priv->_HorizPadding;
#line 218 "../lib/PositionManager.vala"
	return result;
#line 6224 "PositionManager.c"
}

static void
plank_position_manager_set_HorizPadding (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 218 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 218 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_HorizPadding (self);
#line 218 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 218 "../lib/PositionManager.vala"
		self->priv->_HorizPadding = value;
#line 218 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY]);
#line 6242 "PositionManager.c"
	}
}

gint
plank_position_manager_get_TopPadding (PlankPositionManager* self)
{
	gint result;
#line 222 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 222 "../lib/PositionManager.vala"
	result = self->priv->_TopPadding;
#line 222 "../lib/PositionManager.vala"
	return result;
#line 6256 "PositionManager.c"
}

static void
plank_position_manager_set_TopPadding (PlankPositionManager* self,
                                       gint value)
{
	gint old_value;
#line 222 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 222 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_TopPadding (self);
#line 222 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 222 "../lib/PositionManager.vala"
		self->priv->_TopPadding = value;
#line 222 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY]);
#line 6274 "PositionManager.c"
	}
}

gint
plank_position_manager_get_BottomPadding (PlankPositionManager* self)
{
	gint result;
#line 226 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 226 "../lib/PositionManager.vala"
	result = self->priv->_BottomPadding;
#line 226 "../lib/PositionManager.vala"
	return result;
#line 6288 "PositionManager.c"
}

static void
plank_position_manager_set_BottomPadding (PlankPositionManager* self,
                                          gint value)
{
	gint old_value;
#line 226 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 226 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_BottomPadding (self);
#line 226 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 226 "../lib/PositionManager.vala"
		self->priv->_BottomPadding = value;
#line 226 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY]);
#line 6306 "PositionManager.c"
	}
}

gint
plank_position_manager_get_ItemPadding (PlankPositionManager* self)
{
	gint result;
#line 230 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 230 "../lib/PositionManager.vala"
	result = self->priv->_ItemPadding;
#line 230 "../lib/PositionManager.vala"
	return result;
#line 6320 "PositionManager.c"
}

static void
plank_position_manager_set_ItemPadding (PlankPositionManager* self,
                                        gint value)
{
	gint old_value;
#line 230 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 230 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_ItemPadding (self);
#line 230 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 230 "../lib/PositionManager.vala"
		self->priv->_ItemPadding = value;
#line 230 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY]);
#line 6338 "PositionManager.c"
	}
}

gint
plank_position_manager_get_UrgentBounceHeight (PlankPositionManager* self)
{
	gint result;
#line 234 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 234 "../lib/PositionManager.vala"
	result = self->priv->_UrgentBounceHeight;
#line 234 "../lib/PositionManager.vala"
	return result;
#line 6352 "PositionManager.c"
}

static void
plank_position_manager_set_UrgentBounceHeight (PlankPositionManager* self,
                                               gint value)
{
	gint old_value;
#line 234 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 234 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_UrgentBounceHeight (self);
#line 234 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 234 "../lib/PositionManager.vala"
		self->priv->_UrgentBounceHeight = value;
#line 234 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY]);
#line 6370 "PositionManager.c"
	}
}

gint
plank_position_manager_get_LaunchBounceHeight (PlankPositionManager* self)
{
	gint result;
#line 238 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 238 "../lib/PositionManager.vala"
	result = self->priv->_LaunchBounceHeight;
#line 238 "../lib/PositionManager.vala"
	return result;
#line 6384 "PositionManager.c"
}

static void
plank_position_manager_set_LaunchBounceHeight (PlankPositionManager* self,
                                               gint value)
{
	gint old_value;
#line 238 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 238 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_LaunchBounceHeight (self);
#line 238 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 238 "../lib/PositionManager.vala"
		self->priv->_LaunchBounceHeight = value;
#line 238 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY]);
#line 6402 "PositionManager.c"
	}
}

gint
plank_position_manager_get_MaxItemCount (PlankPositionManager* self)
{
	gint result;
#line 289 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 289 "../lib/PositionManager.vala"
	result = self->priv->_MaxItemCount;
#line 289 "../lib/PositionManager.vala"
	return result;
#line 6416 "PositionManager.c"
}

static void
plank_position_manager_set_MaxItemCount (PlankPositionManager* self,
                                         gint value)
{
	gint old_value;
#line 289 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 289 "../lib/PositionManager.vala"
	old_value = plank_position_manager_get_MaxItemCount (self);
#line 289 "../lib/PositionManager.vala"
	if (old_value != value) {
#line 289 "../lib/PositionManager.vala"
		self->priv->_MaxItemCount = value;
#line 289 "../lib/PositionManager.vala"
		g_object_notify_by_pspec ((GObject *) self, plank_position_manager_properties[PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY]);
#line 6434 "PositionManager.c"
	}
}

static gint
plank_position_manager_get_MaxIconSize (PlankPositionManager* self)
{
	gint result;
#line 295 "../lib/PositionManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 295 "../lib/PositionManager.vala"
	result = self->priv->_MaxIconSize;
#line 295 "../lib/PositionManager.vala"
	return result;
#line 6448 "PositionManager.c"
}

static void
plank_position_manager_set_MaxIconSize (PlankPositionManager* self,
                                        gint value)
{
#line 295 "../lib/PositionManager.vala"
	g_return_if_fail (self != NULL);
#line 295 "../lib/PositionManager.vala"
	self->priv->_MaxIconSize = value;
#line 6459 "PositionManager.c"
}

static GObject *
plank_position_manager_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PlankPositionManager * self;
	GdkRectangle _tmp0_ = {0};
	GeeHashMap* _tmp1_;
#line 48 "../lib/PositionManager.vala"
	parent_class = G_OBJECT_CLASS (plank_position_manager_parent_class);
#line 48 "../lib/PositionManager.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 48 "../lib/PositionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 50 "../lib/PositionManager.vala"
	self->priv->static_dock_region = _tmp0_;
#line 51 "../lib/PositionManager.vala"
	_tmp1_ = gee_hash_map_new (PLANK_TYPE_DOCK_ELEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, PLANK_TYPE_DOCK_ITEM_DRAW_VALUE, (GBoxedCopyFunc) plank_dock_item_draw_value_ref, (GDestroyNotify) plank_dock_item_draw_value_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 51 "../lib/PositionManager.vala"
	_g_object_unref0 (self->priv->draw_values);
#line 51 "../lib/PositionManager.vala"
	self->priv->draw_values = _tmp1_;
#line 48 "../lib/PositionManager.vala"
	return obj;
#line 6488 "PositionManager.c"
}

static void
plank_position_manager_class_init (PlankPositionManagerClass * klass,
                                   gpointer klass_data)
{
#line 25 "../lib/PositionManager.vala"
	plank_position_manager_parent_class = g_type_class_peek_parent (klass);
#line 25 "../lib/PositionManager.vala"
	g_type_class_adjust_private_offset (klass, &PlankPositionManager_private_offset);
#line 25 "../lib/PositionManager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_plank_position_manager_get_property;
#line 25 "../lib/PositionManager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_plank_position_manager_set_property;
#line 25 "../lib/PositionManager.vala"
	G_OBJECT_CLASS (klass)->constructor = plank_position_manager_constructor;
#line 25 "../lib/PositionManager.vala"
	G_OBJECT_CLASS (klass)->finalize = plank_position_manager_finalize;
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY] = g_param_spec_object ("controller", "controller", "controller", PLANK_TYPE_DOCK_CONTROLLER, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY] = g_param_spec_boolean ("screen-is-composited", "screen-is-composited", "screen-is-composited", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6511 "PositionManager.c"
	/**
	 * Theme-based line-width.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY] = g_param_spec_int ("LineWidth", "LineWidth", "LineWidth", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6517 "PositionManager.c"
	/**
	 * Cached current icon size for the dock.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY] = g_param_spec_int ("IconSize", "IconSize", "IconSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6523 "PositionManager.c"
	/**
	 * Cached current icon size for the dock.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY] = g_param_spec_int ("ZoomIconSize", "ZoomIconSize", "ZoomIconSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6529 "PositionManager.c"
	/**
	 * Cached position of the dock.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_POSITION_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_POSITION_PROPERTY] = g_param_spec_enum ("Position", "Position", "Position", gtk_position_type_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6535 "PositionManager.c"
	/**
	 * Cached alignment of the dock.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY] = g_param_spec_enum ("Alignment", "Alignment", "Alignment", gtk_align_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6541 "PositionManager.c"
	/**
	 * Cached alignment of the items.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY] = g_param_spec_enum ("ItemsAlignment", "ItemsAlignment", "ItemsAlignment", gtk_align_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6547 "PositionManager.c"
	/**
	 * Cached offset of the dock.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_OFFSET_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_OFFSET_PROPERTY] = g_param_spec_int ("Offset", "Offset", "Offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6553 "PositionManager.c"
	/**
	 * Theme-based indicator size, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY] = g_param_spec_int ("IndicatorSize", "IndicatorSize", "IndicatorSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6559 "PositionManager.c"
	/**
	 * Theme-based icon-shadow size, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY] = g_param_spec_int ("IconShadowSize", "IconShadowSize", "IconShadowSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6565 "PositionManager.c"
	/**
	 * Theme-based urgent glow size, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY] = g_param_spec_int ("GlowSize", "GlowSize", "GlowSize", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6571 "PositionManager.c"
	/**
	 * Theme-based horizontal padding, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY] = g_param_spec_int ("HorizPadding", "HorizPadding", "HorizPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6577 "PositionManager.c"
	/**
	 * Theme-based top padding, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY] = g_param_spec_int ("TopPadding", "TopPadding", "TopPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6583 "PositionManager.c"
	/**
	 * Theme-based bottom padding, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY] = g_param_spec_int ("BottomPadding", "BottomPadding", "BottomPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6589 "PositionManager.c"
	/**
	 * Theme-based item padding, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY] = g_param_spec_int ("ItemPadding", "ItemPadding", "ItemPadding", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6595 "PositionManager.c"
	/**
	 * Theme-based urgent-bounce height, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_int ("UrgentBounceHeight", "UrgentBounceHeight", "UrgentBounceHeight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6601 "PositionManager.c"
	/**
	 * Theme-based launch-bounce height, scaled by icon size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY] = g_param_spec_int ("LaunchBounceHeight", "LaunchBounceHeight", "LaunchBounceHeight", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6607 "PositionManager.c"
	/**
	 * The maximum item count which fit the dock in its maximum
	 * size with the current theme and icon-size.
	 */
#line 25 "../lib/PositionManager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY, plank_position_manager_properties[PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY] = g_param_spec_int ("MaxItemCount", "MaxItemCount", "MaxItemCount", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 6614 "PositionManager.c"
}

static void
plank_position_manager_instance_init (PlankPositionManager * self,
                                      gpointer klass)
{
#line 25 "../lib/PositionManager.vala"
	self->priv = plank_position_manager_get_instance_private (self);
#line 36 "../lib/PositionManager.vala"
	self->priv->window_scale_factor = 1;
#line 295 "../lib/PositionManager.vala"
	self->priv->_MaxIconSize = PLANK_DOCK_PREFERENCES_MAX_ICON_SIZE;
#line 6627 "PositionManager.c"
}

static void
plank_position_manager_finalize (GObject * obj)
{
	PlankPositionManager * self;
	GdkScreen* screen = NULL;
	PlankDockController* _tmp0_;
	PlankDockWindow* _tmp1_;
	PlankDockWindow* _tmp2_;
	GdkScreen* _tmp3_;
	GdkScreen* _tmp4_;
	guint _tmp5_;
	GdkScreen* _tmp6_;
	guint _tmp7_;
	GdkScreen* _tmp8_;
	guint _tmp9_;
	PlankDockController* _tmp10_;
	PlankDockPreferences* _tmp11_;
	PlankDockPreferences* _tmp12_;
	guint _tmp13_;
	GeeHashMap* _tmp14_;
#line 25 "../lib/PositionManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 75 "../lib/PositionManager.vala"
	_tmp0_ = self->priv->_controller;
#line 75 "../lib/PositionManager.vala"
	_tmp1_ = plank_dock_controller_get_window (_tmp0_);
#line 75 "../lib/PositionManager.vala"
	_tmp2_ = _tmp1_;
#line 75 "../lib/PositionManager.vala"
	_tmp3_ = gtk_window_get_screen ((GtkWindow*) _tmp2_);
#line 75 "../lib/PositionManager.vala"
	screen = _tmp3_;
#line 77 "../lib/PositionManager.vala"
	_tmp4_ = screen;
#line 77 "../lib/PositionManager.vala"
	g_signal_parse_name ("monitors-changed", gdk_screen_get_type (), &_tmp5_, NULL, FALSE);
#line 77 "../lib/PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _plank_position_manager_screen_changed_gdk_screen_monitors_changed, self);
#line 78 "../lib/PositionManager.vala"
	_tmp6_ = screen;
#line 78 "../lib/PositionManager.vala"
	g_signal_parse_name ("size-changed", gdk_screen_get_type (), &_tmp7_, NULL, FALSE);
#line 78 "../lib/PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _plank_position_manager_screen_changed_gdk_screen_size_changed, self);
#line 79 "../lib/PositionManager.vala"
	_tmp8_ = screen;
#line 79 "../lib/PositionManager.vala"
	g_signal_parse_name ("composited-changed", gdk_screen_get_type (), &_tmp9_, NULL, FALSE);
#line 79 "../lib/PositionManager.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _plank_position_manager_screen_composited_changed_gdk_screen_composited_changed, self);
#line 80 "../lib/PositionManager.vala"
	_tmp10_ = self->priv->_controller;
#line 80 "../lib/PositionManager.vala"
	_tmp11_ = plank_dock_controller_get_prefs (_tmp10_);
#line 80 "../lib/PositionManager.vala"
	_tmp12_ = _tmp11_;
#line 80 "../lib/PositionManager.vala"
	g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp13_, NULL, FALSE);
#line 80 "../lib/PositionManager.vala"
	g_signal_handlers_disconnect_matched ((GObject*) _tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _plank_position_manager_prefs_changed_g_object_notify, self);
#line 82 "../lib/PositionManager.vala"
	_tmp14_ = self->priv->draw_values;
#line 82 "../lib/PositionManager.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp14_);
#line 27 "../lib/PositionManager.vala"
	_g_object_unref0 (self->priv->_controller);
#line 32 "../lib/PositionManager.vala"
	_g_object_unref0 (self->priv->draw_values);
#line 25 "../lib/PositionManager.vala"
	G_OBJECT_CLASS (plank_position_manager_parent_class)->finalize (obj);
#line 6700 "PositionManager.c"
}

/**
 * Handles computing any size/position information for the dock.
 */
static GType
plank_position_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PlankPositionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plank_position_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PlankPositionManager), 0, (GInstanceInitFunc) plank_position_manager_instance_init, NULL };
	GType plank_position_manager_type_id;
	plank_position_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "PlankPositionManager", &g_define_type_info, 0);
	PlankPositionManager_private_offset = g_type_add_instance_private (plank_position_manager_type_id, sizeof (PlankPositionManagerPrivate));
	return plank_position_manager_type_id;
}

GType
plank_position_manager_get_type (void)
{
	static volatile gsize plank_position_manager_type_id__once = 0;
	if (g_once_init_enter (&plank_position_manager_type_id__once)) {
		GType plank_position_manager_type_id;
		plank_position_manager_type_id = plank_position_manager_get_type_once ();
		g_once_init_leave (&plank_position_manager_type_id__once, plank_position_manager_type_id);
	}
	return plank_position_manager_type_id__once;
}

static void
_vala_plank_position_manager_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	PlankPositionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 25 "../lib/PositionManager.vala"
	switch (property_id) {
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_object (value, plank_position_manager_get_controller (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_boolean (value, plank_position_manager_get_screen_is_composited (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_LineWidth (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IconSize (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_ZoomIconSize (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_POSITION_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_Position (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_Alignment (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_enum (value, plank_position_manager_get_ItemsAlignment (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_OFFSET_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_Offset (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IndicatorSize (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_IconShadowSize (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_GlowSize (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_HorizPadding (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_TopPadding (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_BottomPadding (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_ItemPadding (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_UrgentBounceHeight (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_LaunchBounceHeight (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		g_value_set_int (value, plank_position_manager_get_MaxItemCount (self));
#line 25 "../lib/PositionManager.vala"
		break;
#line 6852 "PositionManager.c"
		default:
#line 25 "../lib/PositionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/PositionManager.vala"
		break;
#line 6858 "PositionManager.c"
	}
}

static void
_vala_plank_position_manager_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	PlankPositionManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLANK_TYPE_POSITION_MANAGER, PlankPositionManager);
#line 25 "../lib/PositionManager.vala"
	switch (property_id) {
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_CONTROLLER_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_controller (self, g_value_get_object (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_SCREEN_IS_COMPOSITED_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_screen_is_composited (self, g_value_get_boolean (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_LINE_WIDTH_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_LineWidth (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_IconSize (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ZOOM_ICON_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_ZoomIconSize (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_POSITION_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_Position (self, g_value_get_enum (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ALIGNMENT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_Alignment (self, g_value_get_enum (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEMS_ALIGNMENT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_ItemsAlignment (self, g_value_get_enum (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_OFFSET_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_Offset (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_INDICATOR_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_IndicatorSize (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ICON_SHADOW_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_IconShadowSize (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_GLOW_SIZE_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_GlowSize (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_HORIZ_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_HorizPadding (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_TOP_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_TopPadding (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_BOTTOM_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_BottomPadding (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_ITEM_PADDING_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_ItemPadding (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_URGENT_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_UrgentBounceHeight (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_LAUNCH_BOUNCE_HEIGHT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_LaunchBounceHeight (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 25 "../lib/PositionManager.vala"
		case PLANK_POSITION_MANAGER_MAX_ITEM_COUNT_PROPERTY:
#line 25 "../lib/PositionManager.vala"
		plank_position_manager_set_MaxItemCount (self, g_value_get_int (value));
#line 25 "../lib/PositionManager.vala"
		break;
#line 6986 "PositionManager.c"
		default:
#line 25 "../lib/PositionManager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 25 "../lib/PositionManager.vala"
		break;
#line 6992 "PositionManager.c"
	}
}

